% Proof obligations of 

% MACHINE Cylinders

% Run check_cylinders

:- dec_p_type(cylinders_inv3_wd).
cylinders_inv3_wd :-
  dec(PositionsDG,sp) &
  dec([Door_cylinder_locked_p,Door_closed_p],rpb) &
  dec(Po,pos) &
  cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_cylinder_locked_p,{}) &
          pfun(Door_cylinder_locked_p) &
          (applyTo(Door_cylinder_locked_p,Po,true)
             implies
               ncomp({[Po,Po]},Door_closed_p,{}) &
               pfun(Door_closed_p)
          )
  ).

:- dec_p_type(cylinders_inv4_wd).
cylinders_inv4_wd :-
  dec(PositionsDG,sp) &
  dec([Door_cylinder_locked_p,Gear_ext_p,Gear_ret_p],rpb) &
  dec(Po,pos) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      gears_inv1(PositionsDG,Gear_ext_p) &
      gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_cylinder_locked_p,{}) &
          pfun(Door_cylinder_locked_p) &
          (applyTo(Door_cylinder_locked_p,Po,true)
             implies
               ncomp({[Po,Po]},Gear_ext_p,{}) &
               pfun(Gear_ext_p) &
               (applyTo(Gear_ext_p,Po,true)
                or
                ncomp({[Po,Po]},Gear_ret_p,{}) &
                pfun(Gear_ret_p)
               )
          )
  ).

:- dec_p_type(cylinders_inv5_wd).
cylinders_inv5_wd :-
  dec(PositionsDG,sp) &
  dec(Gear_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  dec(M,sb) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_cylinder_locked_p,{}) &
          pfun(Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinders_init_inv1).
cylinders_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,
       Door_open_p,
       Door_closed_p,Door_cylinder_locked_p,Gear_cylinder_locked_p],rpb) &
  cylinders_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p, 
    Gear_cylinder_locked_p
    ) &
  cylinders_inv1(PositionsDG,Door_cylinder_locked_p).

:- dec_p_type(cylinders_init_inv2).
cylinders_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,
       Door_open_p,
       Door_closed_p,Door_cylinder_locked_p,Gear_cylinder_locked_p],rpb) &
  cylinders_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p, 
    Gear_cylinder_locked_p
    ) &
  cylinders_inv2(PositionsDG,Gear_cylinder_locked_p).

:- dec_p_type(cylinders_init_inv3).
cylinders_init_inv3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,
       Door_open_p,
       Door_closed_p,Door_cylinder_locked_p,Gear_cylinder_locked_p],rpb) &
  cylinders_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p, 
    Gear_cylinder_locked_p
    ) &
  cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p).

:- dec_p_type(cylinders_init_inv4).
cylinders_init_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,
       Door_open_p,
       Door_closed_p,Door_cylinder_locked_p,Gear_cylinder_locked_p],rpb) &
  cylinders_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p, 
    Gear_cylinder_locked_p
    ) &
  cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p).

:- dec_p_type(cylinders_init_inv5).
cylinders_init_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,
       Door_open_p,
       Door_closed_p,Door_cylinder_locked_p,Gear_cylinder_locked_p],rpb) &
  cylinders_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p, 
    Gear_cylinder_locked_p
    ) &
  cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p).

:- dec_p_type(cylinder_start_GearExtend_grd4).
cylinder_start_GearExtend_grd4 :-
  dec(PositionsDG,sp) &
  dec(Gear_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_cylinder_locked_p,{}) &
          pfun(Gear_cylinder_locked_p)
  ).

:- dec_p_type(n_cylinders_inv4(sp,rpb,rpb,rpb)).
n_cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) :-
  neg(foreach(Po in PositionsDG,[M1,M2,M3],
        dec(Po,pos) & dec([M1,M2,M3],bool) &
        (M1 = true implies (M2 = true or M3 = true)),
        applyTo(Gear_cylinder_locked_p,Po,M1) &
        applyTo(Gear_ext_p,Po,M2) &
        applyTo(Gear_ret_p,Po,M3)
      )
  ).

:- dec_p_type(cylinders_start_GearExtend_inv4).
cylinders_start_GearExtend_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,Gear_cylinder_locked_p,Door_open_p,Gear_ret_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_start_GearExtend(
        PositionsDG,
        Gear_ret_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Gear_ret_p_
      )
        implies 
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p_,
            Gear_cylinder_locked_p
         )
  ).

:- dec_p_type(cylinders_make_GearExtended_inv4).
cylinders_make_GearExtended_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,Gear_ext_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_make_GearExtended(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_ext_p_
      )
        implies
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p_,
            Gear_ret_p,
            Gear_cylinder_locked_p
          )
  ).

:- dec_p_type(cylinder_start_GearRetract_grd3).
cylinder_start_GearRetract_grd3 :-
  dec(PositionsDG,sp) &
  dec(Gear_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_cylinder_locked_p,{}) &
          pfun(Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinders_start_GearRetract_inv4).
cylinders_start_GearRetract_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,Gear_cylinder_locked_p,Door_open_p,Gear_ext_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_start_GearRetract(
        PositionsDG,
        Gear_ext_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Gear_ext_p_
      )
        implies
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p_,
            Gear_ret_p,
            Gear_cylinder_locked_p
          )
  ).

:- dec_p_type(cylinders_make_GearRetracted_inv4).
cylinders_make_GearRetracted_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,Gear_ret_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_make_GearRetracted(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_ret_p_
      )
        implies
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p_,
            Gear_cylinder_locked_p
          )
  ).

:- dec_p_type(cylinder_start_DoorOpening_grd2).
cylinder_start_DoorOpening_grd2 :-
  dec(PositionsDG,sp) &
  dec(Door_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  dec(M,sb) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_cylinder_locked_p,{}) &
          pfun(Door_cylinder_locked_p)
  ).

:- dec_p_type(n_cylinders_inv3(sp,rpb,rpb)).
n_cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p) :-
  neg(foreach(Po in PositionsDG,[M1,M2],
        dec(Po,pos) & dec([M1,M2],bool) &
        (M1 = true implies M2 = true),
        applyTo(Door_cylinder_locked_p,Po,M1) &
        applyTo(Door_closed_p,Po,M2)
      )
  ).

:- dec_p_type(cylinders_start_DoorOpening_inv3).
cylinders_start_DoorOpening_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_closed_p_],rpb) &
  neg(cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p) &
      cylinders_start_DoorOpening(
        Door_closed_p,
        Door_cylinder_locked_p,
        Door_closed_p_
      )
        implies
          cylinders_inv3(PositionsDG,Door_closed_p_,Door_cylinder_locked_p)
  ).

:- dec_p_type(n_cylinders_inv5(sp,rpb,rpb)).
n_cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p) :-
  neg(foreach(Po in PositionsDG,[M],
        dec(Po,pos) & dec(M,bool) &
        (M = false implies Door_open_p = cp(PositionsDG,{true})),
        applyTo(Gear_cylinder_locked_p,Po,M)
      )
  ).

:- dec_p_type(cylinders_make_DoorOpen_inv5).
cylinders_make_DoorOpen_inv5 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Gear_cylinder_locked_p,Door_closed_p,Door_open_p_],rpb) &
  neg(cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p) &
      cylinders_make_DoorOpen(
        Door_open_p,
        Door_closed_p,
        Door_open_p_
      )
        implies
          cylinders_inv5(PositionsDG,Door_open_p_,Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinders_start_DoorClosing_inv5).
cylinders_start_DoorClosing_inv5 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,
       Gear_cylinder_locked_p,Gear_ext_p,Gear_ret_p,Door_open_p_],rpb) &
  neg(delay(
        cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p),
        false
      ) &
      cylinders_start_DoorClosing(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Door_open_p_
      )
        implies
          cylinders_inv5(PositionsDG,Door_open_p_,Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinders_make_DoorClosed_inv3).
cylinders_make_DoorClosed_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_open_p,Door_closed_p_],rpb) &
  neg(cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p) &
      cylinders_make_DoorClosed(
        Door_open_p,
        Door_closed_p,
        Door_closed_p_
      )
        implies
          cylinders_inv3(PositionsDG,Door_closed_p_,Door_cylinder_locked_p)
  ).

:- dec_p_type(cylinder_unlockGearCylinder_grd2).
cylinder_unlockGearCylinder_grd2 :-
  dec(PositionsDG,sp) &
  dec(Gear_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_cylinder_locked_p,{}) &
          pfun(Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinder_unlockGearCylinder_grd3).
cylinder_unlockGearCylinder_grd3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Po,pos) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p) &
          (applyTo(Gear_ext_p,Po,true)
           or
           ncomp({[Po,Po]},Gear_ret_p,{}) &
           pfun(Gear_ret_p)
          )
  ).

:- dec_p_type(n_cylinders_inv2(sp,rpb)).
n_cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) :-
  neg(pfun(Gear_cylinder_locked_p) &
      dompf(Gear_cylinder_locked_p,PositionsDG)
  ).

:- dec_p_type(cylinder_unlockGearCylinder_inv2).
cylinder_unlockGearCylinder_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,
       Door_open_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      cylinders_UnlockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
      )
        implies
          cylinders_inv2(PositionsDG,Gear_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_unlockGearCylinder_inv4).
cylinder_unlockGearCylinder_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,
       Door_open_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_UnlockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
      )
        implies
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p,
            Gear_cylinder_locked_p_
          )
  ).

:- dec_p_type(cylinder_unlockGearCylinder_inv5).
cylinder_unlockGearCylinder_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,
       Door_open_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p) &
      cylinders_UnlockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Door_open_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
       )
         implies
           cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_lockGearCylinder_grd2).
cylinder_lockGearCylinder_grd2 :-
  dec(PositionsDG,sp) &
  dec(Gear_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  dec(M,sb) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_cylinder_locked_p,{}) &
          pfun(Gear_cylinder_locked_p)
  ).

:- dec_p_type(cylinder_lockGearCylinder_grd3).
cylinder_lockGearCylinder_grd3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Po,pos) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p) &
          (applyTo(Gear_ext_p,Po,true)
           or
           ncomp({[Po,Po]},Gear_ret_p,{}) &
           pfun(Gear_ret_p)
          )
  ).

:- dec_p_type(cylinder_lockGearCylinder_inv2).
cylinder_lockGearCylinder_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_ret_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
      cylinders_LockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
      )
        implies
          cylinders_inv2(PositionsDG,Gear_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_lockGearCylinder_inv4).
cylinder_lockGearCylinder_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,
       Door_closed_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv4(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p) &
      cylinders_LockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
      )
        implies
          cylinders_inv4(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p,
            Gear_cylinder_locked_p_
          )
  ).

:- dec_p_type(cylinder_lockGearCylinder_inv5).
cylinder_lockGearCylinder_inv5 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,
       Gear_ext_p,
       Gear_ret_p,Gear_cylinder_locked_p,Gear_cylinder_locked_p_],rpb) &
  neg(cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p) &
      cylinders_LockGearCylinder(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_cylinder_locked_p,
        Gear_cylinder_locked_p_
      )
        implies
          cylinders_inv5(PositionsDG,Door_open_p,Gear_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_unlockDoorCylinder_grd2).
cylinder_unlockDoorCylinder_grd2 :-
  dec(PositionsDG,sp) &
  dec(Door_closed_p,rpb) &
  dec(Po,pos) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_closed_p,{}) &
          pfun(Door_closed_p)
  ).

:- dec_p_type(cylinder_unlockDoorCylinder_grd3).
cylinder_unlockDoorCylinder_grd3 :-
  dec(PositionsDG,sp) &
  dec(Door_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_cylinder_locked_p,{}) &
          pfun(Door_cylinder_locked_p)
  ).

:- dec_p_type(n_cylinders_inv1(sp,rpb)).
n_cylinders_inv1(PositionsDG,Door_cylinder_locked_p) :-
  neg(pfun(Door_cylinder_locked_p) &
      dompf(Door_cylinder_locked_p,PositionsDG)
  ).

:- dec_p_type(cylinder_unlockDoorCylinder_inv1).
cylinder_unlockDoorCylinder_inv1 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      cylinders_UnlockDoorCylinder(
        PositionsDG,
        Door_closed_p,
        Door_cylinder_locked_p,
        Door_cylinder_locked_p_
      )
        implies
          cylinders_inv1(PositionsDG,Door_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_unlockDoorCylinder_inv3).
cylinder_unlockDoorCylinder_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  neg(cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p) &
      cylinders_UnlockDoorCylinder(
        PositionsDG,
        Door_closed_p,
        Door_cylinder_locked_p,
        Door_cylinder_locked_p_
      )
        implies
          cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_lockDoorCylinder_grd2).
cylinder_lockDoorCylinder_grd2 :-
  dec(PositionsDG,sp) &
  dec(Door_cylinder_locked_p,rpb) &
  dec(Po,pos) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_cylinder_locked_p,{}) &
          pfun(Door_cylinder_locked_p)
  ).

:- dec_p_type(cylinder_lockDoorCylinder_grd3).
cylinder_lockDoorCylinder_grd3 :-
  dec(PositionsDG,sp) &
  dec(Door_closed_p,rpb) &
  dec(Po,pos) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_closed_p,{}) &
          pfun(Door_closed_p)
  ).

:- dec_p_type(cylinder_lockDoorCylinder_inv1).
cylinder_lockDoorCylinder_inv1 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  neg(cylinders_inv1(PositionsDG,Door_cylinder_locked_p) &
      cylinders_LockDoorCylinder(
        PositionsDG,
        Door_closed_p,
        Door_cylinder_locked_p,
        Door_cylinder_locked_p_
      )
        implies
          cylinders_inv1(PositionsDG,Door_cylinder_locked_p_)
  ).

:- dec_p_type(cylinder_lockDoorCylinder_inv3).
cylinder_lockDoorCylinder_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  neg(cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p) &
      cylinders_LockDoorCylinder(
        PositionsDG,
        Door_closed_p,
        Door_cylinder_locked_p,
        Door_cylinder_locked_p_
      )
        implies
          cylinders_inv3(PositionsDG,Door_closed_p,Door_cylinder_locked_p_)
  ).

% consult('lgs.pl') & lCylindersPO.
:- dec_p_type(check_cylinders).
check_cylinders :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking cylinders_inv3_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_inv3_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_inv4_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_inv4_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_inv5_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_inv5_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     cylinders_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     cylinders_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_init_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     cylinders_init_inv3 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_init_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     cylinders_init_inv4 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_init_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     cylinders_init_inv5 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_start_GearExtend_grd4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_start_GearExtend_grd4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_start_GearExtend_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_start_GearExtend_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_make_GearExtended_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_make_GearExtended_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_start_GearRetract_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_start_GearRetract_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_start_GearRetract_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_start_GearRetract_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_make_GearRetracted_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_make_GearRetracted_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_start_DoorOpening_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_start_DoorOpening_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_start_DoorOpening_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_start_DoorOpening_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_make_DoorOpen_inv5...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_make_DoorOpen_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_start_DoorClosing_inv5...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_start_DoorClosing_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinders_make_DoorClosed_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinders_make_DoorClosed_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockGearCylinder_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockGearCylinder_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockGearCylinder_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockGearCylinder_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockGearCylinder_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockGearCylinder_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockGearCylinder_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockGearCylinder_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockGearCylinder_inv5...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockGearCylinder_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockGearCylinder_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockGearCylinder_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockGearCylinder_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockGearCylinder_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockGearCylinder_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockGearCylinder_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockGearCylinder_inv4...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockGearCylinder_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockGearCylinder_inv5...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockGearCylinder_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockDoorCylinder_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockDoorCylinder_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockDoorCylinder_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockDoorCylinder_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockDoorCylinder_inv1...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockDoorCylinder_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_unlockDoorCylinder_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_unlockDoorCylinder_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockDoorCylinder_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockDoorCylinder_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockDoorCylinder_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockDoorCylinder_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockDoorCylinder_inv1...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockDoorCylinder_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking cylinder_lockDoorCylinder_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(cylinder_lockDoorCylinder_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 37) discharged in ') &
     write(T) & write(' seconds') & nl
  ).

