% Proof obligations of 

% MACHINE Doors

% Run check_doors

:- dec_p_type(doors_inv2_wd).
doors_inv2_wd :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Po,pos) &
  dec(M,sb) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p) &
          (applyTo(Gear_ext_p,Po,false)
             implies
               ncomp({[Po,Po]},Gear_ret_p,{}) &
               pfun(Gear_ret_p)
          )
  ).

:- dec_p_type(doors_init_inv1).
doors_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p],rpb) &
  doors_init(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
  doors_inv1(PositionsDG,Door_open_p).

:- dec_p_type(doors_init_inv2).
doors_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p],rpb) &
  doors_init(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
  doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p).

:- dec_p_type(n_doors_inv2(sp,rpb,rpb,rpb)).
n_doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) :-
  neg(exists(Po in PositionsDG,
        dec(Po,pos) &
        applyTo(Gear_ext_p,Po,false) &
        applyTo(Gear_ret_p,Po,false)
      )
        implies
          Door_open_p = cp(PositionsDG,{true})
  ).

:- dec_p_type(doors_start_GearExtend_inv2).
doors_start_GearExtend_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_ret_p_],rpb) &
  neg(doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
      doors_start_GearExtend(PositionsDG,Gear_ret_p,Door_open_p,Gear_ret_p_)
        implies
          doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p_,Door_open_p)
  ).

:- dec_p_type(doors_make_GearExtended_inv2).
doors_make_GearExtended_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_ext_p_],rpb) &
  neg(doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
      doors_make_GearExtended(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_ext_p_)
        implies
          doors_inv2(PositionsDG,Gear_ext_p_,Gear_ret_p,Door_open_p)
  ).

:- dec_p_type(doors_start_GearRetract_inv2).
doors_start_GearRetract_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_ext_p_],rpb) &
  neg(doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
      doors_start_GearRetract(PositionsDG,Gear_ext_p,Door_open_p,Gear_ext_p_)
        implies
          doors_inv2(PositionsDG,Gear_ext_p_,Gear_ret_p,Door_open_p)
  ).

:- dec_p_type(doors_make_GearRetracted_inv2).
doors_make_GearRetracted_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_ret_p_],rpb) &
  neg(doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
      doors_make_GearRetracted(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_ret_p_)
        implies
          doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p_,Door_open_p)
  ).

:- dec_p_type(doors_make_DoorOpen_grd1).
doors_make_DoorOpen_grd1 :-
  dec(PositionsDG,sp) &
  dec(Door_open_p,rpb) &
  dec(Po,pos) &
  neg(doors_inv1(PositionsDG,Door_open_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_open_p,{}) &
          pfun(Door_open_p)
  ).

:- dec_p_type(n_doors_inv1(sp,rpb)).
n_doors_inv1(PositionsDG,Door_open_p) :-
  neg(pfun(Door_open_p) &
      dompf(Door_open_p,PositionsDG)
  ).

:- dec_p_type(doors_make_DoorOpen_inv1).
doors_make_DoorOpen_inv1 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_open_p_],rpb) &
  neg(doors_inv1(PositionsDG,Door_open_p) &
      doors_make_DoorOpen(Door_open_p,Door_open_p_)
        implies
          doors_inv1(PositionsDG,Door_open_p_)
  ).

:- dec_p_type(doors_make_DoorOpen_inv2).
doors_make_DoorOpen_inv2 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Gear_ext_p,Gear_ret_p,Door_open_p_],rpb) &
  neg(doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) &
      doors_make_DoorOpen(Door_open_p,Door_open_p_)
        implies
          doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p_)
  ).


% consult('lgs.pl') & lDoorsPO.
:- dec_p_type(check_doors).
check_doors :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking doors_inv2_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_inv2_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     doors_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     doors_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_start_GearExtend_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_start_GearExtend_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_make_GearExtended_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_make_GearExtended_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_start_GearRetract_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_start_GearRetract_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_make_GearRetracted_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_make_GearRetracted_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_make_DoorOpen_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_make_DoorOpen_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_make_DoorOpen_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_make_DoorOpen_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doors_make_DoorOpen_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doors_make_DoorOpen_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) & 
     write(' proof obligations (out of 10) discharged in ') &
     write(T) & write(' seconds') & nl
  ).


