% MACHINE DoorsIntermediate

:- dec_p_type(doorsIntermediate_inv1(sp,rpb)).
doorsIntermediate_inv1(PositionsDG,Door_closed_p) :-
  pfun(Door_closed_p) &
  dompf(Door_closed_p,PositionsDG).

:- dec_p_type(doorsIntermediate_inv2(sp,rpb,rpb)).
doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) :-
  foreach(Po in PositionsDG,[M1,M2],
    dec(Po,pos) & dec([M1,M2],bool) &
    neg(M1 = true & M2 = true),
    applyTo(Door_open_p,Po,M1) &
    applyTo(Door_closed_p,Po,M2)
  ).

:- dec_p_type(doorsIntermediate_init(sp,rpb,rpb,rpb,rpb)).
doorsIntermediate_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p
    ) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}) &
  Door_closed_p = cp(PositionsDG,{true}).

:- dec_p_type(doorsIntermediate_start_GearExtend(sp,rpb,rpb,rpb)).
doorsIntermediate_start_GearExtend(
    PositionsDG,
    Gear_ret_p,
    Door_open_p,
    Gear_ret_p_
    ) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_).

:- dec_p_type(doorsIntermediate_make_GearExtended(sp,rpb,rpb,rpb)).
doorsIntermediate_make_GearExtended(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_ext_p_
    ) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_).

:- dec_p_type(doorsIntermediate_start_GearRetract(sp,rpb,rpb,rpb)).
doorsIntermediate_start_GearRetract(
    PositionsDG,
    Gear_ext_p,
    Door_open_p,
    Gear_ext_p_
    ) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  foplus(Gear_ext_p,Po,false,Gear_ext_p_).

:- dec_p_type(doorsIntermediate_make_GearRetracted(sp,rpb,rpb,rpb)).
doorsIntermediate_make_GearRetracted(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_ret_p_
    ) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_).

:- dec_p_type(doorsIntermediate_start_DoorOpening(rpb,rpb)).
doorsIntermediate_start_DoorOpening(
    Door_closed_p,
    Door_closed_p_
    ) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,true) &
  foplus(Door_closed_p,Po,false,Door_closed_p_).

:- dec_p_type(doorsIntermediate_make_DoorOpen(rpb,rpb,rpb)).
doorsIntermediate_make_DoorOpen(
    Door_open_p,
    Door_closed_p,
    Door_open_p_
    ) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  applyTo(Door_closed_p,Po,false) &
  foplus(Door_open_p,Po,true,Door_open_p_).

:- dec_p_type(doorsIntermediate_start_DoorClosing(sp,rpb,rpb,rpb,rpb)).
doorsIntermediate_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_open_p_
    ) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  foplus(Door_open_p,Po,false,Door_open_p_).

:- dec_p_type(doorsIntermediate_make_DoorClosed(rpb,rpb,rpb)).
doorsIntermediate_make_DoorClosed(
    Door_open_p,
    Door_closed_p,
    Door_closed_p_
    ) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,false) &
  applyTo(Door_open_p,Po,false) &
  foplus(Door_closed_p,Po,true,Door_closed_p_).


