% MACHINE Failures

:- dec_p_type(failures_inv1(bool)).
failures_inv1(Analogical_switch_fail) :-
  Analogical_switch_fail in {false,true}.

:- dec_p_type(failures_inv2(bool,bool,bool,bool,bool)).
failures_inv2(
    General_EV_fail,
    Open_EV_fail,
    Close_EV_fail,
    Extend_EV_fail,
    Retract_EV_fail
  ) :-
  General_EV_fail in {false,true} &
  Open_EV_fail in {false,true} &
  Close_EV_fail in {false,true} &
  Extend_EV_fail in {false,true} &
  Retract_EV_fail in {false,true}.

:- dec_p_type(failures_inv3(sp,rpb,rpb)).
failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) :-
  pfun(Door_cylinder_fail) &
  dompf(Door_cylinder_fail,PositionsDG) &
  pfun(Gear_cylinder_fail) &
  dompf(Gear_cylinder_fail,PositionsDG).

:- dec_p_type(failures_inv4(bool)).
failures_inv4(Anomaly) :-
  Anomaly in {false,true}.

:- dec_p_type(failures_inv5(int)).
failures_inv5(NextInputReadForOpenSwitch) :-
  0 =< NextInputReadForOpenSwitch.

:- dec_p_type(failures_inv6(int)).
failures_inv6(NextInputReadForClosedSwitch) :-
  0 =< NextInputReadForClosedSwitch.

:- dec_p_type(failures_inv7(int)).
failures_inv7(NextInputReadForPressurizedcircuit) :-
  0 =< NextInputReadForPressurizedcircuit.

:- dec_p_type(failures_inv8(int)).
failures_inv8(NextInputReadForDoorOpeningClosing) :-
  0 =< NextInputReadForDoorOpeningClosing.

:- dec_p_type(failures_inv9(int)).
failures_inv9(NextInputReadForGearStartExtendingRetracting) :-
  0 =< NextInputReadForGearStartExtendingRetracting.

:- dec_p_type(failures_inv10(int)).
failures_inv10(NextInputReadForGearEndExtendingRetracting) :-
  0 =< NextInputReadForGearEndExtendingRetracting.

:- dec_p_type(failures_inv11(int)).
failures_inv11(Unchanged20s) :-
  0 =< Unchanged20s.

:- dec_p_type(
    failures_init(
      sp,rpb,rpb,rpb,rpb,rpb,rpb,bool,rpb,posh,poss,bool,bool,bool,bool,bool,
      bool,bool,bool,bool,bool,bool,posh,poss,bool,bool,bool,bool,bool,bool,
      rpb,rpb,rpb,rpb,rpb,bool,bool,bool,int,int,int,int,rpi,rpi,rpi,int,rpi,
      int,int,int,int,int,bool,bool,bool,bool,bool,bool,rpb,rpb,bool,int,int,
      int,int,int,int,int)).
failures_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    General_EV_p,
    Open_EV_p,
    Close_EV_p,
    Extend_EV_p,
    Retract_EV_p,
    GreenLight_p,
    OrangeLight_p,
    RedLight_p,
    Handle_ind,
    Analogical_switch_ind,
    Circuit_pressurized_ind,
    General_EV,
    Open_EV,
    Close_EV,
    Extend_EV,
    Retract_EV,
    Gear_extended_ind,
    Gear_shock_absorber_ind,
    Gear_retracted_ind,
    Door_closed_ind,
    Door_open_ind,
    Gears_locked_down,
    Gears_maneuvering,
    End_cycle,
    CurrentTime,
    DeadlineSwitch,
    DeadlineStimulationGeneralEv,
    DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,
    DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,
    DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,
    AllowedStopGeneralEv,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStartExtEv,
    AllowedStartRetEv,
    Analogical_switch_fail,
    General_EV_fail,
    Open_EV_fail,
    Close_EV_fail,
    Extend_EV_fail,
    Retract_EV_fail,
    Door_cylinder_fail,
    Gear_cylinder_fail,
    Anomaly,
    NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,
    NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,
    Unchanged20s
) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}) &
  Door_closed_p = cp(PositionsDG,{true}) &
  Door_cylinder_locked_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = false &
  Gear_shock_absorber_p = cp(PositionsDG,{true}) &
  Handle_p = down &
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = false &
  General_EV_p = false &
  Open_EV_p = false &
  Close_EV_p = false &
  Extend_EV_p = false &
  Retract_EV_p = false &
  GreenLight_p = true &
  OrangeLight_p = false &
  RedLight_p = false &
  Gear_extended_ind = cp(PositionsDG,{true}) &
  Gear_shock_absorber_ind = cp(PositionsDG,{true}) &
  Gear_retracted_ind = cp(PositionsDG,{false}) &
  Door_closed_ind = cp(PositionsDG,{true}) &
  Door_open_ind = cp(PositionsDG,{false}) &
  General_EV = false &
  Open_EV = false &
  Close_EV = false &
  Extend_EV = false &
  Retract_EV = false &
  Handle_ind = down &
  Analogical_switch_ind = open &
  Circuit_pressurized_ind = false &
  Gears_locked_down = true &
  Gears_maneuvering = false &
  End_cycle = true &
  CurrentTime = 0 &
  DeadlineSwitch = 0 &
  DeadlineStimulationGeneralEv = 0 &
  DeadlineStimulationOpenCloseEv = 0 &
  DeadlineUnlockLockDoorsCylinders = cp(PositionsDG,{0}) &
  DeadlineUnlockLockGearsCylinders = cp(PositionsDG,{0}) &
  DeadlineOpenCloseDoors = cp(PositionsDG,{0}) &
  DeadlineGearsRetractingExtending = cp(PositionsDG,{0}) &
  DeadlineStimulationRetExtEv = 0 &
  AllowedStopGeneralEv = 0 &
  AllowedStartOpenEv = 0 &
  AllowedStartCloseEv = 0 &
  AllowedStartExtEv = 0 &
  AllowedStartRetEv = 0 &
  Analogical_switch_fail = false &
  General_EV_fail = false &
  Open_EV_fail = false &
  Close_EV_fail = false &
  Extend_EV_fail = false &
  Retract_EV_fail = false &
  Door_cylinder_fail = cp(PositionsDG,{false}) &
  Gear_cylinder_fail = cp(PositionsDG,{false}) &
  Anomaly = false &
  NextInputReadForOpenSwitch = 0 &
  NextInputReadForClosedSwitch = 0 &
  NextInputReadForPressurizedcircuit = 0 &
  NextInputReadForDoorOpeningClosing = 0 &
  NextInputReadForGearStartExtendingRetracting = 0 &
  NextInputReadForGearEndExtendingRetracting = 0 &
  Unchanged20s = 0.

:- dec_p_type(
     failures_start_GearExtend(
       sp,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi)).
failures_start_GearExtend(
    PositionsDG,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Extend_EV_p,
    Retract_EV_p,
    Circuit_pressurized_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_ret_p_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = false &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,M1,DeadlineGearsRetractingExtending_
  ) &
    applyTo({[front,M2],[left,M3],[right,16]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16.

:- dec_p_type(
     failures_make_GearExtended(
       sp,rpb,bool,bool,bool,rpb,int,rpi,rpi,rpb,rpi,rpi)).
failures_make_GearExtended(
    PositionsDG,
    Gear_ext_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ret_p,
    CurrentTime,
    DeadlineGearsRetractingExtending,
    DeadlineUnlockLockGearsCylinders,
    Gear_ext_p_,
    DeadlineGearsRetractingExtending_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  dec(M,int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineGearsRetractingExtending,Po,CurrentTime) &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,0,DeadlineGearsRetractingExtending_
  ) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,M,DeadlineUnlockLockGearsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     failures_start_GearRetract(
       sp,rpb,rpb,rpb,bool,bool,bool,rpb,rpb,int,rpi,rpi,rpb,rpi)).
failures_start_GearRetract(
    PositionsDG,
    Gear_ext_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ext_p_,
    Gear_shock_absorber_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_shock_absorber_p_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Gear_ext_p,Po,false,Gear_ext_p_) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_) &
  foplus(
     DeadlineGearsRetractingExtending,Po,M1,DeadlineGearsRetractingExtending_
  ) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 16 &
    M3 is CurrentTime + 20.
    
:- dec_p_type(
     failures_make_GearRetracted(
       sp,rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi,rpi)).
failures_make_GearRetracted(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_ret_p_,
    DeadlineUnlockLockGearsCylinders_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec(M,int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineGearsRetractingExtending,front,CurrentTime) &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,0,DeadlineGearsRetractingExtending_
  ) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,M,DeadlineUnlockLockGearsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     failures_start_DoorOpening(rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi)).
failures_start_DoorOpening(
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,
    Door_closed_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Door_closed_p,Po,false,Door_closed_p_) &
  foplus(
     DeadlineOpenCloseDoors,Po,M1,DeadlineOpenCloseDoors_
  ) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 15.

:- dec_p_type(
     failures_make_DoorOpen(rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_make_DoorOpen(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    Door_open_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  applyTo(Door_closed_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineOpenCloseDoors,Po,CurrentTime) &
  foplus(Door_open_p,Po,true,Door_open_p_) &
  foplus(DeadlineOpenCloseDoors,Po,0,DeadlineOpenCloseDoors_).

:- dec_p_type(
     failures_start_DoorClosing(
       sp,rpb,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    Door_open_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  foplus(Door_open_p,Po,false,Door_open_p_) &
  foplus(DeadlineOpenCloseDoors,Po,M1,DeadlineOpenCloseDoors_) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16.

:- dec_p_type(
     failures_make_DoorClosed(
       rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi,rpi)).
failures_make_DoorClosed(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    DeadlineUnlockLockDoorsCylinders,
    Door_closed_p_,
    DeadlineOpenCloseDoors_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  dec(M,int) &
  applyTo(Door_closed_p,Po,false) &
  applyTo(Door_open_p,Po,false) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  applyTo(DeadlineOpenCloseDoors,Po,CurrentTime) &
  foplus(Door_closed_p,Po,true,Door_closed_p_) &
  foplus(DeadlineOpenCloseDoors,Po,0,DeadlineOpenCloseDoors_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,M,DeadlineUnlockLockDoorsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     failures_LockGearCylinder(
       sp,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_LockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    Gear_cylinder_locked_p_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Extend_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Retract_EV_p = true
  ) &
  applyTo(DeadlineUnlockLockGearsCylinders,front,CurrentTime) &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,0,DeadlineUnlockLockGearsCylinders_
  ).

:- dec_p_type(
     failures_UnlockDoorCylinder(sp,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_UnlockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockDoorsCylinders,
    Door_cylinder_locked_p_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,true) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineUnlockLockDoorsCylinders,Po,CurrentTime) &
  foplus(Door_cylinder_locked_p,Po,false,Door_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,0,DeadlineUnlockLockDoorsCylinders_
  ).

:- dec_p_type(
     failures_LockDoorCylinder(sp,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_LockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockDoorsCylinders,
    Door_cylinder_locked_p_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_cylinder_locked_p,Po,false) &
  applyTo(Door_closed_p,Po,true) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  applyTo(DeadlineUnlockLockDoorsCylinders,Po,CurrentTime) &
  foplus(Door_cylinder_locked_p,Po,true,Door_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,0,DeadlineUnlockLockDoorsCylinders_
  ).

:- dec_p_type(
     failures_UnlockGearCylinder(
       sp,rpb,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
failures_UnlockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    Gear_cylinder_locked_p_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,true) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Door_open_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Retract_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Extend_EV_p = true
  ) &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,CurrentTime) &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,0,DeadlineUnlockLockGearsCylinders_
  ).

:- dec_p_type(failures_Pressurize_HydrolicCircuit(bool,bool,bool)).
failures_Pressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = false &
  General_EV_p = true &
  Circuit_pressurized_p_ = true.

:- dec_p_type(failures_Unpressurize_HydrolicCircuit(bool,bool,bool)).
failures_Unpressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = true &
  General_EV_p = false &
  Circuit_pressurized_p_ = false.

:- dec_p_type(failures_MakeGearShockAbsorberFalse(sp,rpb,rpb)).
failures_MakeGearShockAbsorberFalse(
    PositionsDG,
    Gear_shock_absorber_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,true) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(failures_MakeGearShockAbsorberTRUE(sp,rpb,rpb,posh,bool,rpb)).
failures_MakeGearShockAbsorberTRUE(
    PositionsDG,
    Gear_ext_p,
    Gear_shock_absorber_p,
    Handle_p,
    GreenLight_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,false) &
  applyTo(Gear_ext_p,Po,true) &
  Handle_p = down &
  GreenLight_p = true &
  foplus(Gear_shock_absorber_p,Po,true,Gear_shock_absorber_p_).

:- dec_p_type(failures_MakeGeneralValveActive(bool,bool,int,int,bool,int)).
failures_MakeGeneralValveActive(
    General_EV_p,
    General_EV,
    CurrentTime,
    DeadlineStimulationGeneralEv,
    General_EV_p_,
    DeadlineStimulationGeneralEv_
) :-
  General_EV_p = false &
  General_EV = true &
  CurrentTime = DeadlineStimulationGeneralEv &
  General_EV_p_ = true &
  DeadlineStimulationGeneralEv_ is CurrentTime + 10.

:- dec_p_type(
     failures_MakeGeneralValveNoActive(bool,bool,int,int,bool,bool,int)).
failures_MakeGeneralValveNoActive(
    General_EV_p,
    General_EV,
    CurrentTime,
    DeadlineStimulationGeneralEv,
    General_EV_fail,
    General_EV_p_,
    DeadlineStimulationGeneralEv_
) :-
  General_EV_p = true &
  General_EV = false &
  CurrentTime = DeadlineStimulationGeneralEv &
  General_EV_fail = false &
  General_EV_p_ = false &
  DeadlineStimulationGeneralEv_ = 0.


:- dec_p_type(
     failures_MakeOpenDoorValveActive(sp,bool,bool,bool,int,bool,bool,int,rpi)).
failures_MakeOpenDoorValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Open_EV_p,
    Open_EV,
    CurrentTime,
    Open_EV_fail,
    Open_EV_p_,
    DeadlineStimulationOpenCloseEv_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(M,int) &
  Open_EV_p = false &
  Circuit_pressurized_p = true &
  Open_EV = true &
  Open_EV_fail = false &
  Open_EV_p_ = true &
  DeadlineStimulationOpenCloseEv_ = 0 &
  DeadlineUnlockLockDoorsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     failures_MakeOpenDoorValveNoActive(bool,bool,int,int,bool,bool,int)).
failures_MakeOpenDoorValveNoActive(
    Open_EV_p,
    Open_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Open_EV_fail,
    Open_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Open_EV_p = true &
  Open_EV = false &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Open_EV_fail = false &
  Open_EV_p_ = false &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     failures_MakeCloseDoorValveActive(bool,bool,bool,int,int,bool,bool,int)).
failures_MakeCloseDoorValveActive(
    Circuit_pressurized_p,
    Close_EV_p,
    Close_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Close_EV_fail,
    Close_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Close_EV_p = false &
  Circuit_pressurized_p = true &
  Close_EV = true &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Close_EV_fail = false &
  Close_EV_p_ = true &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     failures_MakeCloseDoorValveNoActive(bool,bool,int,int,bool,bool,int)).
failures_MakeCloseDoorValveNoActive(
    Close_EV_p,
    Close_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Close_EV_fail,
    Close_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Close_EV_p = true &
  Close_EV = false &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Close_EV_fail = false &
  Close_EV_p_ = false &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     failures_MakeExtendGearValveActive(
       sp,bool,bool,bool,int,int,bool,bool,int,rpi)).
failures_MakeExtendGearValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Extend_EV_p,
    Extend_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Extend_EV_fail,
    Extend_EV_p_,
    DeadlineStimulationRetExtEv_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(M,int) &
  Extend_EV_p = false &
  Circuit_pressurized_p = true &
  Extend_EV = true &
  CurrentTime = DeadlineStimulationRetExtEv &
  Extend_EV_fail = false &
  Extend_EV_p_ = true &
  DeadlineStimulationRetExtEv_ = 0 &
  DeadlineUnlockLockGearsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     failures_MakeExtendGearValveNoActive(bool,bool,int,int,bool,bool,int)).
failures_MakeExtendGearValveNoActive(
    Extend_EV_p,
    Extend_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Extend_EV_fail,
    Extend_EV_p_,
    DeadlineStimulationRetExtEv_
) :-
  Extend_EV_p = true &
  Extend_EV = false &
  CurrentTime = DeadlineStimulationRetExtEv &
  Extend_EV_fail = false &
  Extend_EV_p_ = false &
  DeadlineStimulationRetExtEv_ = 0.
  
:- dec_p_type(
     failures_MakeRetractGearValveActive(
       sp,bool,bool,bool,int,int,bool,bool,int,rpi)).
failures_MakeRetractGearValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Retract_EV_p,
    Retract_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Retract_EV_fail,
    Retract_EV_p_,
    DeadlineStimulationRetExtEv_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(M,int) &
  Retract_EV_p = false &
  Circuit_pressurized_p = true &
  Retract_EV = true &
  CurrentTime = DeadlineStimulationRetExtEv &
  Retract_EV_fail = false &
  Retract_EV_p_ = true &
  DeadlineStimulationRetExtEv_ = 0 &
  DeadlineUnlockLockGearsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     failures_MakeRetractGearValveNoActive(bool,bool,int,int,bool,bool,int)).
failures_MakeRetractGearValveNoActive(
    Retract_EV_p,
    Retract_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Retract_EV_fail,
    Retract_EV_p_,
    DeadlineStimulationRetExtEv_
) :-
  Retract_EV_p = true &
  Retract_EV = false &
  CurrentTime = DeadlineStimulationRetExtEv &
  Retract_EV_fail = false &
  Retract_EV_p_ = false &
  DeadlineStimulationRetExtEv_ = 0.
  
:- dec_p_type(failures_PutHandleUp(posh,posh,bool)).
failures_PutHandleUp(
    Handle_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = down &
  Handle_p_ = up &
  Handle_ = true.

:- dec_p_type(failures_PutHandleDown(posh,bool,posh,bool)).
failures_PutHandleDown(
    Handle_p,
    GreenLight_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = up &
  GreenLight_p = false &
  Handle_p_ = down &
  Handle_ = true.

:- dec_p_type(failures_close_Switch(bool,int,int,bool,poss,bool,int)).
failures_close_Switch(
    Intermediate1,
    CurrentTime,
    DeadlineSwitch,
    Analogical_switch_fail,
    Analogical_switch_p_,
    Intermediate1_,
    DeadlineSwitch_
) :-
  Intermediate1 = true &
  CurrentTime = DeadlineSwitch &
  Analogical_switch_fail = false &
  Analogical_switch_p_ = closed &
  Intermediate1_ = false &
  DeadlineSwitch_ is CurrentTime + 200.

:- dec_p_type(failures_HandleOnClosed(poss,bool,int,bool,int)).
failures_HandleOnClosed(
    Analogical_switch_p,
    Handle,
    CurrentTime,
    Handle_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = closed &
  Handle = true &
  Handle_ = false &
  DeadlineSwitch_ is CurrentTime + 200.

:- dec_p_type(
     failures_FromCloseToIntermediate2(poss,int,int,bool,poss,bool,int)).
failures_FromCloseToIntermediate2(
    Analogical_switch_p,
    CurrentTime,
    DeadlineSwitch,
    Analogical_switch_fail,
    Analogical_switch_p_,
    Intermediate2_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = closed &
  DeadlineSwitch = CurrentTime &
  Analogical_switch_fail = false &
  Intermediate2_ = true &
  Analogical_switch_p_ = open &
  DeadlineSwitch_ is CurrentTime + 12.

:- dec_p_type(
     failures_HandleFromOpenToIntermediate1(
       poss,bool,bool,bool,int,bool,bool,bool,int)).
failures_HandleFromOpenToIntermediate1(
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    CurrentTime,
    Analogical_switch_fail,
    Intermediate1_,
    Handle_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = true &
  Analogical_switch_fail = false &
  Intermediate1_ = true &
  Handle_ = false &
  DeadlineSwitch_ is CurrentTime + 8.

:- dec_p_type(
     failures_HandleFromIntermediate2ToIntermediate1(
       bool,bool,int,int,bool,bool,bool,bool,int)).
failures_HandleFromIntermediate2ToIntermediate1(
    Intermediate2,
    Handle,
    CurrentTime,
    DeadlineSwitch,
    Analogical_switch_fail,
    Intermediate1_,
    Intermediate2_,
    Handle_,
    DeadlineSwitch_
) :-
  dec([M1,M2],int) &
  Intermediate2 = true &
  Handle = true &
  Analogical_switch_fail = false &
  Handle_ = false &
  Intermediate2_ = false &
  Intermediate1_ = true &
  M1 = M2 &
    M1 is 3*DeadlineSwitch_ &
    M2 is 3*CurrentTime + (3*8 - 2*(DeadlineSwitch - CurrentTime)).
%  DeadlineSwitch_ = 
%    CurrentTime + (8 - ( 2 rdiv 3) * (DeadlineSwitch - CurrentTime)).

:- dec_p_type(
     failures_ReadHandleSwitchCircuit(
       sph,sps,bool,posh,bool,int,bool,int,int,int,int,posh,poss,bool,bool,int,
       bool,int,int)).
failures_ReadHandleSwitchCircuit(
    PositionsHandle,
    PositionsSwitch,
    General_EV,
    Handle_ind,
    Circuit_pressurized_ind,
    CurrentTime,
    Anomaly,
    NextInputReadForOpenSwitch,
    NextInputReadForPressurizedcircuit,
    NextInputReadForClosedSwitch,
    Unchanged20s,
    Handle_ind_,
    Analogical_switch_ind_,
    Circuit_pressurized_ind_,
    End_cycle_,
    NextInputReadForOpenSwitch_,
    Anomaly_,
    Unchanged20s_,
    NextInputReadForClosedSwitch_
) :-
  dec(Handle_sensor_value,posh) &
  dec(Analogical_switch_sensor_value,poss) &
  dec(Circuit_pressurized_sensor_value,bool) &
  dec([M1,M2],int) &
  dec([B1,B2,B3],bool) &
  Handle_sensor_value in PositionsHandle &
  Analogical_switch_sensor_value in PositionsSwitch &
  Anomaly = false &
  Handle_ind_ = Handle_sensor_value &
  Analogical_switch_ind_ = Analogical_switch_sensor_value &
  Circuit_pressurized_ind_ = Circuit_pressurized_sensor_value &
  End_cycle_ = false &
  bool(B1,Handle_ind neq Handle_sensor_value) &
  apply(
    {[false,NextInputReadForOpenSwitch],[true,M1]},
    B1,
    NextInputReadForOpenSwitch_
  ) &
    M1 is CurrentTime + 10 &
  bool(
    Anomaly_,
    CurrentTime = NextInputReadForOpenSwitch &
    Analogical_switch_sensor_value neq closed
    or
    CurrentTime = NextInputReadForPressurizedcircuit &
    General_EV neq Circuit_pressurized_ind
    or
    CurrentTime = NextInputReadForClosedSwitch &
    Analogical_switch_sensor_value neq open
  ) &
  bool(B2,Handle_sensor_value neq Handle_ind) &
  apply({[true,M2],[false,Unchanged20s]},B2,Unchanged20s_) &
    M2 is CurrentTime + 20 &
  bool(B3,CurrentTime = Unchanged20s) &
  apply({[true,15],[false,0]},B3,NextInputReadForClosedSwitch_).

:- dec_p_type(
     failures_ReadGearsShock(
       rpb,rpb,rpb,rpb,bool,bool,int,bool,int,int,rpb,rpb,rpb,bool,bool,bool,
       bool,int,int)).
failures_ReadGearsShock(
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Gear_shock_absorber_p,
    Extend_EV,
    Retract_EV,
    CurrentTime,
    Anomaly,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,
    Gear_extended_ind_,
    Gear_retracted_ind_,
    Gear_shock_absorber_ind_,
    Gears_locked_down_,
    Gears_maneuvering_,
    End_cycle_,
    Anomaly_,
    NextInputReadForGearStartExtendingRetracting_,
    NextInputReadForGearEndExtendingRetracting_
) :-
  dec([Gear_extended_sensor_valueF,Gear_extended_sensor_valueL,
       Gear_extended_sensor_valueR,Gear_retracted_sensor_valueF,
       Gear_retracted_sensor_valueL,Gear_retracted_sensor_valueR,
       Gear_shock_absorber_sensor_valueF,Gear_shock_absorber_sensor_valueL,
       Gear_shock_absorber_sensor_valueR,B1,B2],bool) &
delay(
  (Gear_extended_sensor_valueF = true
     implies
       applyTo(Gear_ext_p,front,true) &
       applyTo(Gear_cylinder_locked_p,front,true)
  ) &
  (Gear_extended_sensor_valueL = true
     implies
       applyTo(Gear_ext_p,left,true) &
       applyTo(Gear_cylinder_locked_p,left,true)
  ) &
  (Gear_extended_sensor_valueR = true
     implies
       applyTo(Gear_ext_p,right,true) &
       applyTo(Gear_cylinder_locked_p,right,true)
  ) &
  (Gear_retracted_sensor_valueF = true
     implies
       applyTo(Gear_ret_p,front,true) &
       applyTo(Gear_cylinder_locked_p,front,true)
  ) &
  (Gear_retracted_sensor_valueL = true
     implies
       applyTo(Gear_ret_p,left,true) &
       applyTo(Gear_cylinder_locked_p,left,true)
  ) &
  (Gear_retracted_sensor_valueR = true
     implies
       applyTo(Gear_ret_p,right,true) &
       applyTo(Gear_cylinder_locked_p,right,true)
  ) &
  (Gear_shock_absorber_sensor_valueF = false
     implies
       applyTo(Gear_shock_absorber_p,front,false)
  ) &
  (Gear_shock_absorber_sensor_valueL = false
     implies
       applyTo(Gear_shock_absorber_p,left,false)
  ) &
  Anomaly = false &
  Gear_extended_ind_ = 
    {[front,Gear_extended_sensor_valueF],
     [left,Gear_extended_sensor_valueL],
     [right,Gear_extended_sensor_valueR]} &
  Gear_retracted_ind_ = 
    {[front,Gear_retracted_sensor_valueF],
     [left,Gear_retracted_sensor_valueL],
     [right,Gear_retracted_sensor_valueR]} &
  Gear_shock_absorber_ind_ = 
    {[front,Gear_shock_absorber_sensor_valueF],
     [left,Gear_shock_absorber_sensor_valueL],
     [right,Gear_shock_absorber_sensor_valueR]} &
  bool(
    Gears_locked_down_,
    Gear_extended_sensor_valueF = true &
    Gear_extended_sensor_valueL = true &
    Gear_extended_sensor_valueR = true
  ) &
  bool(
    Gears_maneuvering_,
    Gear_extended_sensor_valueF = false &
    Gear_retracted_sensor_valueF = false
    or
    Gear_extended_sensor_valueL = false &
    Gear_retracted_sensor_valueL = false
    or
    Gear_extended_sensor_valueR = false &
    Gear_retracted_sensor_valueR = false
  ) &
  End_cycle_ = false &
  bool(
    Anomaly_,
    CurrentTime >= NextInputReadForGearStartExtendingRetracting &
    (Extend_EV = true &
     (Gear_retracted_sensor_valueF = true
      or
      Gear_retracted_sensor_valueL = true
      or
      Gear_retracted_sensor_valueR = true
     )
     or
     Retract_EV = true &
     (Gear_extended_sensor_valueF = true
      or
      Gear_extended_sensor_valueL = true
      or
      Gear_extended_sensor_valueR = true
     )
    )
    or
    CurrentTime >= NextInputReadForGearEndExtendingRetracting &
    (Extend_EV = true &
     (Gear_extended_sensor_valueF = false
      or
      Gear_extended_sensor_valueL = false
      or
      Gear_extended_sensor_valueR = false
     )
     or
     Retract_EV = true &
     (Gear_retracted_sensor_valueF = false
      or
      Gear_retracted_sensor_valueL = false
      or
      Gear_retracted_sensor_valueR = false
     )
    )
  )  ,false) &
  bool(B1,CurrentTime = NextInputReadForGearEndExtendingRetracting) &
  applyTo(
    {[true,0],[false,NextInputReadForGearEndExtendingRetracting]},
    B1,
    NextInputReadForGearEndExtendingRetracting_
  ) &
  bool(B2,CurrentTime = NextInputReadForGearStartExtendingRetracting) &
  applyTo(
    {[true,0],[false,NextInputReadForGearStartExtendingRetracting]},
    B2,
    NextInputReadForGearStartExtendingRetracting_
  ).

:- dec_p_type(
     failures_ReadDoors(
       rpb,rpb,bool,bool,int,bool,int,rpb,rpb,bool,bool,int)).
failures_ReadDoors(
    Door_open_p,
    Door_closed_p,
    Open_EV,
    Close_EV,
    CurrentTime,
    Anomaly,
    NextInputReadForDoorOpeningClosing,
    Door_open_ind_,
    Door_closed_ind_,
    End_cycle_,
    Anomaly_,
    NextInputReadForDoorOpeningClosing_
) :-
  dec([Door_open_sensor_valueF,Door_open_sensor_valueL,Door_open_sensor_valueR,
       Door_closed_sensor_valueF,Door_closed_sensor_valueL,
       Door_closed_sensor_valueR,B1],bool) &
  (Door_open_sensor_valueF = true implies applyTo(Door_open_p,front,true)) &
  (Door_open_sensor_valueL = true implies applyTo(Door_open_p,left,true)) &
  (Door_open_sensor_valueR = true implies applyTo(Door_open_p,right,true)) &
  (Door_closed_sensor_valueF = true implies applyTo(Door_closed_p,front,true)) &
  (Door_closed_sensor_valueL = true implies applyTo(Door_closed_p,left,true)) &
  (Door_closed_sensor_valueR = true implies applyTo(Door_closed_p,right,true)) &
  Anomaly = false &
  Door_open_ind_ = 
    {[front,Door_open_sensor_valueF],
     [left,Door_open_sensor_valueL],
     [right,Door_open_sensor_valueR]} &
  Door_closed_ind_ = 
    {[front,Door_closed_sensor_valueF],
     [left,Door_closed_sensor_valueL],
     [right,Door_closed_sensor_valueR]} &
  End_cycle_ = false &
  bool(
    Anomaly_,
    CurrentTime >= NextInputReadForDoorOpeningClosing &
    Open_EV = true &
    (Door_open_sensor_valueF = false
     or
     Door_open_sensor_valueL = false
     or
     Door_open_sensor_valueR = false
    )
    or
    CurrentTime >= NextInputReadForDoorOpeningClosing &
    Close_EV = true &
    (Door_closed_sensor_valueF = false
     or
     Door_closed_sensor_valueL = false
     or
     Door_closed_sensor_valueR = false
    )
  ) &
  bool(B1,CurrentTime = NextInputReadForDoorOpeningClosing) &
  applyTo(
    {[true,0],[false,NextInputReadForDoorOpeningClosing]},
    B1,
    NextInputReadForDoorOpeningClosing_
  ).


:- dec_p_type(failures_open_Switch(bool,bool,int)).
failures_open_Switch(
    Intermediate2,
    Intermediate2_,
    DeadlineSwitch_
) :-
  Intermediate2 = true &
  Intermediate2_ = false &
  DeadlineSwitch_ = 0.

:- dec_p_type(failures_MakeGreenLightActive(bool,bool,bool)).
failures_MakeGreenLightActive(
    GreenLight_p,
    Gears_locked_down,
    GreenLight_p_
) :-
  GreenLight_p = false &
  Gears_locked_down = true &
  GreenLight_p_ = true.
  
:- dec_p_type(failures_MakeGreenLightNoActive(bool,bool,bool)).
failures_MakeGreenLightNoActive(
    GreenLight_p,
    Gears_locked_down,
    GreenLight_p_
) :-
  GreenLight_p = true &
  Gears_locked_down = false &
  GreenLight_p_ = false.
  
:- dec_p_type(failures_MakeOrangeLightActive(bool,bool,bool)).
failures_MakeOrangeLightActive(
    OrangeLight_p,
    Gears_maneuvering,
    OrangeLight_p_
) :-
  OrangeLight_p = false &
  Gears_maneuvering = true &
  OrangeLight_p_ = true.
  
:- dec_p_type(failures_MakeOrangeLightNoActive(bool,bool,bool)).
failures_MakeOrangeLightNoActive(
    OrangeLight_p,
    Gears_maneuvering,
    OrangeLight_p_
) :-
  OrangeLight_p = true &
  Gears_maneuvering neq true &
  OrangeLight_p_ = false.
  
:- dec_p_type(failures_MakeRedLightActive(bool,bool)).
failures_MakeRedLightActive(
    RedLight_p,
    RedLight_p_
) :-
  RedLight_p = false &
  RedLight_p_ = true.
  
:- dec_p_type(
     failures_OutputGEV(
       sp,poss,posh,rpb,rpb,bool,bool,bool,int,int,int,rpb,bool,bool,int,int,
       int)).
failures_OutputGEV(
    PositionsDG,
    Analogical_switch_ind,
    Handle_ind,
    Gear_extended_ind,
    Gear_retracted_ind,
    Open_EV,
    Close_EV,
    General_EV,
    CurrentTime,
    AllowedStopGeneralEv,
    AllowedStartOpenEv,
    Door_closed_ind,
    General_EV_,
    End_cycle_,
    DeadlineStimulationGeneralEv_,
    AllowedStartOpenEv_,
    NextInputReadForPressurizedcircuit_
) :-
  dec(General_EV_value,bool) &
  dec([M1,M2,M3,M4,M5],int) &
  bool(
    General_EV_value,
    Analogical_switch_ind = closed &
    (Handle_ind = down & 
     Gear_extended_ind neq cp(PositionsDG,{true})
     or
     Handle_ind = up &
     Gear_retracted_ind neq cp(PositionsDG,{true})
    )
    or
    Door_closed_ind neq cp(PositionsDG,{true})
    or
    Open_EV = true 
    or
    Close_EV = true
  ) &
  General_EV_value neq General_EV &
  CurrentTime >= AllowedStopGeneralEv &
  General_EV_ = General_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M1],[[true,false],M2]},
    [General_EV,General_EV_value],
    DeadlineStimulationGeneralEv_
  ) &
    M1 is CurrentTime + 10 &
    M2 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M3],[[true,false],AllowedStartOpenEv]},
    [General_EV,General_EV_value],
    AllowedStartOpenEv_
  ) &
    M3 is CurrentTime + 2 &
  applyTo(
    {[[false,true],M4],[[true,false],M5]},
    [General_EV,General_EV_value],
    NextInputReadForPressurizedcircuit_
  ) &
    M4 is CurrentTime + 20 &
    M5 is CurrentTime + 100.


:- dec_p_type(
    failures_OutputOpenEV(
      sp,bool,bool,bool,bool,bool,posh,rpb,rpb,int,int,int,int,bool,bool,int,
      int,int,int)).
failures_OutputOpenEV(
    PositionsDG,
    Close_EV,
    Open_EV,
    General_EV,
    Extend_EV,
    Retract_EV,
    Handle_ind,
    Gear_retracted_ind,
    Gear_extended_ind,
    CurrentTime,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStopGeneralEv,
    Open_EV_,
    End_cycle_,
    AllowedStartCloseEv_,
    DeadlineStimulationOpenCloseEv_,
    AllowedStopGeneralEv_,
    NextInputReadForDoorOpeningClosing_
) :-
  dec(Open_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Open_EV_value,
    Close_EV = false &
    General_EV = true &
    (Handle_ind = up &
     Gear_retracted_ind neq cp(PositionsDG,{true})
     or
     Handle_ind = down &
     Gear_extended_ind neq cp(PositionsDG,{true})
    )
    or
    Extend_EV = true 
    or
    Retract_EV = true
  ) &
  Open_EV neq Open_EV_value &
  CurrentTime >= AllowedStartOpenEv &
  Open_EV_ = Open_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartCloseEv]},
    [Open_EV,Open_EV_value],
    AllowedStartCloseEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Open_EV,Open_EV_value],
    DeadlineStimulationOpenCloseEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Open_EV,Open_EV_value],
    AllowedStopGeneralEv_
  ) &
  NextInputReadForDoorOpeningClosing_ = CurrentTime + 70.

:- dec_p_type(
     failures_OutputCloseEv(
       sp,posh,rpb,rpb,rpb,bool,bool,bool,bool,bool,int,int,int,int,bool,bool,
       int,int,int,int)).
failures_OutputCloseEv(
    PositionsDG,
    Handle_ind,
    Gear_retracted_ind,
    Gear_extended_ind,
    Door_closed_ind,
    General_EV,
    Extend_EV,
    Retract_EV,
    Open_EV,
    Close_EV,
    CurrentTime,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStopGeneralEv,
    Close_EV_,
    End_cycle_,
    AllowedStartOpenEv_,
    DeadlineStimulationOpenCloseEv_,
    AllowedStopGeneralEv_,
    NextInputReadForDoorOpeningClosing_
) :-
  dec(Close_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Close_EV_value,
    (Handle_ind = up &
     Gear_retracted_ind = cp(PositionsDG,{true})
     or
     Handle_ind = down &
     Gear_extended_ind = cp(PositionsDG,{true})
    ) &
    Door_closed_ind neq cp(PositionsDG,{true}) &
    General_EV = true &
    Extend_EV = false &
    Retract_EV = false &
    Open_EV = false
  ) &
  Close_EV neq Close_EV_value &
  CurrentTime >= AllowedStartCloseEv &
  Close_EV_ = Close_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Close_EV,Close_EV_value],
    DeadlineStimulationOpenCloseEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartOpenEv]},
    [Close_EV,Close_EV_value],
    AllowedStartOpenEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Close_EV,Close_EV_value],
    AllowedStopGeneralEv_
  ) &
  NextInputReadForDoorOpeningClosing_ = CurrentTime + 70.

:- dec_p_type(
     failures_OutputExtendEV(
       sp,posh,rpb,rpb,bool,bool,bool,int,int,int,int,bool,bool,int,int,int,
       int,int)).
failures_OutputExtendEV(
    PositionsDG,
    Handle_ind,
    Gear_extended_ind,
    Door_open_ind,
    Open_EV,
    Retract_EV,
    Extend_EV,
    CurrentTime,
    AllowedStartExtEv,
    AllowedStartRetEv,
    AllowedStopGeneralEv,
    Extend_EV_,
    End_cycle_,
    DeadlineStimulationRetExtEv_,
    AllowedStartRetEv_,
    AllowedStopGeneralEv_,
    NextInputReadForGearStartExtendingRetracting_,
    NextInputReadForGearEndExtendingRetracting_
) :-
  dec(Extend_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Extend_EV_value,
    Handle_ind = down &
    Gear_extended_ind neq cp(PositionsDG,{true}) &
    Open_EV = true &
    Door_open_ind = cp(PositionsDG,{true}) &
    Retract_EV = false
  ) &
  Extend_EV neq Extend_EV_value &
  CurrentTime >= AllowedStartExtEv &
  Extend_EV_ = Extend_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Extend_EV,Extend_EV_value],
    DeadlineStimulationRetExtEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartRetEv]},
    [Extend_EV,Extend_EV_value],
    AllowedStartRetEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Extend_EV,Extend_EV_value],
    AllowedStopGeneralEv_
  ) &
  NextInputReadForGearStartExtendingRetracting_ = CurrentTime + 70 &
  NextInputReadForGearEndExtendingRetracting_ = CurrentTime + 100.

:- dec_p_type(
     failures_OutputRetractEV(
       sp,posh,rpb,rpb,rpb,bool,bool,bool,int,int,int,int,bool,bool,int,int,
       int,int,int)).
failures_OutputRetractEV(
    PositionsDG,
    Handle_ind,
    Gear_retracted_ind,
    Door_open_ind,
    Gear_shock_absorber_ind,
    Open_EV,
    Extend_EV,
    Retract_EV,
    CurrentTime,
    AllowedStartExtEv,
    AllowedStartRetEv,
    AllowedStopGeneralEv,
    Retract_EV_,
    End_cycle_,
    DeadlineStimulationRetExtEv_,
    AllowedStartExtEv_,
    AllowedStopGeneralEv_,
    NextInputReadForGearStartExtendingRetracting_,
    NextInputReadForGearEndExtendingRetracting_
) :-
  dec(Retract_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Retract_EV_value,
    Handle_ind = up &
    Gear_retracted_ind neq cp(PositionsDG,{true}) &
    Open_EV = true &
    Extend_EV = false &
    Door_open_ind = cp(PositionsDG,{true}) &
    Gear_shock_absorber_ind = cp(PositionsDG,{false})
  ) &
  Retract_EV neq Retract_EV_value &
  CurrentTime >= AllowedStartRetEv &
  Retract_EV_ = Retract_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Retract_EV,Retract_EV_value],
    DeadlineStimulationRetExtEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartExtEv]},
    [Retract_EV,Retract_EV_value],
    AllowedStartExtEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Retract_EV,Retract_EV_value],
    AllowedStopGeneralEv_
  ) &
  NextInputReadForGearStartExtendingRetracting_ = CurrentTime + 70 &
  NextInputReadForGearEndExtendingRetracting_ = CurrentTime + 100.

:- dec_p_type(
     failures_passingTime(
       int,int,int,int,rpi,rpi,rpi,rpi,int,int,int,int,int,int,int,int)).
failures_passingTime(
    DeadlineSwitch,
    DeadlineStimulationGeneralEv,
    DeadlineStimulationOpenCloseEv,
    DeadlineStimulationRetExtEv,
    DeadlineOpenCloseDoors,
    DeadlineUnlockLockDoorsCylinders,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    CurrentTime,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,
    NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForClosedSwitch,
    NextInputReadForOpenSwitch,
    CurrentTime_    
) :-
  dec(Step,int) &
  dec(M1,rpi) &
  dec(M2,stype(int)) &
  dec(M3,int) &
  0 < Step &
delay(
  (DeadlineSwitch neq 0
   or
   DeadlineStimulationGeneralEv neq 0
   or
   DeadlineStimulationOpenCloseEv neq 0
   or
   DeadlineStimulationRetExtEv neq 0
   or
   nran(DeadlineOpenCloseDoors,{0})
   or
   nran(DeadlineUnlockLockDoorsCylinders,{0})
   or
   nran(DeadlineUnlockLockGearsCylinders,{0})
   or
   nran(DeadlineGearsRetractingExtending,{0})
  ) &
  (DeadlineSwitch = 0 implies CurrentTime + Step =< DeadlineSwitch) &
  (DeadlineStimulationGeneralEv neq 0 
     implies 
       CurrentTime + Step =< DeadlineStimulationGeneralEv
  ) &
  (DeadlineStimulationOpenCloseEv neq 0
     implies
       CurrentTime + Step =< DeadlineStimulationOpenCloseEv
  ) &
  (DeadlineStimulationRetExtEv neq 0
     implies
       CurrentTime + Step =< DeadlineStimulationRetExtEv
  ) &
  (nran(DeadlineOpenCloseDoors,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineOpenCloseDoors,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineUnlockLockDoorsCylinders,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineUnlockLockDoorsCylinders,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineUnlockLockGearsCylinders,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineUnlockLockGearsCylinders,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineGearsRetractingExtending,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineGearsRetractingExtending,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  )
,false) &
  (NextInputReadForGearStartExtendingRetracting neq 0
   or
   NextInputReadForGearEndExtendingRetracting neq 0
  ) &
  (NextInputReadForPressurizedcircuit neq 0
     implies
       CurrentTime + Step =< NextInputReadForPressurizedcircuit
  ) &
  (NextInputReadForDoorOpeningClosing neq 0
     implies
       CurrentTime + Step =< NextInputReadForDoorOpeningClosing
  ) &
  (NextInputReadForGearStartExtendingRetracting neq 0
     implies
       CurrentTime + Step =< NextInputReadForGearStartExtendingRetracting
  ) &
  (NextInputReadForGearEndExtendingRetracting neq 0
     implies
       CurrentTime + Step =< NextInputReadForGearEndExtendingRetracting
  ) &
  (NextInputReadForClosedSwitch neq 0
     implies
       CurrentTime + Step =< NextInputReadForClosedSwitch
  ) &
  (NextInputReadForOpenSwitch neq 0
     implies
       CurrentTime + Step =< NextInputReadForOpenSwitch
  ) &
  CurrentTime_ is CurrentTime + Step.

:- dec_p_type(failures_MakeGeneralEVFail(bool,bool)).
failures_MakeGeneralEVFail(General_EV_fail,General_EV_fail_) :-
  General_EV_fail = false &
  General_EV_fail_ = true.

:- dec_p_type(failures_MakeOpenEVFail(bool,bool)).
failures_MakeOpenEVFail(Open_EV_fail,Open_EV_fail_) :-
  Open_EV_fail = false &
  Open_EV_fail_ = true.

:- dec_p_type(failures_MakeCloseEVFail(bool,bool)).
failures_MakeCloseEVFail(Close_EV_fail,Close_EV_fail_) :-
  Close_EV_fail = false &
  Close_EV_fail_ = true.

:- dec_p_type(failures_MakeExtendEVFail(bool,bool)).
failures_MakeExtendEVFail(Extend_EV_fail,Extend_EV_fail_) :-
  Extend_EV_fail = false &
  Extend_EV_fail_ = true.

:- dec_p_type(failures_MakeRetractEVFail(bool,bool)).
failures_MakeRetractEVFail(Retract_EV_fail,Retract_EV_fail_) :-
  Retract_EV_fail = false &
  Retract_EV_fail_ = true.

:- dec_p_type(failures_MakeSwitchFail(bool,bool)).
failures_MakeSwitchFail(Analogical_switch_fail,Analogical_switch_fail_) :-
  Analogical_switch_fail = false &
  Analogical_switch_fail_ = true.

:- dec_p_type(failures_MakeDoorCylinderFail(sp,rpb,rpb)).
failures_MakeDoorCylinderFail(
  PositionsDG,
  Door_Cylinder_fail,
  Door_Cylinder_fail_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_Cylinder_fail,Po,false) &
  foplus(Door_Cylinder_fail,Po,true,Door_Cylinder_fail_).

:- dec_p_type(failures_MakeGearCylinderFail(sp,rpb,rpb)).
failures_MakeGearCylinderFail(
  PositionsDG,
  Gear_Cylinder_fail,
  Gear_Cylinder_fail_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_Cylinder_fail,Po,false) &
  foplus(Gear_Cylinder_fail,Po,true,Gear_Cylinder_fail_).


