% Proof obligations of 

% MACHINE Gears

% Run check_gears

:- dec_p_type(gears_init_inv1).
gears_init_inv1 :-
  dec(PositionsDG,sp) &
  dec(Gear_ext_p,rpb) &
  gears_init(PositionsDG,Gear_ext_p) &
  gears_inv1(PositionsDG,Gear_ext_p).

:- dec_p_type(gears_make_GearExtended_grd1).
gears_make_GearExtended_grd1 :-
  dec(PositionsDG,sp) &
  dec(Gear_ext_p,rpb) &
  dec(Po,pos) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p)
  ).

:- dec_p_type(n_gears_inv1(sp,rpb)).
n_gears_inv1(PositionsDG,Gear_ext_p) :-
  neg(pfun(Gear_ext_p) &
      dompf(Gear_ext_p,PositionsDG)
  ).

:- dec_p_type(gears_make_GearExtended_inv1).
gears_make_GearExtended_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ext_p_],rpb) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gears_make_GearExtended(
        PositionsDG,
        Gear_ext_p,
        Gear_ext_p_
      )
        implies
          gears_inv1(PositionsDG,Gear_ext_p_)
  ).

:- dec_p_type(gears_start_GearRetract_grd1).
gears_start_GearRetract_grd1 :-
  dec(PositionsDG,sp) &
  dec(Gear_ext_p,rpb) &
  dec(Po,pos) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p)
  ).

:- dec_p_type(gears_start_GearRetract_inv1).
gears_start_GearRetract_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ext_p_],rpb) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gears_start_GearRetract(
        PositionsDG,
        Gear_ext_p,
        Gear_ext_p_
      )
        implies
          gears_inv1(PositionsDG,Gear_ext_p_)
  ).

% consult('lgs.pl') & lGearsPO.
:- dec_p_type(check_gears).
check_gears :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking init_inv1...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     gears_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_make_GearExtended_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_make_GearExtended_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_make_GearExtended_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_make_GearExtended_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_start_GearRetract_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_start_GearRetract_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_start_GearRetract_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_start_GearRetract_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) & 
     write(' proof obligations (out of 5) discharged in ') &
     write(T) & write(' seconds') & nl
  ).

