% MACHINE HandleSwitchShockAbsorber

% theorem
:- dec_p_type(handleSwitchShockAbsorber_inv1(bool)).
handleSwitchShockAbsorber_inv1(Circuit_pressurized_p) :-
  Circuit_pressurized_p in {true,false}.

:- dec_p_type(handleSwitchShockAbsorber_inv2(sp,rpb)).
handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) :-
  pfun(Gear_shock_absorber_p) &
  dompf(Gear_shock_absorber_p,PositionsDG).

:- dec_p_type(handleSwitchShockAbsorber_inv3(sph,posh)).
handleSwitchShockAbsorber_inv3(PositionsHandle,Handle_p) :-
  Handle_p in PositionsHandle.

:- dec_p_type(handleSwitchShockAbsorber_inv4(sps,poss)).
handleSwitchShockAbsorber_inv4(PositionsSwitch,Analogical_switch_p) :-
  Analogical_switch_p in PositionsSwitch.

:- dec_p_type(handleSwitchShockAbsorber_inv5(bool)).
handleSwitchShockAbsorber_inv5(Intermediate1) :-
  Intermediate1 in {true,false}.

:- dec_p_type(handleSwitchShockAbsorber_inv6(bool)).
handleSwitchShockAbsorber_inv6(Intermediate2) :-
  Intermediate2 in {true,false}.

:- dec_p_type(handleSwitchShockAbsorber_inv7(bool,bool)).
handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) :-
  neg(Intermediate1 = true & Intermediate2 = true).

:- dec_p_type(handleSwitchShockAbsorber_inv8(poss,bool)).
handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) :-
  Intermediate2 = true implies Analogical_switch_p = open.

:- dec_p_type(handleSwitchShockAbsorber_inv9(poss,bool)).
handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) :-
  Intermediate1 = true implies Analogical_switch_p = open.

:- dec_p_type(handleSwitchShockAbsorber_inv10(bool)).
handleSwitchShockAbsorber_inv10(Handle) :-
  Handle in {true,false}.

:- dec_p_type(handleSwitchShockAbsorber_inv11(sp,rpb,rpb)).
handleSwitchShockAbsorber_inv11(PositionsDG,Gear_ext_p,Gear_shock_absorber_p) :-
  foreach(Po in PositionsDG,[M1,M2],
    dec(Po,pos) & dec([M1,M2],bool) &
    (M1 = true implies M2 = true),
    applyTo(Gear_shock_absorber_p,Po,M1) &
    applyTo(Gear_ext_p,Po,M2)
  ).

:- dec_p_type(
     handleSwitchShockAbsorber_init(
       sp,rpb,rpb,rpb,rpb,rpb,rpb,bool,rpb,posh,poss,bool,bool,bool)).
handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}) &
  Door_closed_p = cp(PositionsDG,{true}) &
  Door_cylinder_locked_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = false &
  Gear_shock_absorber_p = cp(PositionsDG,{true}) &
  Handle_p = down &
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = false.

:- dec_p_type(
     handleSwitchShockAbsorber_start_GearExtend(sp,rpb,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_start_GearExtend(
    PositionsDG,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_ret_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_).

:- dec_p_type(handleSwitchShockAbsorber_make_GearExtended(sp,rpb,bool,rpb,rpb)).
handleSwitchShockAbsorber_make_GearExtended(
    PositionsDG,
    Gear_ext_p,
    Circuit_pressurized_p,
    Gear_ret_p,
    Gear_ext_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_).

:- dec_p_type(
     handleSwitchShockAbsorber_start_GearRetract(
       sp,rpb,rpb,rpb,rpb,bool,rpb,rpb)).
handleSwitchShockAbsorber_start_GearRetract(
    PositionsDG,
    Gear_ext_p,
    Door_open_p,
    Gear_shock_absorber_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_ext_p_,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Gear_ext_p,Po,false,Gear_ext_p_) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(handleSwitchShockAbsorber_make_GearRetracted(sp,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_make_GearRetracted(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Circuit_pressurized_p,
    Gear_ret_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_).

:- dec_p_type(handleSwitchShockAbsorber_start_DoorOpening(rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_start_DoorOpening(
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Door_closed_p_
) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Door_closed_p,Po,false,Door_closed_p_).

:- dec_p_type(handleSwitchShockAbsorber_make_DoorOpen(rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_make_DoorOpen(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Door_open_p_
) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  applyTo(Door_closed_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Door_open_p,Po,true,Door_open_p_).

:- dec_p_type(
     handleSwitchShockAbsorber_start_DoorClosing(sp,rpb,rpb,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Door_open_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  foplus(Door_open_p,Po,false,Door_open_p_).

:- dec_p_type(handleSwitchShockAbsorber_make_DoorClosed(rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_make_DoorClosed(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Door_closed_p_
) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,false) &
  applyTo(Door_open_p,Po,false) &
  Circuit_pressurized_p = true &
  foplus(Door_closed_p,Po,true,Door_closed_p_).

:- dec_p_type(
     handleSwitchShockAbsorber_UnlockGearCylinder(sp,rpb,rpb,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_UnlockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,true) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Door_open_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_).

:- dec_p_type(
     handleSwitchShockAbsorber_LockGearCylinder(sp,rpb,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_LockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Circuit_pressurized_p = true &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_).

:- dec_p_type(handleSwitchShockAbsorber_UnlockDoorCylinder(sp,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_UnlockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Door_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,true) &
  Circuit_pressurized_p = true &
  foplus(Door_cylinder_locked_p,Po,false,Door_cylinder_locked_p_).

:- dec_p_type(handleSwitchShockAbsorber_LockDoorCylinder(sp,rpb,rpb,bool,rpb)).
handleSwitchShockAbsorber_LockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Door_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_cylinder_locked_p,Po,false) &
  applyTo(Door_closed_p,Po,true) &
  Circuit_pressurized_p = true &
  foplus(Door_cylinder_locked_p,Po,true,Door_cylinder_locked_p_).

:- dec_p_type(handleSwitchShockAbsorber_Unpressurize_HydrolicCircuit(bool,bool)).
handleSwitchShockAbsorber_Unpressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = true &
  Circuit_pressurized_p_ = false.

:- dec_p_type(handleSwitchShockAbsorber_Pressurize_HydrolicCircuit(bool,bool)).
handleSwitchShockAbsorber_Pressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = false &
  Circuit_pressurized_p_ = true.

:- dec_p_type(
     handleSwitchShockAbsorber_Make_GearAbsorberTrue(sp,rpb,rpb,posh,rpb)).
handleSwitchShockAbsorber_Make_GearAbsorberTrue(
    PositionsDG,
    Gear_ext_p,
    Gear_shock_absorber_p,
    Handle_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,false) &
  applyTo(Gear_ext_p,Po,true) &
  Handle_p = down &
  foplus(Gear_shock_absorber_p,Po,true,Gear_shock_absorber_p_).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberFalse(sp,rpb,rpb)).
handleSwitchShockAbsorber_Make_GearAbsorberFalse(
    PositionsDG,
    Gear_shock_absorber_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,true) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(handleSwitchShockAbsorber_PutHandleUp(posh,posh,bool)).
handleSwitchShockAbsorber_PutHandleUp(Handle_p,Handle_p_,Handle_) :-
  Handle_p = down &
  Handle_p_ = up &
  Handle_ = true.

:- dec_p_type(handleSwitchShockAbsorber_PutHandleDown(posh,posh,bool)).
handleSwitchShockAbsorber_PutHandleDown(Handle_p,Handle_p_,Handle_) :-
  Handle_p = up &
  Handle_p_ = down &
  Handle_ = true.

:- dec_p_type(
     handleSwitchShockAbsorber_HandleFromOpenToIntermediate1(
       poss,bool,bool,bool,bool,bool)).
handleSwitchShockAbsorber_HandleFromOpenToIntermediate1(
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    Intermediate1_,
    Handle_
) :-
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = true &
  Intermediate1_ = true &
  Handle_ = false.

:- dec_p_type(handleSwitchShockAbsorber_close_Switch(bool,poss,bool)).
handleSwitchShockAbsorber_close_Switch(
    Intermediate1,
    Analogical_switch_p_,
    Intermediate1_
) :-
  Intermediate1 = true &
  Analogical_switch_p_ = closed &
  Intermediate1_ = false.

:- dec_p_type(handleSwitchShockAbsorber_HandleOnClosed(poss,bool,bool)).
handleSwitchShockAbsorber_HandleOnClosed(
    Analogical_switch_p,
    Handle,
    Handle_) :-
  Analogical_switch_p = closed &
  Handle = true &
  Handle_ = false.

:- dec_p_type(
     handleSwitchShockAbsorber_FromCloseToIntermediate2(poss,poss,bool)).
handleSwitchShockAbsorber_FromCloseToIntermediate2(
    Analogical_switch_p,
    Analogical_switch_p_,
    Intermediate2_
) :-
  Analogical_switch_p = closed &
  Intermediate2_ = true &
  Analogical_switch_p_ = open.

:- dec_p_type(
     handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1(
       bool,bool,bool,bool,bool)).
handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1(
    Intermediate2,
    Handle,
    Intermediate1_,
    Intermediate2_,
    Handle_
) :-
  Intermediate2 = true &
  Handle = true &
  Handle_ = false &
  Intermediate2_ = false &
  Intermediate1_ = true.

:- dec_p_type(handleSwitchShockAbsorber_open_Switch(bool,bool)).
handleSwitchShockAbsorber_open_Switch(
    Intermediate2,
    Intermediate2_
) :-
  Intermediate2 = true &
  Intermediate2_ = false.

