% Proof obligations of 

% MACHINE Sensors

% Run check_sensors

:- dec_p_type(sensors_inv9_wd).
sensors_inv9_wd :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_retracted_ind],rpb) &
  dec(Po,pos) &
  neg(
    sensors_inv6(PositionsDG,Gear_extended_ind) &
    sensors_inv8(PositionsDG,Gear_retracted_ind) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_extended_ind,{}) &
        pfun(Gear_extended_ind) &
        (applyTo(Gear_extended_ind,Po,true)
           implies
             ncomp({[Po,Po]},Gear_retracted_ind,{}) &
             pfun(Gear_retracted_ind)
        )
  ).
             
:- dec_p_type(sensors_inv12_wd).
sensors_inv12_wd :-
  dec(PositionsDG,sp) &
  dec([Door_closed_ind,Door_open_ind],rpb) &
  dec(Po,pos) &
  neg(
    sensors_inv10(PositionsDG,Door_closed_ind) &
    sensors_inv11(PositionsDG,Door_open_ind) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Door_closed_ind,{}) &
        pfun(Door_closed_ind) &
        (applyTo(Door_closed_ind,Po,true)
           implies
             ncomp({[Po,Po]},Door_open_ind,{}) &
             pfun(Door_open_ind)
        )
  ).
             
:- dec_p_type(sensors_inv21_wd).
sensors_inv21_wd :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_ext_p],rpb) &
  dec(Po,pos) &
  neg(
    gears_inv1(PositionsDG,Gear_ext_p) &
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p) &
        (applyTo(Gear_shock_absorber_p,Po,true)
           implies
             ncomp({[Po,Po]},Gear_ext_p,{}) &
             pfun(Gear_ext_p)
        )
  ).
             
:- dec_p_type(sensors_init_inv6).
sensors_init_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv6(PositionsDG,Gear_extended_ind).

:- dec_p_type(sensors_init_inv7).
sensors_init_inv7 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv7(PositionsDG,Gear_shock_absorber_ind).

:- dec_p_type(sensors_init_inv8).
sensors_init_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv8(PositionsDG,Gear_retracted_ind).

:- dec_p_type(sensors_init_inv9).
sensors_init_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv9(PositionsDG,Gear_extended_ind,Gear_retracted_ind).

:- dec_p_type(sensors_init_inv10).
sensors_init_inv10 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv10(PositionsDG,Door_closed_ind).

:- dec_p_type(sensors_init_inv11).
sensors_init_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv11(PositionsDG,Door_open_ind).

:- dec_p_type(sensors_init_inv12).
sensors_init_inv12 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv12(PositionsDG,Door_closed_ind,Door_open_ind).

:- dec_p_type(sensors_init_inv18).
sensors_init_inv18 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV).

:- dec_p_type(sensors_init_inv19).
sensors_init_inv19 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv19(Open_EV,Close_EV).

:- dec_p_type(sensors_init_inv20).
sensors_init_inv20 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv20(Open_EV,Extend_EV,Retract_EV).

:- dec_p_type(sensors_init_inv21).
sensors_init_inv21 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p).

:- dec_p_type(sensors_init_inv22).
sensors_init_inv22 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  sensors_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle
  ) &
  sensors_inv22(Extend_EV,Retract_EV).

:- dec_p_type(n_sensors_inv21(sp,rpb,rpb)).
n_sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p) :-
  neg(
    foreach(Po in PositionsDG,[M1,M2],
      dec(Po,pos) &
      dec([M1,M2],bool) &
      (M1 = true implies M2 = true),
      applyTo(Gear_shock_absorber_p,Po,M1) &
      applyTo(Gear_ext_p,Po,M2)
    )
  ).
  
:- dec_p_type(sensors_make_GearExtended_inv21).
sensors_make_GearExtended_inv21 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_ext_p,Gear_ret_p,Gear_ext_p_],rpb) &
  dec([Circuit_pressurized_p,Extend_EV_p,Retract_EV_p],bool) &
  neg(
    sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p) &
    sensors_make_GearExtended(
      PositionsDG,
      Gear_ext_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ret_p,
      Gear_ext_p_
    )
      implies
        sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p_)
  ).

:- dec_p_type(sensors_start_GearRetract_inv21).
sensors_start_GearRetract_inv21 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_ext_p,Door_open_p,Gear_cylinder_locked_p,
       Gear_ret_p,Gear_ext_p_,Gear_shock_absorber_p_],rpb) &
  dec([Circuit_pressurized_p,Extend_EV_p,Retract_EV_p],bool) &
  neg(
    sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p) &
    sensors_start_GearRetract(
      PositionsDG,
      Gear_ext_p,
      Door_open_p,
      Gear_shock_absorber_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ext_p_,
      Gear_shock_absorber_p_
    )
      implies
        sensors_inv21(PositionsDG,Gear_shock_absorber_p_,Gear_ext_p_)
  ).

:- dec_p_type(sensors_MakeGearSockAbsorberFalse_inv21).
sensors_MakeGearSockAbsorberFalse_inv21 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_ext_p,Gear_shock_absorber_p_],rpb) &
  dec([Circuit_pressurized_p,Extend_EV_p,Retract_EV_p],bool) &
  neg(
    sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p) &
    sensors_MakeGearShockAbsorberFalse(
      PositionsDG,
      Gear_shock_absorber_p,
      Gear_shock_absorber_p_
    )
      implies
        sensors_inv21(PositionsDG,Gear_shock_absorber_p_,Gear_ext_p)
  ).

:- dec_p_type(sensors_MakeGearSockAbsorberTRUE_inv21).
sensors_MakeGearSockAbsorberTRUE_inv21 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_ext_p,Gear_shock_absorber_p_],rpb) &
  dec(Handle_p,posh) &
  dec(GreenLight_p,bool) &
  neg(
    sensors_inv21(PositionsDG,Gear_shock_absorber_p,Gear_ext_p) &
    sensors_MakeGearShockAbsorberTRUE(
      PositionsDG,
      Gear_ext_p,
      Gear_shock_absorber_p,
      Handle_p,
      GreenLight_p,
      Gear_shock_absorber_p_
    )
      implies
        sensors_inv21(PositionsDG,Gear_shock_absorber_p_,Gear_ext_p)
  ).

:- dec_p_type(sensors_ReadGearsShock_grd2).
sensors_ReadGearsShock_grd2 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ext_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_extended_sensor_valueF,bool) &
  neg(
    PositionsDG = {front / M} &
    gears_inv1(PositionsDG,Gear_ext_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_extended_sensor_valueF = true
      implies
        ncomp({[front,front]},Gear_ext_p,{}) &
        pfun(Gear_ext_p) &
        (applyTo(Gear_ext_p,front,true)
           implies
             ncomp({[front,front]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd4).
sensors_ReadGearsShock_grd4 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ext_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_extended_sensor_valueL,bool) &
  neg(
    PositionsDG = {left / M} &
    gears_inv1(PositionsDG,Gear_ext_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_extended_sensor_valueL = true
      implies
        ncomp({[left,left]},Gear_ext_p,{}) &
        pfun(Gear_ext_p) &
        (applyTo(Gear_ext_p,left,true)
           implies
             ncomp({[left,left]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd6).
sensors_ReadGearsShock_grd6 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ext_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_extended_sensor_valueR,bool) &
  neg(
    PositionsDG = {right / M} &
    gears_inv1(PositionsDG,Gear_ext_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_extended_sensor_valueR = true
      implies
        ncomp({[right,right]},Gear_ext_p,{}) &
        pfun(Gear_ext_p) &
        (applyTo(Gear_ext_p,right,true)
           implies
             ncomp({[right,right]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd8).
sensors_ReadGearsShock_grd8 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ret_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_retracted_sensor_valueF,bool) &
  neg(
    PositionsDG = {front / M} &
    gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_retracted_sensor_valueF = true
      implies
        ncomp({[front,front]},Gear_ret_p,{}) &
        pfun(Gear_ret_p) &
        (applyTo(Gear_ret_p,front,true)
           implies
             ncomp({[front,front]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd10).
sensors_ReadGearsShock_grd10 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ret_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_retracted_sensor_valueF,bool) &
  neg(
    PositionsDG = {left / M} &
    gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_retracted_sensor_valueF = true
      implies
        ncomp({[left,left]},Gear_ret_p,{}) &
        pfun(Gear_ret_p) &
        (applyTo(Gear_ret_p,left,true)
           implies
             ncomp({[left,left]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd12).
sensors_ReadGearsShock_grd12 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_ret_p,Gear_cylinder_locked_p],rpb) &
  dec(Gear_retracted_sensor_valueF,bool) &
  neg(
    PositionsDG = {right / M} &
    gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
    cylinders_inv2(PositionsDG,Gear_cylinder_locked_p) &
    Gear_retracted_sensor_valueF = true
      implies
        ncomp({[right,right]},Gear_ret_p,{}) &
        pfun(Gear_ret_p) &
        (applyTo(Gear_ret_p,left,true)
           implies
             ncomp({[right,right]},Gear_cylinder_locked_p,{}) &
             pfun(Gear_cylinder_locked_p)
        )
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd14).
sensors_ReadGearsShock_grd14 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_shock_absorber_p],rpb) &
  dec(Gear_shock_absorber_sensor_valueF,bool) &
  neg(
    PositionsDG = {front / M} &
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    Gear_shock_absorber_sensor_valueF = false
      implies
        ncomp({[front,front]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p)
  ).
             
:- dec_p_type(sensors_ReadGearsShock_grd16).
sensors_ReadGearsShock_grd16 :-
  dec([PositionsDG,M],sp) &
  dec([Gear_shock_absorber_p],rpb) &
  dec(Gear_shock_absorber_sensor_valueL,bool) &
  neg(
    PositionsDG = {left / M} &
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    Gear_shock_absorber_sensor_valueL = false
      implies
        ncomp({[left,left]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p)
  ).
             
:- dec_p_type(n_sensors_inv6(sp,rpb)).
n_sensors_inv6(PositionsDG,Gear_extended_ind) :-
  neg(
    pfun(Gear_extended_ind) &
    dompf(Gear_extended_ind,PositionsDG)
  ).

:- dec_p_type(sensors_ReadGearsShock_inv6).
sensors_ReadGearsShock_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,End_cycle_],bool) &
  neg(
    PositionsDG = {front,left,right} &
    sensors_inv6(PositionsDG,Gear_extended_ind) &
    sensors_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_
    )
      implies
        sensors_inv6(PositionsDG,Gear_extended_ind_)
  ).

:- dec_p_type(n_sensors_inv7(sp,rpb)).
n_sensors_inv7(PositionsDG,Gear_shock_absorber_ind) :-
  neg(
    pfun(Gear_shock_absorber_ind) &
    dompf(Gear_shock_absorber_ind,PositionsDG)
  ).

:- dec_p_type(sensors_ReadGearsShock_inv7).
sensors_ReadGearsShock_inv7 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_ind,Gear_extended_ind,Gear_ext_p,Gear_ret_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind_,
       Gear_retracted_ind_,Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,End_cycle_],bool) &
  neg(
    PositionsDG = {front,left,right} &
    sensors_inv7(PositionsDG,Gear_shock_absorber_ind) &
    sensors_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_
    )
      implies
        sensors_inv7(PositionsDG,Gear_shock_absorber_ind_)
  ).

:- dec_p_type(n_sensors_inv8(sp,rpb)).
n_sensors_inv8(PositionsDG,Gear_retracted_ind) :-
  neg(
    pfun(Gear_retracted_ind) &
    dompf(Gear_retracted_ind,PositionsDG)
  ).

:- dec_p_type(sensors_ReadGearsShock_inv8).
sensors_ReadGearsShock_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_retracted_ind,Gear_ext_p,Gear_ret_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind_,
       Gear_retracted_ind_,Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,End_cycle_],bool) &
  neg(
    PositionsDG = {front,left,right} &
    sensors_inv8(PositionsDG,Gear_retracted_ind) &
    sensors_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_
    )
      implies
        sensors_inv8(PositionsDG,Gear_retracted_ind_)
  ).

:- dec_p_type(n_sensors_inv9(sp,rpb,rpb)).
n_sensors_inv9(PositionsDG,Gear_extended_ind,Gear_retracted_ind) :-
  neg(
    foreach(Po in PositionsDG,[M1,M2],
      dec(Po,pos) &
      dec([M1,M2],bool) &
      neg(M1 = true & M2 = true),
      applyTo(Gear_extended_ind,Po,M1) &
      applyTo(Gear_retracted_ind,Po,M2)
    )
  ).

:- dec_p_type(sensors_ReadGearsShock_inv9).
sensors_ReadGearsShock_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_retracted_ind,Gear_ext_p,Gear_ret_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind_,
       Gear_retracted_ind_,Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,End_cycle_],bool) &
  neg(
    PositionsDG = {front,left,right} &
    gearsIntermediate_inv2(PositionsDG,Gear_ext_p,Gear_ret_p) &
    delay(sensors_inv9(PositionsDG,Gear_extended_ind,Gear_retracted_ind),false) &
    sensors_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_
    )
      implies
        sensors_inv9(PositionsDG,Gear_extended_ind_,Gear_retracted_ind_)
  ).

:- dec_p_type(sensors_ReadDoors_grd1).
sensors_ReadDoors_grd1 :-
  dec([PositionsDG,M],sp) &
  dec([Door_open_p],rpb) &
  dec(Door_open_sensor_valueF,bool) &
  neg(
    PositionsDG = {front / M} &
    doors_inv1(PositionsDG,Door_open_p) &
    Door_open_sensor_valueF = true
      implies
        ncomp({[front,front]},Door_open_p,{}) &
        pfun(Door_open_p)
  ).
             
:- dec_p_type(sensors_ReadDoors_grd2).
sensors_ReadDoors_grd2 :-
  dec([PositionsDG,M],sp) &
  dec([Door_open_p],rpb) &
  dec(Door_open_sensor_valueL,bool) &
  neg(
    PositionsDG = {left / M} &
    doors_inv1(PositionsDG,Door_open_p) &
    Door_open_sensor_valueL = true
      implies
        ncomp({[left,left]},Door_open_p,{}) &
        pfun(Door_open_p)
  ).
             
:- dec_p_type(sensors_ReadDoors_grd3).
sensors_ReadDoors_grd3 :-
  dec([PositionsDG,M],sp) &
  dec([Door_open_p],rpb) &
  dec(Door_open_sensor_valueR,bool) &
  neg(
    PositionsDG = {right / M} &
    doors_inv1(PositionsDG,Door_open_p) &
    Door_open_sensor_valueR = true
      implies
        ncomp({[right,right]},Door_open_p,{}) &
        pfun(Door_open_p)
  ).
             
:- dec_p_type(sensors_ReadDoors_grd4).
sensors_ReadDoors_grd4 :-
  dec([PositionsDG,M],sp) &
  dec([Door_closed_p],rpb) &
  dec(Door_closed_sensor_valueF,bool) &
  neg(
    PositionsDG = {front / M} &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
    Door_closed_sensor_valueF = true
      implies
        ncomp({[front,front]},Door_closed_p,{}) &
        pfun(Door_closed_p)
  ).
             
:- dec_p_type(sensors_ReadDoors_grd5).
sensors_ReadDoors_grd5 :-
  dec([PositionsDG,M],sp) &
  dec([Door_closed_p],rpb) &
  dec(Door_closed_sensor_valueL,bool) &
  neg(
    PositionsDG = {left / M} &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
    Door_closed_sensor_valueL = true
      implies
        ncomp({[left,left]},Door_closed_p,{}) &
        pfun(Door_closed_p)
  ).
             
:- dec_p_type(sensors_ReadDoors_grd6).
sensors_ReadDoors_grd6 :-
  dec([PositionsDG,M],sp) &
  dec([Door_closed_p],rpb) &
  dec(Door_closed_sensor_valueR,bool) &
  neg(
    PositionsDG = {right / M} &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
    Door_closed_sensor_valueR = true
      implies
        ncomp({[right,right]},Door_closed_p,{}) &
        pfun(Door_closed_p)
  ).
             
:- dec_p_type(n_sensors_inv10(sp,rpb)).
n_sensors_inv10(PositionsDG,Door_closed_ind) :-
  neg(
    pfun(Door_closed_ind) &
    dompf(Door_closed_ind,PositionsDG)
  ).

:- dec_p_type(sensors_ReadDoors_inv10).
sensors_ReadDoors_inv10 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_ind,Door_open_p,Door_closed_p,Door_open_ind_,
       Door_closed_ind_],rpb) &
  dec(End_cycle_,bool) &
  neg(
    PositionsDG = {front,left,right} &
    sensors_inv10(PositionsDG,Door_closed_ind) &
    sensors_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_
    )
      implies
        sensors_inv10(PositionsDG,Door_closed_ind_)
  ).

:- dec_p_type(n_sensors_inv11(sp,rpb)).
n_sensors_inv11(PositionsDG,Door_open_ind) :-
  neg(
    pfun(Door_open_ind) &
    dompf(Door_open_ind,PositionsDG)
  ).

:- dec_p_type(sensors_ReadDoors_inv11).
sensors_ReadDoors_inv11 :-
  dec(PositionsDG,sp) &
  dec([Door_open_ind,Door_open_p,Door_closed_p,Door_open_ind_,
       Door_closed_ind_],rpb) &
  dec(End_cycle_,bool) &
  neg(
    PositionsDG = {front,left,right} &
    sensors_inv11(PositionsDG,Door_open_ind) &
    sensors_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_
    )
      implies
        sensors_inv11(PositionsDG,Door_open_ind_)
  ).

:- dec_p_type(n_sensors_inv12(sp,rpb,rpb)).
n_sensors_inv12(PositionsDG,Door_closed_ind,Door_open_ind) :-
  neg(
    foreach(Po in PositionsDG,[M1,M2],
      dec(Po,pos) &
      dec([M1,M2],bool) &
      neg(M1 = true & M2 = true),
      applyTo(Door_closed_ind,Po,M1) &
      applyTo(Door_open_ind,Po,M2)
    )
  ).
  
:- dec_p_type(sensors_ReadDoors_inv12).
sensors_ReadDoors_inv12 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_ind,Door_open_ind,Door_open_p,Door_closed_p,Door_open_ind_,
       Door_closed_ind_],rpb) &
  dec(End_cycle_,bool) &
  neg(
    PositionsDG = {front,left,right} &
    doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) &
    delay(sensors_inv12(PositionsDG,Door_closed_ind,Door_open_ind),false) &
    sensors_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_
    )
      implies
        sensors_inv12(PositionsDG,Door_closed_ind_,Door_open_ind_)
  ).

:- dec_p_type(n_sensors_inv18(bool,bool,bool,bool,bool)).
n_sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) :-
  neg(
    (Open_EV = true
     or
     Close_EV = true
     or
     Extend_EV = true
     or
     Retract_EV = true
    )
     implies
       General_EV = true
  ).

:- dec_p_type(sensors_outputGEV_inv18).
sensors_outputGEV_inv18 :-
  dec([Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV,General_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      Door_closed_ind,
      General_EV_,
      End_cycle_
    )
      implies
        sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV_)
  ).

:- dec_p_type(sensors_OutputOpenEV_inv18).
sensors_OutputOpenEV_inv18 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Open_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind],rpb) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Open_EV_,
      End_cycle_
    )
      implies
        sensors_inv18(Open_EV_,Close_EV,Extend_EV,Retract_EV,General_EV)
  ).

:- dec_p_type(n_sensors_inv19(bool,bool)).
n_sensors_inv19(Open_EV,Close_EV) :-
  neg(neg(Open_EV = true & Close_EV = true)).

:- dec_p_type(sensors_OutputOpenEV_inv19).
sensors_OutputOpenEV_inv19 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Open_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    sensors_inv19(Open_EV,Close_EV) &
    sensors_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Open_EV_,
      End_cycle_
    )
      implies
        sensors_inv19(Open_EV_,Close_EV)
  ).

:- dec_p_type(n_sensors_inv20(bool,bool,bool)).
n_sensors_inv20(Open_EV,Extend_EV,Retract_EV) :-
  neg(
    (Extend_EV = true
     or
     Retract_EV = true
    )
      implies
        Open_EV = true
  ).

:- dec_p_type(sensors_OutputOpenEV_inv20).
sensors_OutputOpenEV_inv20 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Open_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    sensors_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Open_EV_,
      End_cycle_
    )
      implies
        sensors_inv20(Open_EV_,Extend_EV,Retract_EV)
  ).


:- dec_p_type(sensors_OutputCloseEv_inv18).
sensors_OutputCloseEv_inv18 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      Close_EV_,
      End_cycle_
    )
      implies
        sensors_inv18(Open_EV,Close_EV_,Extend_EV,Retract_EV,General_EV)
  ).

:- dec_p_type(sensors_OutputCloseEv_inv19).
sensors_OutputCloseEv_inv19 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      Close_EV_,
      End_cycle_
    )
      implies
        sensors_inv19(Open_EV,Close_EV_)
  ).

:- dec_p_type(sensors_OutputExtendEV_inv18).
sensors_OutputExtendEV_inv18 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Extend_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      Extend_EV_,
      End_cycle_
    )
      implies
        sensors_inv18(Open_EV,Close_EV,Extend_EV_,Retract_EV,General_EV)
  ).

:- dec_p_type(sensors_OutputExtendEV_inv20).
sensors_OutputExtendEV_inv20 :-
  dec([Open_EV,Close_EV,Extend_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    sensors_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      Extend_EV_,
      End_cycle_
    )
      implies
        sensors_inv20(Open_EV,Extend_EV_,Retract_EV)
  ).

:- dec_p_type(n_sensors_inv22(bool,bool)).
n_sensors_inv22(Extend_EV,Retract_EV) :-
  neg(neg(Extend_EV = true & Retract_EV = true)).

:- dec_p_type(sensors_OutputExtendEV_inv22).
sensors_OutputExtendEV_inv22 :-
  dec([Open_EV,Close_EV,Extend_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    sensors_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      Extend_EV_,
      End_cycle_
    )
      implies
        sensors_inv22(Extend_EV_,Retract_EV)
  ).

:- dec_p_type(sensors_OutputRetractEV_inv18).
sensors_OutputRetractEV_inv18 :-
  dec([Open_EV,Close_EV,General_EV,Extend_EV,Retract_EV,Retract_EV_,
       End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      Retract_EV_,
      End_cycle_
    )
      implies
        sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV_,General_EV)
  ).

:- dec_p_type(sensors_OutputRetractEV_inv20).
sensors_OutputRetractEV_inv20 :-
  dec([Open_EV,Close_EV,Extend_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    sensors_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      Retract_EV_,
      End_cycle_
    )
      implies
        sensors_inv20(Open_EV,Extend_EV,Retract_EV_)
  ).

:- dec_p_type(sensors_OutputRetractEV_inv22).
sensors_OutputRetractEV_inv22 :-
  dec([Open_EV,Close_EV,Extend_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    sensors_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      Retract_EV_,
      End_cycle_
    )
      implies
        sensors_inv22(Extend_EV,Retract_EV_)
  ).


% consult('lgs.pl') & lSensorsPO.
:- dec_p_type(check_sensors).
check_sensors :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking sensors_inv9_wd...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_inv9_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_inv12_wd...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_inv12_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_inv21_wd...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_inv21_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv6 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv7 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv8 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv9 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv10 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv11 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv12 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv18 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv19 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv20 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv21...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv21 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_init_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     sensors_init_inv22 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_make_GearExtended_inv21...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_make_GearExtended_inv21) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_start_GearRetract_inv21...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_start_GearRetract_inv21) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_MakeGearSockAbsorberFalse_inv21...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_MakeGearSockAbsorberFalse_inv21) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_MakeGearSockAbsorberTRUE_inv21...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_MakeGearSockAbsorberTRUE_inv21) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_grd16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_grd16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadGearsShock_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadGearsShock_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_ReadDoors_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_ReadDoors_inv12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_outputGEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_outputGEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputOpenEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputOpenEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputOpenEV_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputOpenEV_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputOpenEV_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputOpenEV_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputCloseEv_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputCloseEv_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputCloseEv_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputCloseEv_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputExtendEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputExtendEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputExtendEV_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputExtendEV_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputExtendEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputExtendEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputRetractEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputRetractEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputRetractEV_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputRetractEV_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking sensors_OutputRetractEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(sensors_OutputRetractEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 52) discharged in ') &
     write(T) & write(' seconds') & nl
  ).











