% MACHINE TimedAspects

:- dec_p_type(timedAspects_inv1(int)).
timedAspects_inv1(CurrentTime) :-
  0 =< CurrentTime.

:- dec_p_type(timedAspects_inv2(int)).
timedAspects_inv2(DeadlineSwitch) :-
  0 =< DeadlineSwitch.

:- dec_p_type(timedAspects_inv3(int)).
timedAspects_inv3(DeadlineStimulationGeneralEv) :-
  0 =< DeadlineStimulationGeneralEv.

:- dec_p_type(timedAspects_inv4(int)).
timedAspects_inv4(DeadlineStimulationOpenCloseEv) :-
  0 =< DeadlineStimulationOpenCloseEv.

:- dec_p_type(timedAspects_inv5(sp,rpi)).
timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) :-
  pfun(DeadlineUnlockLockDoorsCylinders) &
  dompf(DeadlineUnlockLockDoorsCylinders,PositionsDG) &
  foreach(
    [X,Y] in DeadlineUnlockLockDoorsCylinders, dec(X,pos) & dec(Y,int) & 0 =< Y
  ).

:- dec_p_type(timedAspects_inv6(sp,rpi)).
timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) :-
  pfun(DeadlineUnlockLockGearsCylinders) &
  dompf(DeadlineUnlockLockGearsCylinders,PositionsDG) &
  foreach(
    [X,Y] in DeadlineUnlockLockGearsCylinders, dec(X,pos) & dec(Y,int) & 0 =< Y
  ).

:- dec_p_type(timedAspects_inv7(sp,rpi)).
timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) :-
  pfun(DeadlineOpenCloseDoors) &
  dompf(DeadlineOpenCloseDoors,PositionsDG) &
  foreach(
    [X,Y] in DeadlineOpenCloseDoors, dec(X,pos) & dec(Y,int) & 0 =< Y
  ).

:- dec_p_type(timedAspects_inv8(int)).
timedAspects_inv8(DeadlineStimulationRetExtEv) :-
  0 =< DeadlineStimulationRetExtEv.

:- dec_p_type(timedAspects_inv9(sp,rpi)).
timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) :-
  pfun(DeadlineGearsRetractingExtending) &
  dompf(DeadlineGearsRetractingExtending,PositionsDG) &
  foreach(
    [X,Y] in DeadlineGearsRetractingExtending, dec(X,pos) & dec(Y,int) & 0 =< Y
  ).

:- dec_p_type(timedAspects_inv10(int)).
timedAspects_inv10(AllowedStopGeneralEv) :-
  0 =< AllowedStopGeneralEv.

:- dec_p_type(timedAspects_inv11(int)).
timedAspects_inv11(AllowedStartOpenEv) :-
  0 =< AllowedStartOpenEv.

:- dec_p_type(timedAspects_inv12(int)).
timedAspects_inv12(AllowedStartCloseEv) :-
  0 =< AllowedStartCloseEv.

:- dec_p_type(timedAspects_inv13(int)).
timedAspects_inv13(AllowedStartExtEv) :-
  0 =< AllowedStartExtEv.

:- dec_p_type(timedAspects_inv14(int)).
timedAspects_inv14(AllowedStartRetEv) :-
  0 =< AllowedStartRetEv.

:- dec_p_type(
    timedAspects_init(
      sp,rpb,rpb,rpb,rpb,rpb,rpb,bool,rpb,posh,poss,bool,bool,bool,bool,bool,
      bool,bool,bool,bool,bool,bool,posh,poss,bool,bool,bool,bool,bool,bool,
      rpb,rpb,rpb,rpb,rpb,bool,bool,bool,int,int,int,int,rpi,rpi,rpi,int,rpi,
      int,int,int,int,int)).
timedAspects_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    General_EV_p,
    Open_EV_p,
    Close_EV_p,
    Extend_EV_p,
    Retract_EV_p,
    GreenLight_p,
    OrangeLight_p,
    RedLight_p,
    Handle_ind,
    Analogical_switch_ind,
    Circuit_pressurized_ind,
    General_EV,
    Open_EV,
    Close_EV,
    Extend_EV,
    Retract_EV,
    Gear_extended_ind,
    Gear_shock_absorber_ind,
    Gear_retracted_ind,
    Door_closed_ind,
    Door_open_ind,
    Gears_locked_down,
    Gears_maneuvering,
    End_cycle,
    CurrentTime,
    DeadlineSwitch,
    DeadlineStimulationGeneralEv,
    DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,
    DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,
    DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,
    AllowedStopGeneralEv,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStartExtEv,
    AllowedStartRetEv
) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}) &
  Door_closed_p = cp(PositionsDG,{true}) &
  Door_cylinder_locked_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = false &
  Gear_shock_absorber_p = cp(PositionsDG,{true}) &
  Handle_p = down &
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = false &
  General_EV_p = false &
  Open_EV_p = false &
  Close_EV_p = false &
  Extend_EV_p = false &
  Retract_EV_p = false &
  GreenLight_p = true &
  OrangeLight_p = false &
  RedLight_p = false &
  Gear_extended_ind = cp(PositionsDG,{true}) &
  Gear_shock_absorber_ind = cp(PositionsDG,{true}) &
  Gear_retracted_ind = cp(PositionsDG,{false}) &
  Door_closed_ind = cp(PositionsDG,{true}) &
  Door_open_ind = cp(PositionsDG,{false}) &
  General_EV = false &
  Open_EV = false &
  Close_EV = false &
  Extend_EV = false &
  Retract_EV = false &
  Handle_ind = down &
  Analogical_switch_ind = open &
  Circuit_pressurized_ind = false &
  Gears_locked_down = true &
  Gears_maneuvering = false &
  End_cycle = true &
  CurrentTime = 0 &
  DeadlineSwitch = 0 &
  DeadlineStimulationGeneralEv = 0 &
  DeadlineStimulationOpenCloseEv = 0 &
  DeadlineUnlockLockDoorsCylinders = cp(PositionsDG,{0}) &
  DeadlineUnlockLockGearsCylinders = cp(PositionsDG,{0}) &
  DeadlineOpenCloseDoors = cp(PositionsDG,{0}) &
  DeadlineGearsRetractingExtending = cp(PositionsDG,{0}) &
  DeadlineStimulationRetExtEv = 0 &
  AllowedStopGeneralEv = 0 &
  AllowedStartOpenEv = 0 &
  AllowedStartCloseEv = 0 &
  AllowedStartExtEv = 0 &
  AllowedStartRetEv = 0.

:- dec_p_type(
     timedAspects_start_GearExtend(
       sp,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi)).
timedAspects_start_GearExtend(
    PositionsDG,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Extend_EV_p,
    Retract_EV_p,
    Circuit_pressurized_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_ret_p_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = false &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,M1,DeadlineGearsRetractingExtending_
  ) &
    applyTo({[front,M2],[left,M3],[right,16]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16.

:- dec_p_type(
     timedAspects_make_GearExtended(
       sp,rpb,bool,bool,bool,rpb,int,rpi,rpi,rpb,rpi,rpi)).
timedAspects_make_GearExtended(
    PositionsDG,
    Gear_ext_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ret_p,
    CurrentTime,
    DeadlineGearsRetractingExtending,
    DeadlineUnlockLockGearsCylinders,
    Gear_ext_p_,
    DeadlineGearsRetractingExtending_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  dec(M,int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineGearsRetractingExtending,Po,CurrentTime) &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,0,DeadlineGearsRetractingExtending_
  ) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,M,DeadlineUnlockLockGearsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     timedAspects_start_GearRetract(
       sp,rpb,rpb,rpb,bool,bool,bool,rpb,rpb,int,rpi,rpi,rpb,rpi)).
timedAspects_start_GearRetract(
    PositionsDG,
    Gear_ext_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ext_p_,
    Gear_shock_absorber_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_shock_absorber_p_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Gear_ext_p,Po,false,Gear_ext_p_) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_) &
  foplus(
     DeadlineGearsRetractingExtending,Po,M1,DeadlineGearsRetractingExtending_
  ) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 16 &
    M3 is CurrentTime + 20.
    
:- dec_p_type(
     timedAspects_make_GearRetracted(
       sp,rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi,rpi)).
timedAspects_make_GearRetracted(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    Gear_ret_p_,
    DeadlineUnlockLockGearsCylinders_,
    DeadlineGearsRetractingExtending_
) :-
  dec(Po,pos) &
  dec(M,int) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  applyTo(DeadlineGearsRetractingExtending,front,CurrentTime) &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_) &
  foplus(
    DeadlineGearsRetractingExtending,Po,0,DeadlineGearsRetractingExtending_
  ) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,M,DeadlineUnlockLockGearsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     timedAspects_start_DoorOpening(rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi)).
timedAspects_start_DoorOpening(
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,
    Door_closed_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,0) &
  foplus(Door_closed_p,Po,false,Door_closed_p_) &
  foplus(
     DeadlineOpenCloseDoors,Po,M1,DeadlineOpenCloseDoors_
  ) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 15.

:- dec_p_type(
     timedAspects_make_DoorOpen(rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_make_DoorOpen(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    Door_open_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  applyTo(Door_closed_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineOpenCloseDoors,Po,CurrentTime) &
  foplus(Door_open_p,Po,true,Door_open_p_) &
  foplus(DeadlineOpenCloseDoors,Po,0,DeadlineOpenCloseDoors_).

:- dec_p_type(
     timedAspects_start_DoorClosing(
       sp,rpb,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    Door_open_p_,
    DeadlineOpenCloseDoors_
) :-
  dec(Po,pos) &
  dec([M1,M2,M3],int) &
  Po in PositionsDG &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  foplus(Door_open_p,Po,false,Door_open_p_) &
  foplus(DeadlineOpenCloseDoors,Po,M1,DeadlineOpenCloseDoors_) &
    applyTo({[front,M2],[left,M3],[right,M3]},Po,M1) &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16.

:- dec_p_type(
     timedAspects_make_DoorClosed(
       rpb,rpb,bool,bool,bool,int,rpi,rpi,rpb,rpi,rpi)).
timedAspects_make_DoorClosed(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineOpenCloseDoors,
    DeadlineUnlockLockDoorsCylinders,
    Door_closed_p_,
    DeadlineOpenCloseDoors_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  dec(M,int) &
  applyTo(Door_closed_p,Po,false) &
  applyTo(Door_open_p,Po,false) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  applyTo(DeadlineOpenCloseDoors,Po,CurrentTime) &
  foplus(Door_closed_p,Po,true,Door_closed_p_) &
  foplus(DeadlineOpenCloseDoors,Po,0,DeadlineOpenCloseDoors_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,M,DeadlineUnlockLockDoorsCylinders_
  ) &
    M is CurrentTime + 4.

:- dec_p_type(
     timedAspects_LockGearCylinder(
       sp,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_LockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    Gear_cylinder_locked_p_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Extend_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Retract_EV_p = true
  ) &
  applyTo(DeadlineUnlockLockGearsCylinders,front,CurrentTime) &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,0,DeadlineUnlockLockGearsCylinders_
  ).

:- dec_p_type(
     timedAspects_UnlockDoorCylinder(sp,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_UnlockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockDoorsCylinders,
    Door_cylinder_locked_p_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,true) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  applyTo(DeadlineUnlockLockDoorsCylinders,Po,CurrentTime) &
  foplus(Door_cylinder_locked_p,Po,false,Door_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,0,DeadlineUnlockLockDoorsCylinders_
  ).

:- dec_p_type(
     timedAspects_LockDoorCylinder(sp,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_LockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    CurrentTime,
    DeadlineUnlockLockDoorsCylinders,
    Door_cylinder_locked_p_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_cylinder_locked_p,Po,false) &
  applyTo(Door_closed_p,Po,true) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  applyTo(DeadlineUnlockLockDoorsCylinders,Po,CurrentTime) &
  foplus(Door_cylinder_locked_p,Po,true,Door_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockDoorsCylinders,Po,0,DeadlineUnlockLockDoorsCylinders_
  ).

:- dec_p_type(
     timedAspects_UnlockGearCylinder(
       sp,rpb,rpb,rpb,rpb,bool,bool,bool,int,rpi,rpb,rpi)).
timedAspects_UnlockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    CurrentTime,
    DeadlineUnlockLockGearsCylinders,
    Gear_cylinder_locked_p_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,true) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Door_open_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Retract_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Extend_EV_p = true
  ) &
  applyTo(DeadlineUnlockLockGearsCylinders,Po,CurrentTime) &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_) &
  foplus(
    DeadlineUnlockLockGearsCylinders,Po,0,DeadlineUnlockLockGearsCylinders_
  ).

:- dec_p_type(timedAspects_Pressurize_HydrolicCircuit(bool,bool,bool)).
timedAspects_Pressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = false &
  General_EV_p = true &
  Circuit_pressurized_p_ = true.

:- dec_p_type(timedAspects_Unpressurize_HydrolicCircuit(bool,bool,bool)).
timedAspects_Unpressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = true &
  General_EV_p = false &
  Circuit_pressurized_p_ = false.

:- dec_p_type(timedAspects_MakeGearShockAbsorberFalse(sp,rpb,rpb)).
timedAspects_MakeGearShockAbsorberFalse(
    PositionsDG,
    Gear_shock_absorber_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,true) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(timedAspects_MakeGearShockAbsorberTRUE(sp,rpb,rpb,posh,bool,rpb)).
timedAspects_MakeGearShockAbsorberTRUE(
    PositionsDG,
    Gear_ext_p,
    Gear_shock_absorber_p,
    Handle_p,
    GreenLight_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,false) &
  applyTo(Gear_ext_p,Po,true) &
  Handle_p = down &
  GreenLight_p = true &
  foplus(Gear_shock_absorber_p,Po,true,Gear_shock_absorber_p_).

:- dec_p_type(timedAspects_MakeGeneralValveActive(bool,bool,int,int,bool,int)).
timedAspects_MakeGeneralValveActive(
    General_EV_p,
    General_EV,
    CurrentTime,
    DeadlineStimulationGeneralEv,
    General_EV_p_,
    DeadlineStimulationGeneralEv_
) :-
  General_EV_p = false &
  General_EV = true &
  CurrentTime = DeadlineStimulationGeneralEv &
  General_EV_p_ = true &
  DeadlineStimulationGeneralEv_ is CurrentTime + 10.

:- dec_p_type(timedAspects_MakeGeneralValveNoActive(bool,bool,int,int,bool,int)).
timedAspects_MakeGeneralValveNoActive(
    General_EV_p,
    General_EV,
    CurrentTime,
    DeadlineStimulationGeneralEv,
    General_EV_p_,
    DeadlineStimulationGeneralEv_
) :-
  General_EV_p = true &
  General_EV = false &
  CurrentTime = DeadlineStimulationGeneralEv &
  General_EV_p_ = false &
  DeadlineStimulationGeneralEv_ = 0.


:- dec_p_type(
     timedAspects_MakeOpenDoorValveActive(sp,bool,bool,bool,int,bool,int,rpi)).
timedAspects_MakeOpenDoorValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Open_EV_p,
    Open_EV,
    CurrentTime,
    Open_EV_p_,
    DeadlineStimulationOpenCloseEv_,
    DeadlineUnlockLockDoorsCylinders_
) :-
  dec(M,int) &
  Open_EV_p = false &
  Circuit_pressurized_p = true &
  Open_EV = true &
  Open_EV_p_ = true &
  DeadlineStimulationOpenCloseEv_ = 0 &
  DeadlineUnlockLockDoorsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     timedAspects_MakeOpenDoorValveNoActive(bool,bool,int,int,bool,int)).
timedAspects_MakeOpenDoorValveNoActive(
    Open_EV_p,
    Open_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Open_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Open_EV_p = true &
  Open_EV = false &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Open_EV_p_ = false &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     timedAspects_MakeCloseDoorValveActive(bool,bool,bool,int,int,bool,int)).
timedAspects_MakeCloseDoorValveActive(
    Circuit_pressurized_p,
    Close_EV_p,
    Close_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Close_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Close_EV_p = false &
  Circuit_pressurized_p = true &
  Close_EV = true &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Close_EV_p_ = true &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     timedAspects_MakeCloseDoorValveNoActive(bool,bool,int,int,bool,int)).
timedAspects_MakeCloseDoorValveNoActive(
    Close_EV_p,
    Close_EV,
    CurrentTime,
    DeadlineStimulationOpenCloseEv,
    Close_EV_p_,
    DeadlineStimulationOpenCloseEv_
) :-
  Close_EV_p = true &
  Close_EV = false &
  CurrentTime = DeadlineStimulationOpenCloseEv &
  Close_EV_p_ = false &
  DeadlineStimulationOpenCloseEv_ = 0.
  
:- dec_p_type(
     timedAspects_MakeExtendGearValveActive(
       sp,bool,bool,bool,int,int,bool,int,rpi)).
timedAspects_MakeExtendGearValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Extend_EV_p,
    Extend_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Extend_EV_p_,
    DeadlineStimulationRetExtEv_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(M,int) &
  Extend_EV_p = false &
  Circuit_pressurized_p = true &
  Extend_EV = true &
  CurrentTime = DeadlineStimulationRetExtEv &
  Extend_EV_p_ = true &
  DeadlineStimulationRetExtEv_ = 0 &
  DeadlineUnlockLockGearsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     timedAspects_MakeExtendGearValveNoActive(bool,bool,int,int,bool,int)).
timedAspects_MakeExtendGearValveNoActive(
    Extend_EV_p,
    Extend_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Extend_EV_p_,
    DeadlineStimulationRetExtEv_
) :-
  Extend_EV_p = true &
  Extend_EV = false &
  CurrentTime = DeadlineStimulationRetExtEv &
  Extend_EV_p_ = false &
  DeadlineStimulationRetExtEv_ = 0.
  
:- dec_p_type(
     timedAspects_MakeRetractGearValveActive(
       sp,bool,bool,bool,int,int,bool,int,rpi)).
timedAspects_MakeRetractGearValveActive(
    PositionsDG,
    Circuit_pressurized_p,
    Retract_EV_p,
    Retract_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Retract_EV_p_,
    DeadlineStimulationRetExtEv_,
    DeadlineUnlockLockGearsCylinders_
) :-
  dec(M,int) &
  Retract_EV_p = false &
  Circuit_pressurized_p = true &
  Retract_EV = true &
  CurrentTime = DeadlineStimulationRetExtEv &
  Retract_EV_p_ = true &
  DeadlineStimulationRetExtEv_ = 0 &
  DeadlineUnlockLockGearsCylinders_ = cp(PositionsDG,{M}) &
    M is CurrentTime + 4.
  
:- dec_p_type(
     timedAspects_MakeRetractGearValveNoActive(bool,bool,int,int,bool,int)).
timedAspects_MakeRetractGearValveNoActive(
    Retract_EV_p,
    Retract_EV,
    CurrentTime,
    DeadlineStimulationRetExtEv,
    Retract_EV_p_,
    DeadlineStimulationRetExtEv_
) :-
  Retract_EV_p = true &
  Retract_EV = false &
  CurrentTime = DeadlineStimulationRetExtEv &
  Retract_EV_p_ = false &
  DeadlineStimulationRetExtEv_ = 0.
  
:- dec_p_type(timedAspects_PutHandleUp(posh,posh,bool)).
timedAspects_PutHandleUp(
    Handle_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = down &
  Handle_p_ = up &
  Handle_ = true.

:- dec_p_type(timedAspects_PutHandleDown(posh,bool,posh,bool)).
timedAspects_PutHandleDown(
    Handle_p,
    GreenLight_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = up &
  GreenLight_p = false &
  Handle_p_ = down &
  Handle_ = true.

:- dec_p_type(timedAspects_close_Switch(bool,int,int,poss,bool,int)).
timedAspects_close_Switch(
    Intermediate1,
    CurrentTime,
    DeadlineSwitch,
    Analogical_switch_p_,
    Intermediate1_,
    DeadlineSwitch_
) :-
  Intermediate1 = true &
  CurrentTime = DeadlineSwitch &
  Analogical_switch_p_ = closed &
  Intermediate1_ = false &
  DeadlineSwitch_ is CurrentTime + 200.

:- dec_p_type(timedAspects_HandleOnClosed(poss,bool,int,bool,int)).
timedAspects_HandleOnClosed(
    Analogical_switch_p,
    Handle,
    CurrentTime,
    Handle_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = closed &
  Handle = true &
  Handle_ = false &
  DeadlineSwitch_ is CurrentTime + 200.

:- dec_p_type(timedAspects_FromCloseToIntermediate2(poss,int,int,poss,bool,int)).
timedAspects_FromCloseToIntermediate2(
    Analogical_switch_p,
    CurrentTime,
    DeadlineSwitch,
    Analogical_switch_p_,
    Intermediate2_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = closed &
  DeadlineSwitch = CurrentTime &
  Intermediate2_ = true &
  Analogical_switch_p_ = open &
  DeadlineSwitch_ is CurrentTime + 12.

:- dec_p_type(
     timedAspects_HandleFromOpenToIntermediate1(
       poss,bool,bool,bool,int,bool,bool,int)).
timedAspects_HandleFromOpenToIntermediate1(
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    CurrentTime,
    Intermediate1_,
    Handle_,
    DeadlineSwitch_
) :-
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = true &
  Intermediate1_ = true &
  Handle_ = false &
  DeadlineSwitch_ is CurrentTime + 8.

:- dec_p_type(
     timedAspects_HandleFromIntermediate2ToIntermediate1(
       bool,bool,int,int,bool,bool,bool,int)).
timedAspects_HandleFromIntermediate2ToIntermediate1(
    Intermediate2,
    Handle,
    CurrentTime,
    DeadlineSwitch,
    Intermediate1_,
    Intermediate2_,
    Handle_,
    DeadlineSwitch_
) :-
  dec([M1,M2],int) &
  Intermediate2 = true &
  Handle = true &
  Handle_ = false &
  Intermediate2_ = false &
  Intermediate1_ = true &
  M1 = M2 &
    M1 is 3*DeadlineSwitch_ &
    M2 is 3*CurrentTime + (3*8 - 2*(DeadlineSwitch - CurrentTime)).
%  DeadlineSwitch_ = 
%    CurrentTime + (8 - ( 2 rdiv 3) * (DeadlineSwitch - CurrentTime)).

:- dec_p_type(timedAspects_ReadHandleSwitchCircuit(sph,sps,posh,poss,bool,bool)).
timedAspects_ReadHandleSwitchCircuit(
    PositionsHandle,
    PositionsSwitch,
    Handle_ind_,
    Analogical_switch_ind_,
    Circuit_pressurized_ind_,
    End_cycle_
) :-
  dec(Handle_sensor_value,posh) &
  dec(Analogical_switch_sensor_value,poss) &
  dec(Circuit_pressurized_sensor_value,bool) &
  Handle_sensor_value in PositionsHandle &
  Analogical_switch_sensor_value in PositionsSwitch &
  Handle_ind_ = Handle_sensor_value &
  Analogical_switch_ind_ = Analogical_switch_sensor_value &
  Circuit_pressurized_ind_ = Circuit_pressurized_sensor_value &
  End_cycle_ = false.

:- dec_p_type(
     timedAspects_ReadGearsShock(rpb,rpb,rpb,rpb,rpb,rpb,rpb,bool,bool,bool)).
timedAspects_ReadGearsShock(
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Gear_shock_absorber_p,
    Gear_extended_ind_,
    Gear_retracted_ind_,
    Gear_shock_absorber_ind_,
    Gears_locked_down_,
    Gears_maneuvering_,
    End_cycle_
) :-
  dec([Gear_extended_sensor_valueF,
       Gear_extended_sensor_valueL,
       Gear_extended_sensor_valueR,
       Gear_retracted_sensor_valueF,
       Gear_retracted_sensor_valueL,
       Gear_retracted_sensor_valueR,
       Gear_shock_absorber_sensor_valueF,
       Gear_shock_absorber_sensor_valueL,
       Gear_shock_absorber_sensor_valueR],bool) &
  (Gear_extended_sensor_valueF = true
     implies
       applyTo(Gear_ext_p,front,true) &
       applyTo(Gear_cylinder_locked_p,front,true)
  ) &
  (Gear_extended_sensor_valueL = true
     implies
       applyTo(Gear_ext_p,left,true) &
       applyTo(Gear_cylinder_locked_p,left,true)
  ) &
  (Gear_extended_sensor_valueR = true
     implies
       applyTo(Gear_ext_p,right,true) &
       applyTo(Gear_cylinder_locked_p,right,true)
  ) &
  (Gear_retracted_sensor_valueF = true
     implies
       applyTo(Gear_ret_p,front,true) &
       applyTo(Gear_cylinder_locked_p,front,true)
  ) &
  (Gear_retracted_sensor_valueL = true
     implies
       applyTo(Gear_ret_p,left,true) &
       applyTo(Gear_cylinder_locked_p,left,true)
  ) &
  (Gear_retracted_sensor_valueR = true
     implies
       applyTo(Gear_ret_p,right,true) &
       applyTo(Gear_cylinder_locked_p,right,true)
  ) &
  (Gear_shock_absorber_sensor_valueF = false
     implies
       applyTo(Gear_shock_absorber_p,front,false)
  ) &
  (Gear_shock_absorber_sensor_valueL = false
     implies
       applyTo(Gear_shock_absorber_p,left,false)
  ) &
  Gear_extended_ind_ = 
    {[front,Gear_extended_sensor_valueF],
     [left,Gear_extended_sensor_valueL],
     [right,Gear_extended_sensor_valueR]} &
  Gear_retracted_ind_ = 
    {[front,Gear_retracted_sensor_valueF],
     [left,Gear_retracted_sensor_valueL],
     [right,Gear_retracted_sensor_valueR]} &
  Gear_shock_absorber_ind_ = 
    {[front,Gear_shock_absorber_sensor_valueF],
     [left,Gear_shock_absorber_sensor_valueL],
     [right,Gear_shock_absorber_sensor_valueR]} &
  bool(
    Gears_locked_down_,
    Gear_extended_sensor_valueF = true &
    Gear_extended_sensor_valueL = true &
    Gear_extended_sensor_valueR = true
  ) &
  bool(
    Gears_maneuvering_,
    Gear_extended_sensor_valueF = false &
    Gear_retracted_sensor_valueF = false
    or
    Gear_extended_sensor_valueL = false &
    Gear_retracted_sensor_valueL = false
    or
    Gear_extended_sensor_valueR = false &
    Gear_retracted_sensor_valueR = false
  ) &
  End_cycle_ = false.

:- dec_p_type(timedAspects_ReadDoors(rpb,rpb,rpb,rpb,bool)).
timedAspects_ReadDoors(
    Door_open_p,
    Door_closed_p,
    Door_open_ind_,
    Door_closed_ind_,
    End_cycle_
) :-
  dec([Door_open_sensor_valueF,
       Door_open_sensor_valueL,
       Door_open_sensor_valueR,
       Door_closed_sensor_valueF,
       Door_closed_sensor_valueL,
       Door_closed_sensor_valueR],bool) &
  (Door_open_sensor_valueF = true implies applyTo(Door_open_p,front,true)) &
  (Door_open_sensor_valueL = true implies applyTo(Door_open_p,left,true)) &
  (Door_open_sensor_valueR = true implies applyTo(Door_open_p,right,true)) &
  (Door_closed_sensor_valueF = true implies applyTo(Door_closed_p,front,true)) &
  (Door_closed_sensor_valueL = true implies applyTo(Door_closed_p,left,true)) &
  (Door_closed_sensor_valueR = true implies applyTo(Door_closed_p,right,true)) &
  Door_open_ind_ = 
    {[front,Door_open_sensor_valueF],
     [left,Door_open_sensor_valueL],
     [right,Door_open_sensor_valueR]} &
  Door_closed_ind_ = 
    {[front,Door_closed_sensor_valueF],
     [left,Door_closed_sensor_valueL],
     [right,Door_closed_sensor_valueR]} &
  End_cycle_ = false.

:- dec_p_type(timedAspects_open_Switch(bool,bool,int)).
timedAspects_open_Switch(
    Intermediate2,
    Intermediate2_,
    DeadlineSwitch_
) :-
  Intermediate2 = true &
  Intermediate2_ = false &
  DeadlineSwitch_ = 0.

:- dec_p_type(timedAspects_MakeGreenLightActive(bool,bool,bool)).
timedAspects_MakeGreenLightActive(
    GreenLight_p,
    Gears_locked_down,
    GreenLight_p_
) :-
  GreenLight_p = false &
  Gears_locked_down = true &
  GreenLight_p_ = true.
  
:- dec_p_type(timedAspects_MakeGreenLightNoActive(bool,bool,bool)).
timedAspects_MakeGreenLightNoActive(
    GreenLight_p,
    Gears_locked_down,
    GreenLight_p_
) :-
  GreenLight_p = true &
  Gears_locked_down = false &
  GreenLight_p_ = false.
  
:- dec_p_type(timedAspects_MakeOrangeLightActive(bool,bool,bool)).
timedAspects_MakeOrangeLightActive(
    OrangeLight_p,
    Gears_maneuvering,
    OrangeLight_p_
) :-
  OrangeLight_p = false &
  Gears_maneuvering = true &
  OrangeLight_p_ = true.
  
:- dec_p_type(timedAspects_MakeOrangeLightNoActive(bool,bool,bool)).
timedAspects_MakeOrangeLightNoActive(
    OrangeLight_p,
    Gears_maneuvering,
    OrangeLight_p_
) :-
  OrangeLight_p = true &
  Gears_maneuvering neq true &
  OrangeLight_p_ = false.
  
:- dec_p_type(timedAspects_MakeRedLightActive(bool,bool)).
timedAspects_MakeRedLightActive(
    RedLight_p,
    RedLight_p_
) :-
  RedLight_p = false &
  RedLight_p_ = true.
  
:- dec_p_type(
     timedAspects_OutputGEV(
       sp,poss,posh,rpb,rpb,bool,bool,bool,int,int,int,rpb,bool,bool,int,int)).
timedAspects_OutputGEV(
    PositionsDG,
    Analogical_switch_ind,
    Handle_ind,
    Gear_extended_ind,
    Gear_retracted_ind,
    Open_EV,
    Close_EV,
    General_EV,
    CurrentTime,
    AllowedStopGeneralEv,
    AllowedStartOpenEv,
    Door_closed_ind,
    General_EV_,
    End_cycle_,
    DeadlineStimulationGeneralEv_,
    AllowedStartOpenEv_
) :-
  dec(General_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    General_EV_value,
    Analogical_switch_ind = closed &
    (Handle_ind = down & 
     Gear_extended_ind neq cp(PositionsDG,{true})
     or
     Handle_ind = up &
     Gear_retracted_ind neq cp(PositionsDG,{true})
    )
    or
    Door_closed_ind neq cp(PositionsDG,{true})
    or
    Open_EV = true 
    or
    Close_EV = true
  ) &
  General_EV_value neq General_EV &
  CurrentTime >= AllowedStopGeneralEv &
  General_EV_ = General_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M1],[[true,false],M2]},
    [General_EV,General_EV_value],
    DeadlineStimulationGeneralEv_
  ) &
    M1 is CurrentTime + 10 &
    M2 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M3],[[true,false],AllowedStartOpenEv]},
    [General_EV,General_EV_value],
    AllowedStartOpenEv_
  ) &
    M3 is CurrentTime + 2.

:- dec_p_type(
    timedAspects_OutputOpenEV(
      sp,bool,bool,bool,bool,bool,posh,rpb,rpb,int,int,int,int,bool,bool,int,
      int,int)).
timedAspects_OutputOpenEV(
    PositionsDG,
    Close_EV,
    Open_EV,
    General_EV,
    Extend_EV,
    Retract_EV,
    Handle_ind,
    Gear_retracted_ind,
    Gear_extended_ind,
    CurrentTime,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStopGeneralEv,
    Open_EV_,
    End_cycle_,
    AllowedStartCloseEv_,
    DeadlineStimulationOpenCloseEv_,
    AllowedStopGeneralEv_
) :-
  dec(Open_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Open_EV_value,
    Close_EV = false &
    General_EV = true &
    (Handle_ind = up &
     Gear_retracted_ind neq cp(PositionsDG,{true})
     or
     Handle_ind = down &
     Gear_extended_ind neq cp(PositionsDG,{true})
    )
    or
    Extend_EV = true 
    or
    Retract_EV = true
  ) &
  Open_EV neq Open_EV_value &
  CurrentTime >= AllowedStartOpenEv &
  Open_EV_ = Open_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartCloseEv]},
    [Open_EV,Open_EV_value],
    AllowedStartCloseEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Open_EV,Open_EV_value],
    DeadlineStimulationOpenCloseEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Open_EV,Open_EV_value],
    AllowedStopGeneralEv_
  ).

:- dec_p_type(
     timedAspects_OutputCloseEv(
       sp,posh,rpb,rpb,rpb,bool,bool,bool,bool,bool,int,int,int,int,bool,bool,
       int,int,int)).
timedAspects_OutputCloseEv(
    PositionsDG,
    Handle_ind,
    Gear_retracted_ind,
    Gear_extended_ind,
    Door_closed_ind,
    General_EV,
    Extend_EV,
    Retract_EV,
    Open_EV,
    Close_EV,
    CurrentTime,
    AllowedStartOpenEv,
    AllowedStartCloseEv,
    AllowedStopGeneralEv,
    Close_EV_,
    End_cycle_,
    AllowedStartOpenEv_,
    DeadlineStimulationOpenCloseEv_,
    AllowedStopGeneralEv_
) :-
  dec(Close_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Close_EV_value,
    (Handle_ind = up &
     Gear_retracted_ind = cp(PositionsDG,{true})
     or
     Handle_ind = down &
     Gear_extended_ind = cp(PositionsDG,{true})
    ) &
    Door_closed_ind neq cp(PositionsDG,{true}) &
    General_EV = true &
    Extend_EV = false &
    Retract_EV = false &
    Open_EV = false
  ) &
  Close_EV neq Close_EV_value &
  CurrentTime >= AllowedStartCloseEv &
  Close_EV_ = Close_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Close_EV,Close_EV_value],
    DeadlineStimulationOpenCloseEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartOpenEv]},
    [Close_EV,Close_EV_value],
    AllowedStartOpenEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Close_EV,Close_EV_value],
    AllowedStopGeneralEv_
  ).

:- dec_p_type(
     timedAspects_OutputExtendEV(
       sp,posh,rpb,rpb,bool,bool,bool,int,int,int,int,bool,bool,int,int,int)).
timedAspects_OutputExtendEV(
    PositionsDG,
    Handle_ind,
    Gear_extended_ind,
    Door_open_ind,
    Open_EV,
    Retract_EV,
    Extend_EV,
    CurrentTime,
    AllowedStartExtEv,
    AllowedStartRetEv,
    AllowedStopGeneralEv,
    Extend_EV_,
    End_cycle_,
    DeadlineStimulationRetExtEv_,
    AllowedStartRetEv_,
    AllowedStopGeneralEv_
) :-
  dec(Extend_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Extend_EV_value,
    Handle_ind = down &
    Gear_extended_ind neq cp(PositionsDG,{true}) &
    Open_EV = true &
    Door_open_ind = cp(PositionsDG,{true}) &
    Retract_EV = false
  ) &
  Extend_EV neq Extend_EV_value &
  CurrentTime >= AllowedStartExtEv &
  Extend_EV_ = Extend_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Extend_EV,Extend_EV_value],
    DeadlineStimulationRetExtEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartRetEv]},
    [Extend_EV,Extend_EV_value],
    AllowedStartRetEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Extend_EV,Extend_EV_value],
    AllowedStopGeneralEv_
  ).

:- dec_p_type(
     timedAspects_OutputRetractEV(
       sp,posh,rpb,rpb,rpb,bool,bool,bool,int,int,int,int,bool,bool,int,int,
       int)).
timedAspects_OutputRetractEV(
    PositionsDG,
    Handle_ind,
    Gear_retracted_ind,
    Door_open_ind,
    Gear_shock_absorber_ind,
    Open_EV,
    Extend_EV,
    Retract_EV,
    CurrentTime,
    AllowedStartExtEv,
    AllowedStartRetEv,
    AllowedStopGeneralEv,
    Retract_EV_,
    End_cycle_,
    DeadlineStimulationRetExtEv_,
    AllowedStartExtEv_,
    AllowedStopGeneralEv_
) :-
  dec(Retract_EV_value,bool) &
  dec([M1,M2,M3],int) &
  bool(
    Retract_EV_value,
    Handle_ind = up &
    Gear_retracted_ind neq cp(PositionsDG,{true}) &
    Open_EV = true &
    Extend_EV = false &
    Door_open_ind = cp(PositionsDG,{true}) &
    Gear_shock_absorber_ind = cp(PositionsDG,{false})
  ) &
  Retract_EV neq Retract_EV_value &
  CurrentTime >= AllowedStartRetEv &
  Retract_EV_ = Retract_EV_value &
  End_cycle_ = true &
  applyTo(
    {[[false,true],M2],[[true,false],M3]},
    [Retract_EV,Retract_EV_value],
    DeadlineStimulationRetExtEv_
  ) &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36 &
  applyTo(
    {[[false,true],M1],[[true,false],AllowedStartExtEv]},
    [Retract_EV,Retract_EV_value],
    AllowedStartExtEv_
  ) &
    M1 is CurrentTime + 2 &
  applyTo(
    {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
    [Retract_EV,Retract_EV_value],
    AllowedStopGeneralEv_
  ).

:- dec_p_type(timedAspects_passingTime(int,int,int,int,rpi,rpi,rpi,rpi,int,int)).
timedAspects_passingTime(
    DeadlineSwitch,
    DeadlineStimulationGeneralEv,
    DeadlineStimulationOpenCloseEv,
    DeadlineStimulationRetExtEv,
    DeadlineOpenCloseDoors,
    DeadlineUnlockLockDoorsCylinders,
    DeadlineUnlockLockGearsCylinders,
    DeadlineGearsRetractingExtending,
    CurrentTime,
    CurrentTime_    
) :-
  dec(Step,int) &
  dec(M1,rpi) &
  dec(M2,stype(int)) &
  dec(M3,int) &
  0 < Step &
  (DeadlineSwitch neq 0
   or
   DeadlineStimulationGeneralEv neq 0
   or
   DeadlineStimulationOpenCloseEv neq 0
   or
   DeadlineStimulationRetExtEv neq 0
   or
   nran(DeadlineOpenCloseDoors,{0})
   or
   nran(DeadlineUnlockLockDoorsCylinders,{0})
   or
   nran(DeadlineUnlockLockGearsCylinders,{0})
   or
   nran(DeadlineGearsRetractingExtending,{0})
  ) &
  (DeadlineSwitch = 0 implies CurrentTime + Step =< DeadlineSwitch) &
  (DeadlineStimulationGeneralEv neq 0 
     implies 
       CurrentTime + Step =< DeadlineStimulationGeneralEv
  ) &
  (DeadlineStimulationOpenCloseEv neq 0
     implies
       CurrentTime + Step =< DeadlineStimulationOpenCloseEv
  ) &
  (DeadlineStimulationRetExtEv neq 0
     implies
       CurrentTime + Step =< DeadlineStimulationRetExtEv
  ) &
delay(
  (nran(DeadlineOpenCloseDoors,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineOpenCloseDoors,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineUnlockLockDoorsCylinders,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineUnlockLockDoorsCylinders,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineUnlockLockGearsCylinders,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineUnlockLockGearsCylinders,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  ) &
  (nran(DeadlineGearsRetractingExtending,{0})
     implies
       CurrentTime + Step =< M3 &
         rares(DeadlineGearsRetractingExtending,{0},M1) &
         ran(M1,M2) &
         qsetmin(M2,M3)
  )
,false) &
  CurrentTime_ is CurrentTime + Step.

