% Proof obligations of 

% MACHINE ValvesLights

% Run check_valvesLights

:- dec_p_type(valvesLights_init_inv2).
valvesLights_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  valvesLights_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    General_EV_p,
    Open_EV_p,
    Close_EV_p,
    Extend_EV_p,
    Retract_EV_p,
    GreenLight_p,
    OrangeLight_p,
    RedLight_p
  ) &
  valvesLights_inv2(Open_EV_p,Close_EV_p).

:- dec_p_type(valvesLights_init_inv3).
valvesLights_init_inv3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  valvesLights_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    General_EV_p,
    Open_EV_p,
    Close_EV_p,
    Extend_EV_p,
    Retract_EV_p,
    GreenLight_p,
    OrangeLight_p,
    RedLight_p
  ) &
  valvesLights_inv3(Extend_EV_p,Retract_EV_p).

:- dec_p_type(valvesLights_UnlockGearCylinder_grd6).
valvesLights_UnlockGearCylinder_grd6 :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Retract_EV_p,bool) &
  neg(
    gears_inv1(PositionsDG,Gear_ext_p) &
    gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_ext_p,{}) &
        pfun(Gear_ext_p) &
        (applyTo(Gear_ext_p,Po,true) &
         Retract_EV_p = true 
         or
         ncomp({[Po,Po]},Gear_ret_p,{}) &
         pfun(Gear_ret_p)
        )
  ).

:- dec_p_type(valvesLights_LockGearCylinder_grd5).
valvesLights_LockGearCylinder_grd5 :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Extend_EV_p,bool) &
  neg(
    gears_inv1(PositionsDG,Gear_ext_p) &
    gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_ext_p,{}) &
        pfun(Gear_ext_p) &
        (applyTo(Gear_ext_p,Po,true) &
         Extend_EV_p = true 
         or
         ncomp({[Po,Po]},Gear_ret_p,{}) &
         pfun(Gear_ret_p)
        )
  ).

:- dec_p_type(n_valvesLights_inv2(bool,bool)).
n_valvesLights_inv2(Open_EV_p,Close_EV_p) :-
  neg(
    Open_EV_p in {false,true} &
    Close_EV_p in {false,true}
  ).

:- dec_p_type(valvesLights_MakeOpenDoorValveActive_inv2).
valvesLights_MakeOpenDoorValveActive_inv2 :-
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p,Open_EV_p_],bool) &
  neg(
    valvesLights_inv2(Open_EV_p,Close_EV_p) &
    valvesLights_MakeOpenDoorValveActive(
      Circuit_pressurized_p,
      Open_EV_p,
      Open_EV_p_
    )
      implies
        valvesLights_inv2(Open_EV_p_,Close_EV_p)
  ).

:- dec_p_type(valvesLights_MakeOpenDoorValveNoActive_inv2).
valvesLights_MakeOpenDoorValveNoActive_inv2 :-
  dec([Open_EV_p,Close_EV_p,Open_EV_p_],bool) &
  neg(
    valvesLights_inv2(Open_EV_p,Close_EV_p) &
    valvesLights_MakeOpenDoorValveNoActive(
      Open_EV_p,
      Open_EV_p_
    )
      implies
        valvesLights_inv2(Open_EV_p_,Close_EV_p)
  ).

:- dec_p_type(valvesLights_MakeCloseDoorValveActive_inv2).
valvesLights_MakeCloseDoorValveActive_inv2 :-
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p,Close_EV_p_],bool) &
  neg(
    valvesLights_inv2(Open_EV_p,Close_EV_p) &
    valvesLights_MakeCloseDoorValveActive(
      Circuit_pressurized_p,
      Close_EV_p,
      Close_EV_p_
    )
      implies
        valvesLights_inv2(Open_EV_p,Close_EV_p_)
  ).

:- dec_p_type(valvesLights_MakeCloseDoorValveNoActive_inv2).
valvesLights_MakeCloseDoorValveNoActive_inv2 :-
  dec([Open_EV_p,Close_EV_p,Close_EV_p_],bool) &
  neg(
    valvesLights_inv2(Open_EV_p,Close_EV_p) &
    valvesLights_MakeCloseDoorValveNoActive(
      Close_EV_p,
      Close_EV_p_
    )
      implies
        valvesLights_inv2(Open_EV_p,Close_EV_p_)
  ).

:- dec_p_type(n_valvesLights_inv3(bool,bool)).
n_valvesLights_inv3(Extend_EV_p,Retract_EV_p) :-
  neg(
    Extend_EV_p in {false,true} &
    Retract_EV_p in {false,true}
  ).

:- dec_p_type(valvesLights_MakeExtendGearValveActive_inv3).
valvesLights_MakeExtendGearValveActive_inv3 :-
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p,Extend_EV_p_],bool) &
  neg(
    valvesLights_inv3(Extend_EV_p,Retract_EV_p) &
    valvesLights_MakeExtendGearValveActive(
      Circuit_pressurized_p,
      Extend_EV_p,
      Extend_EV_p_
    )
      implies
        valvesLights_inv3(Extend_EV_p_,Retract_EV_p)
  ).

:- dec_p_type(valvesLights_MakeExtendGearValveNoActive_inv3).
valvesLights_MakeExtendGearValveNoActive_inv3 :-
  dec([Extend_EV_p,Retract_EV_p,Extend_EV_p_],bool) &
  neg(
    valvesLights_inv3(Extend_EV_p,Retract_EV_p) &
    valvesLights_MakeExtendGearValveNoActive(
      Extend_EV_p,
      Extend_EV_p_
    )
      implies
        valvesLights_inv3(Extend_EV_p_,Retract_EV_p)
  ).

:- dec_p_type(valvesLights_MakeRetractGearValveActive_inv3).
valvesLights_MakeRetractGearValveActive_inv3 :-
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p,Retract_EV_p_],bool) &
  neg(
    valvesLights_inv3(Extend_EV_p,Retract_EV_p) &
    valvesLights_MakeRetractGearValveActive(
      Circuit_pressurized_p,
      Retract_EV_p,
      Retract_EV_p_
    )
      implies
        valvesLights_inv3(Extend_EV_p,Retract_EV_p_)
  ).

:- dec_p_type(valvesLights_MakeRetractGearValveNoActive_inv3).
valvesLights_MakeRetractGearValveNoActive_inv3 :-
  dec([Extend_EV_p,Retract_EV_p,Retract_EV_p_],bool) &
  neg(
    valvesLights_inv3(Extend_EV_p,Retract_EV_p) &
    valvesLights_MakeRetractGearValveNoActive(
      Retract_EV_p,
      Retract_EV_p_
    )
      implies
        valvesLights_inv3(Extend_EV_p,Retract_EV_p_)
  ).


:- dec_p_type(check_valvesLights).
check_valvesLights :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking valvesLights_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     valvesLights_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking valvesLights_init_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     valvesLights_init_inv3 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_UnlockGearCylinder_grd6...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_UnlockGearCylinder_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_LockGearCylinder_grd5...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_LockGearCylinder_grd5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeOpenDoorValveActive_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeOpenDoorValveActive_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeOpenDoorValveNoActive_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeOpenDoorValveNoActive_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeCloseDoorValveActive_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeCloseDoorValveActive_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeCloseDoorValveNoActive_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeCloseDoorValveNoActive_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeExtendGearValveActive_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeExtendGearValveActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeExtendGearValveNoActive_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeExtendGearValveNoActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeRetractGearValveActive_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeRetractGearValveActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking valvesLights_MakeRetractGearValveNoActive_inv3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(valvesLights_MakeRetractGearValveNoActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 12) discharged in ') &
     write(T) & write(' seconds') & nl
  ).





