% MACHINE ValvesLights

:- dec_p_type(valvesLights_inv1(bool)).
valvesLights_inv1(General_EV_p) :-
  General_EV_p in {false,true}.

:- dec_p_type(valvesLights_inv2(bool,bool)).
valvesLights_inv2(Open_EV_p,Close_EV_p) :-
  Open_EV_p in {false,true} &
  Close_EV_p in {false,true}.

:- dec_p_type(valvesLights_inv3(bool,bool)).
valvesLights_inv3(Extend_EV_p,Retract_EV_p) :-
  Extend_EV_p in {false,true} &
  Retract_EV_p in {false,true}.

:- dec_p_type(valvesLights_inv4(bool)).
valvesLights_inv4(GreenLight_p) :-
  GreenLight_p in {false,true}.

:- dec_p_type(valvesLights_inv5(bool)).
valvesLights_inv5(OrangeLight_p) :-
  OrangeLight_p in {false,true}.

:- dec_p_type(valvesLights_inv6(bool)).
valvesLights_inv6(RedLight_p) :-
  RedLight_p in {false,true}.

:- dec_p_type(
     valvesLights_init(
       sp,rpb,rpb,rpb,rpb,rpb,rpb,bool,rpb,posh,poss,
       bool,bool,bool,bool,bool,bool,bool,bool,bool,bool,bool)).
valvesLights_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    General_EV_p,
    Open_EV_p,
    Close_EV_p,
    Extend_EV_p,
    Retract_EV_p,
    GreenLight_p,
    OrangeLight_p,
    RedLight_p
) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}) &
  Door_closed_p = cp(PositionsDG,{true}) &
  Door_cylinder_locked_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = false &
  Gear_shock_absorber_p = cp(PositionsDG,{true}) &
  Handle_p = down &
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = false &
  General_EV_p = false &
  Open_EV_p = false &
  Close_EV_p = false &
  Extend_EV_p = false &
  Retract_EV_p = false &
  GreenLight_p = true &
  OrangeLight_p = false &
  RedLight_p = false.

:- dec_p_type(valvesLights_start_GearExtend(sp,rpb,rpb,rpb,bool,bool,rpb,bool)).
valvesLights_start_GearExtend(
    PositionsDG,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ret_p_,
    Circuit_pressurized_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_) &
  Extend_EV_p = true &
  Retract_EV_p = false &
  Circuit_pressurized_p_ = false.

:- dec_p_type(valvesLights_make_GearExtended(sp,rpb,bool,bool,bool,rpb,rpb)).
valvesLights_make_GearExtended(
    PositionsDG,
    Gear_ext_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ret_p,
    Gear_ext_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_).

:- dec_p_type(
     valvesLights_start_GearRetract(sp,rpb,rpb,rpb,rpb,bool,bool,bool,rpb,rpb)).
valvesLights_start_GearRetract(
    PositionsDG,
    Gear_ext_p,
    Door_open_p,
    Gear_shock_absorber_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ext_p_,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  foplus(Gear_ext_p,Po,false,Gear_ext_p_) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(valvesLights_make_GearRetracted(sp,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_make_GearRetracted(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_ret_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  Circuit_pressurized_p = true &
  Extend_EV_p = true &
  Retract_EV_p = false &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_).

:- dec_p_type(valvesLights_start_DoorOpening(rpb,rpb,bool,bool,bool,rpb)).
valvesLights_start_DoorOpening(
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_closed_p_
) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  foplus(Door_closed_p,Po,false,Door_closed_p_).

:- dec_p_type(valvesLights_make_DoorOpen(rpb,rpb,bool,bool,bool,rpb)).
valvesLights_make_DoorOpen(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_open_p_
) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  applyTo(Door_closed_p,Po,false) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  foplus(Door_open_p,Po,true,Door_open_p_).

:- dec_p_type(
     valvesLights_start_DoorClosing(sp,rpb,rpb,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_open_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  Gear_cylinder_locked_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  foplus(Door_open_p,Po,false,Door_open_p_).

:- dec_p_type(valvesLights_make_DoorClosed(rpb,rpb,bool,bool,bool,rpb)).
valvesLights_make_DoorClosed(
    Door_open_p,
    Door_closed_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_closed_p_
) :-
  dec(Po,pos) &
  applyTo(Door_closed_p,Po,false) &
  applyTo(Door_open_p,Po,false) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  foplus(Door_closed_p,Po,true,Door_closed_p_).

:- dec_p_type(
     valvesLights_UnlockGearCylinder(sp,rpb,rpb,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_UnlockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,true) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Door_open_p = cp(PositionsDG,{true}) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Retract_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Extend_EV_p = true
  ) &
  foplus(Gear_cylinder_locked_p,Po,false,Gear_cylinder_locked_p_).

:- dec_p_type(valvesLights_LockGearCylinder(sp,rpb,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_LockGearCylinder(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Extend_EV_p,
    Retract_EV_p,
    Gear_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_cylinder_locked_p,Po,false) &
  (applyTo(Gear_ext_p,Po,true)
   or
   applyTo(Gear_ret_p,Po,true)
  ) &
  Circuit_pressurized_p = true &
  (applyTo(Gear_ext_p,Po,true) &
   Extend_EV_p = true
   or
   applyTo(Gear_ret_p,Po,true) &
   Retract_EV_p = true
  ) &
  foplus(Gear_cylinder_locked_p,Po,true,Gear_cylinder_locked_p_).

:- dec_p_type(valvesLights_UnlockDoorCylinder(sp,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_UnlockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_closed_p,Po,true) &
  applyTo(Door_cylinder_locked_p,Po,true) &
  Circuit_pressurized_p = true &
  Open_EV_p = true &
  Close_EV_p = false &
  foplus(Door_cylinder_locked_p,Po,false,Door_cylinder_locked_p_).

:- dec_p_type(valvesLights_LockDoorCylinder(sp,rpb,rpb,bool,bool,bool,rpb)).
valvesLights_LockDoorCylinder(
    PositionsDG,
    Door_closed_p,
    Door_cylinder_locked_p,
    Circuit_pressurized_p,
    Open_EV_p,
    Close_EV_p,
    Door_cylinder_locked_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Door_cylinder_locked_p,Po,false) &
  applyTo(Door_closed_p,Po,true) &
  Circuit_pressurized_p = true &
  Close_EV_p = true &
  Open_EV_p = false &
  foplus(Door_cylinder_locked_p,Po,true,Door_cylinder_locked_p_).

:- dec_p_type(valvesLights_Pressurize_HydrolicCircuit(bool,bool,bool)).
valvesLights_Pressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = false &
  General_EV_p = true &
  Circuit_pressurized_p_ = true.

:- dec_p_type(valvesLights_Unpressurize_HydrolicCircuit(bool,bool,bool)).
valvesLights_Unpressurize_HydrolicCircuit(
    Circuit_pressurized_p,
    General_EV_p,
    Circuit_pressurized_p_
) :-
  Circuit_pressurized_p = true &
  General_EV_p = false &
  Circuit_pressurized_p_ = false.

:- dec_p_type(valvesLights_Make_GearAbsorberTrue(sp,rpb,rpb,posh,bool,rpb)).
valvesLights_Make_GearAbsorberTrue(
    PositionsDG,
    Gear_ext_p,
    Gear_shock_absorber_p,
    Handle_p,
    GreenLight_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,false) &
  applyTo(Gear_ext_p,Po,true) &
  Handle_p = down &
  GreenLight_p = true &
  foplus(Gear_shock_absorber_p,Po,true,Gear_shock_absorber_p_).

:- dec_p_type(valvesLights_Make_GearAbsorberFalse(sp,rpb,rpb)).
valvesLights_Make_GearAbsorberFalse(
    PositionsDG,
    Gear_shock_absorber_p,
    Gear_shock_absorber_p_
) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_shock_absorber_p,Po,true) &
  foplus(Gear_shock_absorber_p,Po,false,Gear_shock_absorber_p_).

:- dec_p_type(valvesLights_PutHandleUp(posh,posh,bool)).
valvesLights_PutHandleUp(
    Handle_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = down &
  Handle_p_ = up &
  Handle_ = true.

:- dec_p_type(handleSwitchShockAbsorber_PutHandleDown(posh,bool,posh,bool)).
handleSwitchShockAbsorber_PutHandleDown(
    Handle_p,
    GreenLight_p,
    Handle_p_,
    Handle_
) :-
  Handle_p = up &
  GreenLight_p = false &
  Handle_p_ = down &
  Handle_ = true.

:- dec_p_type(
     valvesLights_HandleFromOpenToIntermediate1(poss,bool,bool,bool,bool,bool)).
valvesLights_HandleFromOpenToIntermediate1(
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle,
    Intermediate1_,
    Handle_
) :-
  Analogical_switch_p = open &
  Intermediate1 = false &
  Intermediate2 = false &
  Handle = true &
  Intermediate1_ = true &
  Handle_ = false.

:- dec_p_type(valvesLights_close_Switch(bool,poss,bool)).
valvesLights_close_Switch(
    Intermediate1,
    Analogical_switch_p_,
    Intermediate1_
) :-
  Intermediate1 = true &
  Analogical_switch_p_ = closed &
  Intermediate1_ = false.

:- dec_p_type(valvesLights_HandleOnClosed(poss,bool,bool)).
valvesLights_HandleOnClosed(
    Analogical_switch_p,
    Handle,
    Handle_
) :-
  Analogical_switch_p = closed &
  Handle = true &
  Handle_ = false.

:- dec_p_type(valvesLights_FromCloseToIntermediate2(poss,poss,bool)).
valvesLights_FromCloseToIntermediate2(
    Analogical_switch_p,
    Analogical_switch_p_,
    Intermediate2_
) :-
  Analogical_switch_p = closed &
  Intermediate2_ = true &
  Analogical_switch_p_ = open.

:- dec_p_type(
     valvesLights_HandleFromIntermediate2ToIntermediate1(
       bool,bool,bool,bool,bool)).
valvesLights_HandleFromIntermediate2ToIntermediate1(
    Intermediate2,
    Handle,
    Intermediate1_,
    Intermediate2_,
    Handle_
) :-
  Intermediate2 = true &
  Handle = true &
  Handle_ = false &
  Intermediate2_ = false &
  Intermediate1_ = true.

:- dec_p_type(valvesLights_open_Switch(bool,bool)).
valvesLights_open_Switch(
    Intermediate2,
    Intermediate2_
) :-
  Intermediate2 = true &
  Intermediate2_ = false.

:- dec_p_type(valvesLights_MakeGeneralValveActive(bool,bool)).
valvesLights_MakeGeneralValveActive(
    General_EV_p,
    General_EV_p_
) :-
  General_EV_p = false &
  General_EV_p_ = true.

:- dec_p_type(valvesLights_MakeGeneralValveNoActive(bool,bool)).
valvesLights_MakeGeneralValveNoActive(
    General_EV_p,
    General_EV_p_
) :-
  General_EV_p = true &
  General_EV_p_ = false.

:- dec_p_type(valvesLights_MakeOpenDoorValveActive(bool,bool,bool)).
valvesLights_MakeOpenDoorValveActive(
    Circuit_pressurized_p,
    Open_EV_p,
    Open_EV_p_
) :-
  Open_EV_p = false &
  Circuit_pressurized_p = true &
  Open_EV_p_ = true.
  
:- dec_p_type(valvesLights_MakeOpenDoorValveNoActive(bool,bool)).
valvesLights_MakeOpenDoorValveNoActive(
    Open_EV_p,
    Open_EV_p_
) :-
  Open_EV_p = true &
  Open_EV_p_ = false.
  
:- dec_p_type(valvesLights_MakeCloseDoorValveActive(bool,bool,bool)).
valvesLights_MakeCloseDoorValveActive(
    Circuit_pressurized_p,
    Close_EV_p,
    Close_EV_p_
) :-
  Close_EV_p = false &
  Circuit_pressurized_p = true &
  Close_EV_p_ = true.
  
:- dec_p_type(valvesLights_MakeCloseDoorValveNoActive(bool,bool)).
valvesLights_MakeCloseDoorValveNoActive(
    Close_EV_p,
    Close_EV_p_
) :-
  Close_EV_p = true &
  Close_EV_p_ = false.
  
:- dec_p_type(valvesLights_MakeExtendGearValveActive(bool,bool,bool)).
valvesLights_MakeExtendGearValveActive(
    Circuit_pressurized_p,
    Extend_EV_p,
    Extend_EV_p_
) :-
  Extend_EV_p = false &
  Circuit_pressurized_p = true &
  Extend_EV_p_ = true.
  
:- dec_p_type(valvesLights_MakeExtendGearValveNoActive(bool,bool)).
valvesLights_MakeExtendGearValveNoActive(
    Extend_EV_p,
    Extend_EV_p_
) :-
  Extend_EV_p = true &
  Extend_EV_p_ = false.
  
:- dec_p_type(valvesLights_MakeRetractGearValveActive(bool,bool,bool)).
valvesLights_MakeRetractGearValveActive(
    Circuit_pressurized_p,
    Retract_EV_p,
    Retract_EV_p_
) :-
  Retract_EV_p = false &
  Circuit_pressurized_p = true &
  Retract_EV_p_ = true.
  
:- dec_p_type(valvesLights_MakeRetractGearValveNoActive(bool,bool)).
valvesLights_MakeRetractGearValveNoActive(
    Retract_EV_p,
    Retract_EV_p_
) :-
  Retract_EV_p = true &
  Retract_EV_p_ = false.
  
:- dec_p_type(valvesLights_MakeGreenLightActive(bool,bool)).
valvesLights_MakeGreenLightActive(
    GreenLight_p,
    GreenLight_p_
) :-
  GreenLight_p = false &
  GreenLight_p_ = true.
  
:- dec_p_type(valvesLights_MakeGreenLightNoActive(bool,bool)).
valvesLights_MakeGreenLightNoActive(
    GreenLight_p,
    GreenLight_p_
) :-
  GreenLight_p = true &
  GreenLight_p_ = false.
  
:- dec_p_type(valvesLights_MakeOrangeLightActive(bool,bool)).
valvesLights_MakeOrangeLightActive(
    OrangeLight_p,
    OrangeLight_p_
) :-
  OrangeLight_p = false &
  OrangeLight_p_ = true.
  
:- dec_p_type(valvesLights_MakeOrangeLightNoActive(bool,bool)).
valvesLights_MakeOrangeLightNoActive(
    OrangeLight_p,
    OrangeLight_p_
) :-
  OrangeLight_p = true &
  OrangeLight_p_ = false.
  
:- dec_p_type(valvesLights_MakeRedLightActive(bool,bool)).
valvesLights_MakeRedLightActive(
    RedLight_p,
    RedLight_p_
) :-
  RedLight_p = false &
  RedLight_p_ = true.

