% Proof obligations of 

% MACHINE PropertyVerification

% Run check_propVerif

:- dec_p_type(propVerif_init_inv1).
propVerif_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv).

:- dec_p_type(propVerif_init_inv2).
propVerif_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv2(
    PositionsDG,
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Open_EV,
    Anomaly,
    Door_open_ind
  ).

:- dec_p_type(propVerif_init_inv3).
propVerif_init_inv3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv3(
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Open_EV,
    NextInputReadForDoorOpeningClosing
  ).

:- dec_p_type(propVerif_init_inv4).
propVerif_init_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv4(
    TimeStimulationOpenCloseEv,
    NextInputReadForDoorOpeningClosing
  ).

:- dec_p_type(propVerif_init_inv5).
propVerif_init_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv5(
    PositionsDG,
    NextInputReadForDoorOpeningClosing,
    Open_EV,
    Anomaly,
    Door_open_ind
  ).

:- dec_p_type(propVerif_init_inv6).
propVerif_init_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv6(
    PositionsDG,
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Close_EV,
    Anomaly,
    Door_closed_ind
  ).

:- dec_p_type(propVerif_init_inv7).
propVerif_init_inv7 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv7(
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Close_EV,
    NextInputReadForDoorOpeningClosing
  ).

:- dec_p_type(propVerif_init_inv8).
propVerif_init_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv8(
    PositionsDG,
    NextInputReadForDoorOpeningClosing,
    Close_EV,
    Anomaly,
    Door_closed_ind
  ).

:- dec_p_type(propVerif_init_inv9).
propVerif_init_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv9(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    Anomaly,
    Gear_retracted_ind
  ).

:- dec_p_type(propVerif_init_inv10).
propVerif_init_inv10 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv10(
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    NextInputReadForGearEndExtendingRetracting
  ).

:- dec_p_type(propVerif_init_inv11).
propVerif_init_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv11(
    PositionsDG,
    NextInputReadForGearEndExtendingRetracting,
    Retract_EV,
    Anomaly,
    Gear_retracted_ind
  ).

:- dec_p_type(propVerif_init_inv12).
propVerif_init_inv12 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv12(
    TimeStimulationExtendRetractEv,
    NextInputReadForGearEndExtendingRetracting
  ).

:- dec_p_type(propVerif_init_inv13).
propVerif_init_inv13 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv13(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    Anomaly,
    Gear_extended_ind
  ).

:- dec_p_type(propVerif_init_inv14).
propVerif_init_inv14 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv14(
    PositionsDG,
    NextInputReadForGearEndExtendingRetracting,
    Extend_EV,
    Anomaly,
    Gear_extended_ind
  ).

:- dec_p_type(propVerif_init_inv15).
propVerif_init_inv15 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv15(
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    NextInputReadForGearEndExtendingRetracting
  ).

:- dec_p_type(propVerif_init_inv16).
propVerif_init_inv16 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv16(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    Anomaly,
    Gear_extended_ind
  ).

:- dec_p_type(propVerif_init_inv17).
propVerif_init_inv17 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv17(
    PositionsDG,
    NextInputReadForGearStartExtendingRetracting,
    Retract_EV,
    Anomaly,
    Gear_extended_ind
  ).

:- dec_p_type(propVerif_init_inv18).
propVerif_init_inv18 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv18(
    TimeStimulationExtendRetractEv,
    NextInputReadForGearStartExtendingRetracting
  ).

:- dec_p_type(propVerif_init_inv19).
propVerif_init_inv19 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv19(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    Anomaly,
    Gear_retracted_ind
  ).

:- dec_p_type(propVerif_init_inv20).
propVerif_init_inv20 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv20(
    PositionsDG,
    CurrentTime,
    NextInputReadForGearStartExtendingRetracting,
    Extend_EV,
    Anomaly,
    Gear_retracted_ind
  ).

:- dec_p_type(propVerif_init_inv22).
propVerif_init_inv22 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv22(StayDown,End_cycle,Retract_EV).

:- dec_p_type(propVerif_init_inv23).
propVerif_init_inv23 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv23(StayDown,Handle_ind).

:- dec_p_type(propVerif_init_inv25).
propVerif_init_inv25 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv25(StayUp,End_cycle,Extend_EV).

:- dec_p_type(propVerif_init_inv26).
propVerif_init_inv26 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv26(StayUp,Handle_ind).

:- dec_p_type(propVerif_init_inv27).
propVerif_init_inv27 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv27(
    PositionsDG,
    Retract_EV,
    Extend_EV,
    End_cycle,
    Door_open_ind,
    Anomaly
  ).

:- dec_p_type(propVerif_init_inv28).
propVerif_init_inv28 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv28(
    PositionsDG,
    Close_EV,
    End_cycle,
    Gear_retracted_ind,
    Gear_extended_ind,
    Anomaly
  ).

:- dec_p_type(propVerif_init_inv29).
propVerif_init_inv29 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly,StayDown,StayUp],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv,
       TimeStayDown],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  propVerif_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s,
    TimeStimulationOpenCloseEv,
    TimeStimulationExtendRetractEv,
    StayDown,
    StayUp,
    TimeStayDown
  ) &
  propVerif_inv29(TimeStayDown).

:- dec_p_type(n_propVerif_inv1(int,int)).
n_propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv) :-
  neg(
    0 =< TimeStimulationOpenCloseEv &
    0 =< TimeStimulationExtendRetractEv
  ).

:- dec_p_type(n_propVerif_inv2(sp,int,int,bool,bool,rpb)).
n_propVerif_inv2(
    PositionsDG,
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Open_EV,
    Anomaly,
    Door_open_ind
) :-
  neg(
    CurrentTime > TimeStimulationOpenCloseEv + 70 &
    Open_EV = true
      implies
        (Anomaly = true
         or
         Door_open_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv3(int,int,bool,int)).
n_propVerif_inv3(
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Open_EV,
    NextInputReadForDoorOpeningClosing
) :-
  neg(
    CurrentTime > TimeStimulationOpenCloseEv + 70 &
    Open_EV = true
      implies
        NextInputReadForDoorOpeningClosing = 0
  ).

:- dec_p_type(n_propVerif_inv4(int,int)).
n_propVerif_inv4(
    TimeStimulationOpenCloseEv,
    NextInputReadForDoorOpeningClosing
) :-
  neg(
    NextInputReadForDoorOpeningClosing neq 0
      implies
        NextInputReadForDoorOpeningClosing is TimeStimulationOpenCloseEv + 70
  ).

:- dec_p_type(n_propVerif_inv5(sp,int,bool,bool,rpb)).
n_propVerif_inv5(
    PositionsDG,
    NextInputReadForDoorOpeningClosing,
    Open_EV,
    Anomaly,
    Door_open_ind
) :-
  neg(
    NextInputReadForDoorOpeningClosing = 0 &
    Open_EV = true
      implies
        (Anomaly = true
         or
         Door_open_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv6(sp,int,int,bool,bool,rpb)).
n_propVerif_inv6(
    PositionsDG,
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Close_EV,
    Anomaly,
    Door_closed_ind
) :-
  neg(
    CurrentTime > TimeStimulationOpenCloseEv + 70 &
    Close_EV = true
      implies
        (Anomaly = true
         or
         Door_closed_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv7(int,int,bool,int)).
n_propVerif_inv7(
    CurrentTime,
    TimeStimulationOpenCloseEv,
    Close_EV,
    NextInputReadForDoorOpeningClosing
) :-
  neg(
    CurrentTime > TimeStimulationOpenCloseEv + 70 &
    Close_EV = true
      implies
        NextInputReadForDoorOpeningClosing = 0
  ).

:- dec_p_type(n_propVerif_inv8(sp,int,bool,bool,rpb)).
n_propVerif_inv8(
    PositionsDG,
    NextInputReadForDoorOpeningClosing,
    Close_EV,
    Anomaly,
    Door_closed_ind
) :-
  neg(
    NextInputReadForDoorOpeningClosing = 0 &
    Close_EV = true
      implies
        (Anomaly = true
         or
         Door_closed_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv9(sp,int,int,bool,bool,rpb)).
n_propVerif_inv9(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    Anomaly,
    Gear_retracted_ind
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 100 &
    Retract_EV = true
      implies
        (Anomaly = true
         or
         Gear_retracted_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv10(int,int,bool,int)).
n_propVerif_inv10(
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    NextInputReadForGearEndExtendingRetracting
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 100 &
    Retract_EV = true
      implies
        NextInputReadForGearEndExtendingRetracting = 0
  ).

:- dec_p_type(n_propVerif_inv11(sp,int,bool,bool,rpb)).
n_propVerif_inv11(
    PositionsDG,
    NextInputReadForGearEndExtendingRetracting,
    Retract_EV,
    Anomaly,
    Gear_retracted_ind
) :-
  neg(
    NextInputReadForGearEndExtendingRetracting = 0 &
    Retract_EV = true
      implies
        (Anomaly = true
         or
         Gear_retracted_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv12(int,int)).
n_propVerif_inv12(
    TimeStimulationExtendRetractEv,
    NextInputReadForGearEndExtendingRetracting
) :-
  neg(
    NextInputReadForGearEndExtendingRetracting neq 0
      implies
        NextInputReadForGearEndExtendingRetracting is
          TimeStimulationExtendRetractEv + 100
  ).


:- dec_p_type(n_propVerif_inv13(sp,int,int,bool,bool,rpb)).
n_propVerif_inv13(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    Anomaly,
    Gear_extended_ind
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 100 &
    Extend_EV = true
      implies
        (Anomaly = true
         or
         Gear_extended_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv14(sp,int,bool,bool,rpb)).
n_propVerif_inv14(
    PositionsDG,
    NextInputReadForGearEndExtendingRetracting,
    Extend_EV,
    Anomaly,
    Gear_extended_ind
) :-
  neg(
    NextInputReadForGearEndExtendingRetracting = 0 &
    Extend_EV = true
      implies
        (Anomaly = true
         or
         Gear_extended_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv15(int,int,bool,int)).
n_propVerif_inv15(
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    NextInputReadForGearEndExtendingRetracting
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 100 &
    Extend_EV = true
      implies
        NextInputReadForGearEndExtendingRetracting = 0
  ).

:- dec_p_type(n_propVerif_inv16(sp,int,int,bool,bool,rpb)).
n_propVerif_inv16(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Retract_EV,
    Anomaly,
    Gear_extended_ind
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 70 &
    Retract_EV = true
      implies
        (Anomaly = true
         or
         Gear_extended_ind = cp(PositionsDG,{false})
        )
  ).

:- dec_p_type(n_propVerif_inv17(sp,int,bool,bool,rpb)).
n_propVerif_inv17(
    PositionsDG,
    NextInputReadForGearStartExtendingRetracting,
    Retract_EV,
    Anomaly,
    Gear_extended_ind
) :-
  neg(
    NextInputReadForGearStartExtendingRetracting = 0 &
    Retract_EV = true
      implies
        (Anomaly = true
         or
         Gear_extended_ind = cp(PositionsDG,{false})
        )
  ).

:- dec_p_type(n_propVerif_inv18(int,int)).
n_propVerif_inv18(
    TimeStimulationExtendRetractEv,
    NextInputReadForGearStartExtendingRetracting
) :-
  neg(
    NextInputReadForGearStartExtendingRetracting neq 0
      implies
        NextInputReadForGearStartExtendingRetracting is
          TimeStimulationExtendRetractEv + 70
  ).

:- dec_p_type(n_propVerif_inv19(sp,int,int,bool,bool,rpb)).
n_propVerif_inv19(
    PositionsDG,
    CurrentTime,
    TimeStimulationExtendRetractEv,
    Extend_EV,
    Anomaly,
    Gear_retracted_ind
) :-
  neg(
    CurrentTime > TimeStimulationExtendRetractEv + 70 &
    Extend_EV = true
      implies
        (Anomaly = true
         or
         Gear_retracted_ind = cp(PositionsDG,{false})
        )
  ).

:- dec_p_type(n_propVerif_inv20(sp,int,int,bool,bool,rpb)).
n_propVerif_inv20(
    PositionsDG,
    CurrentTime,
    NextInputReadForGearStartExtendingRetracting,
    Extend_EV,
    Anomaly,
    Gear_retracted_ind
) :-
  neg(
    NextInputReadForGearStartExtendingRetracting = 0 &
    Extend_EV = true
      implies
        (Anomaly = true
         or
         Gear_retracted_ind = cp(PositionsDG,{false})
        )
  ).

:- dec_p_type(n_propVerif_inv22(bool,bool,bool)).
n_propVerif_inv22(StayDown,End_cycle,Retract_EV) :-
  neg(
    StayDown = true &
    End_cycle = true
      implies
        Retract_EV = false
  ).

:- dec_p_type(n_propVerif_inv23(bool,posh)).
n_propVerif_inv23(StayDown,Handle_ind) :-
  neg(Handle_ind = up implies StayDown = false).

:- dec_p_type(n_propVerif_inv25(bool,bool,bool)).
n_propVerif_inv25(StayUp,End_cycle,Extend_EV) :-
  neg(
    StayUp = true &
    End_cycle = true
      implies
        Extend_EV = false
  ).

:- dec_p_type(n_propVerif_inv26(bool,posh)).
n_propVerif_inv26(StayUp,Handle_ind) :-
  neg(Handle_ind = down implies StayUp = false).

:- dec_p_type(n_propVerif_inv27(sp,bool,bool,bool,rpb,bool)).
n_propVerif_inv27(
    PositionsDG,
    Retract_EV,
    Extend_EV,
    End_cycle,
    Door_open_ind,
    Anomaly
) :-
  neg(
    (Retract_EV = true
     or
     Extend_EV = true
    ) &
    End_cycle = true
      implies
        (Anomaly = true
         or
         Door_open_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv28(sp,bool,bool,rpb,rpb,bool)).
n_propVerif_inv28(
    PositionsDG,
    Close_EV,
    End_cycle,
    Gear_retracted_ind,
    Gear_extended_ind,
    Anomaly
) :-
  neg(
    Close_EV = true &
    End_cycle = true
      implies
        (Anomaly = true
         or
         Gear_retracted_ind = cp(PositionsDG,{true})
         or
         Gear_extended_ind = cp(PositionsDG,{true})
        )
  ).

:- dec_p_type(n_propVerif_inv29(int)).
n_propVerif_inv29(TimeStayDown) :-
  neg(0 =< TimeStayDown).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv2).
propVerif_ReadHandleSwitchCircuit_inv2 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Open_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,TimeStimulationOpenCloseEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Door_open_ind,rpb) &
  neg(
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv2(
        PositionsDG,
        CurrentTime,
        TimeStimulationOpenCloseEv,
        Open_EV,
        Anomaly_,
        Door_open_ind
      )    

  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv5).
propVerif_ReadHandleSwitchCircuit_inv5 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Open_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Door_open_ind,rpb) &
  neg(
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv5(
        PositionsDG,
        NextInputReadForDoorOpeningClosing,
        Open_EV,
        Anomaly_,
        Door_open_ind
      )    
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv6).
propVerif_ReadHandleSwitchCircuit_inv6 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Close_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       TimeStimulationOpenCloseEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Door_closed_ind,rpb) &
  neg(
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv6(
        PositionsDG,
        CurrentTime,
        TimeStimulationOpenCloseEv,
        Close_EV,
        Anomaly_,
        Door_closed_ind
      )    
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv8).
propVerif_ReadHandleSwitchCircuit_inv8 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Close_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Door_closed_ind,rpb) &
  neg(
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv8(
        PositionsDG,
        NextInputReadForDoorOpeningClosing,
        Close_EV,
        Anomaly_,
        Door_closed_ind
      )    
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv9).
propVerif_ReadHandleSwitchCircuit_inv9 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Retract_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       TimeStimulationExtendRetractEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv9(
        PositionsDG,
        CurrentTime,
        TimeStimulationExtendRetractEv,
        Retract_EV,
        Anomaly_,
        Gear_retracted_ind
      )    
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv11).
propVerif_ReadHandleSwitchCircuit_inv11 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Retract_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv11(
        PositionsDG,
        NextInputReadForGearEndExtendingRetracting,
        Retract_EV,
        Anomaly_,
        Gear_retracted_ind
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv13).
propVerif_ReadHandleSwitchCircuit_inv13 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Extend_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       TimeStimulationExtendRetractEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv13(
        PositionsDG,
        CurrentTime,
        TimeStimulationExtendRetractEv,
        Extend_EV,
        Anomaly_,
        Gear_extended_ind
    )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv14).
propVerif_ReadHandleSwitchCircuit_inv14 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Extend_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv14(
        PositionsDG,
        NextInputReadForGearEndExtendingRetracting,
        Extend_EV,
        Anomaly_,
        Gear_extended_ind
    )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv16).
propVerif_ReadHandleSwitchCircuit_inv16 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Retract_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       TimeStimulationExtendRetractEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv16(
        PositionsDG,
        CurrentTime,
        TimeStimulationExtendRetractEv,
        Retract_EV,
        Anomaly_,
        Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv17).
propVerif_ReadHandleSwitchCircuit_inv17 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Retract_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv17(
        PositionsDG,
        NextInputReadForGearStartExtendingRetracting,
        Retract_EV,
        Anomaly_,
        Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv19).
propVerif_ReadHandleSwitchCircuit_inv19 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Extend_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       TimeStimulationExtendRetractEv,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv19(
        PositionsDG,
        CurrentTime,
        TimeStimulationExtendRetractEv,
        Extend_EV,
        Anomaly_,
        Gear_retracted_ind
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv20).
propVerif_ReadHandleSwitchCircuit_inv20 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Extend_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv20(
        PositionsDG,
        CurrentTime,
        NextInputReadForGearStartExtendingRetracting,
        Extend_EV,
        Anomaly_,
        Gear_retracted_ind
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv22).
propVerif_ReadHandleSwitchCircuit_inv22 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,
       End_cycle,Retract_EV],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv22(StayDown_,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv23).
propVerif_ReadHandleSwitchCircuit_inv23 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    propVerif_inv23(StayDown,Handle_ind) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv23(StayDown_,Handle_ind_)
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv25).
propVerif_ReadHandleSwitchCircuit_inv25 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,
       End_cycle,Extend_EV,StayUp],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv25(StayUp_,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv26).
propVerif_ReadHandleSwitchCircuit_inv26 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,StayUp],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    propVerif_inv26(StayUp,Handle_ind) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv26(StayUp_,Handle_ind_)
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv27).
propVerif_ReadHandleSwitchCircuit_inv27 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Retract_EV,
       Extend_EV,End_cycle],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec(Door_open_ind,rpb) &
  neg(
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv27(
        PositionsDG,
        Retract_EV,
        Extend_EV,
        End_cycle_,
        Door_open_ind,
        Anomaly_
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv28).
propVerif_ReadHandleSwitchCircuit_inv28 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_,Close_EV,End_cycle],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_],int) &
  dec(Analogical_switch_ind_,poss) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv28(
        PositionsDG,
        Close_EV,
        End_cycle_,
        Gear_retracted_ind,
        Gear_extended_ind,
        Anomaly_
      )
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_inv29).
propVerif_ReadHandleSwitchCircuit_inv29 :-
  dec(PositionsDG,sp) &
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_,StayDown,StayDown_,StayUp_],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_,TimeStayDown_,TimeStayDown],int) &
  dec(Analogical_switch_ind_,poss) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv29(TimeStayDown) &    
    propVerif_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      StayDown,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_,
      StayDown_,
      StayUp_,
      TimeStayDown_
    )
    implies
      propVerif_inv29(TimeStayDown_)
  ).

:- dec_p_type(propVerif_ReadHandleSwitchCircuit_act11).
propVerif_ReadHandleSwitchCircuit_act11 :-
  dec([B4,StayDown],bool) &
  dec([Handle_ind,Handle_sensor_value],posh) &
  dec(CurrentTime,int) &
  neg(
    bool(B4,StayDown = false & Handle_ind = down & Handle_sensor_value = down)
      implies
        ncomp({[B4,B4]},{[true,CurrentTime],[false,0]},{}) &
        pfun({[true,CurrentTime],[false,0]})
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv2).
propVerif_ReadGearsShock_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Door_open_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,Open_EV],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationOpenCloseEv],int) &
  neg(
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv2(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Open_EV,
          Anomaly_,
          Door_open_ind
        )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv5).
propVerif_ReadGearsShock_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Door_open_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,Open_EV],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       NextInputReadForDoorOpeningClosing],int) &
  neg(
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv5(
          PositionsDG,
          NextInputReadForDoorOpeningClosing,
          Open_EV,
          Anomaly_,
          Door_open_ind
        )    
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv6).
propVerif_ReadGearsShock_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Door_closed_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,Close_EV],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationOpenCloseEv],int) &
  neg(
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv6(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Close_EV,
          Anomaly_,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv8).
propVerif_ReadGearsShock_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Door_closed_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,Close_EV],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       NextInputReadForDoorOpeningClosing],int) &
  neg(
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv8(
          PositionsDG,
          NextInputReadForDoorOpeningClosing,
          Close_EV,
          Anomaly_,
          Door_closed_ind
        )    
  ).

% ReadGearsShock_R
:- dec_p_type(propVerif_ReadGearsShock_inv9).
propVerif_ReadGearsShock_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Gear_retracted_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv10(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &
    propVerif_ReadGearsShock_R(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv9(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly_,
          Gear_retracted_ind_
        )    
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv10).
propVerif_ReadGearsShock_inv10 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  neg(
    propVerif_inv10(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv10(
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

% ReadGearsShock_R
:- dec_p_type(propVerif_ReadGearsShock_inv11).
propVerif_ReadGearsShock_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Gear_retracted_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadGearsShock_R(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv11(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting,
          Retract_EV,
          Anomaly_,
          Gear_retracted_ind_
        )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv12).
propVerif_ReadGearsShock_inv12 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv12(
          TimeStimulationExtendRetractEv,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

% ReadGearsShock_E
:- dec_p_type(propVerif_ReadGearsShock_inv13).
propVerif_ReadGearsShock_inv13 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv15(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadGearsShock_E(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv13(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly_,
          Gear_extended_ind_
      )
  ).

% ReadGearsShock_E
:- dec_p_type(propVerif_ReadGearsShock_inv14).
propVerif_ReadGearsShock_inv14 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadGearsShock_E(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv14(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting,
          Extend_EV,
          Anomaly_,
          Gear_extended_ind_
      )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv15).
propVerif_ReadGearsShock_inv15 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv15(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv15(
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

% ReadGearsShock_E
:- dec_p_type(propVerif_ReadGearsShock_inv16).
propVerif_ReadGearsShock_inv16 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadGearsShock_E(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv16(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly_,
          Gear_extended_ind_
        )
  ).

% ReadGearsShock_E
:- dec_p_type(propVerif_ReadGearsShock_inv17).
propVerif_ReadGearsShock_inv17 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadGearsShock_E(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv17(
          PositionsDG,
          NextInputReadForGearStartExtendingRetracting,
          Retract_EV,
          Anomaly_,
          Gear_extended_ind_
        )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv18).
propVerif_ReadGearsShock_inv18 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv18(
          TimeStimulationExtendRetractEv,
          NextInputReadForGearStartExtendingRetracting_
        )
  ).

% ReadGearsShock_R
:- dec_p_type(propVerif_ReadGearsShock_inv19).
propVerif_ReadGearsShock_inv19 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Gear_retracted_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadGearsShock_R(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv19(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly_,
          Gear_retracted_ind_
        )
  ).

% ReadGearsShock_R
:- dec_p_type(propVerif_ReadGearsShock_inv20).
propVerif_ReadGearsShock_inv20 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Gear_retracted_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadGearsShock_R(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv20(
          PositionsDG,
          CurrentTime,
          NextInputReadForGearStartExtendingRetracting_,
          Extend_EV,
          Anomaly_,
          Gear_retracted_ind_
        )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv22).
propVerif_ReadGearsShock_inv22 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,StayDown,End_cycle],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv25).
propVerif_ReadGearsShock_inv25 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,StayUp,End_cycle],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv27).
propVerif_ReadGearsShock_inv27 :-
  dec(PositionsDG,sp) &
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_,Door_open_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,End_cycle],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV,
          End_cycle_,
          Door_open_ind,
          Anomaly_
        )
  ).

:- dec_p_type(propVerif_ReadGearsShock_inv28).
propVerif_ReadGearsShock_inv28 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,Gear_shock_absorber_p,
       Gear_extended_ind_,Gear_retracted_ind_,Gear_shock_absorber_ind_,
       Gear_retracted_ind,Gear_extended_ind],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_,End_cycle,Close_EV],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind_,
          Gear_extended_ind_,
          Anomaly_
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv2).
propVerif_ReadDoors_inv2 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Door_open_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime)  &
    propVerif_inv3(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv2(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Open_EV,
          Anomaly_,
          Door_open_ind_
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv3).
propVerif_ReadDoors_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv],int) &
  neg(
    propVerif_inv3(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv3(
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Open_EV,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv4).
propVerif_ReadDoors_inv4 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv],int) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv4(
          TimeStimulationOpenCloseEv,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv5).
propVerif_ReadDoors_inv5 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Door_open_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime)  &
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv5(
          PositionsDG,
          NextInputReadForDoorOpeningClosing,
          Open_EV,
          Anomaly_,
          Door_open_ind_
        )    
  ).

:- dec_p_type(propVerif_ReadDoors_inv6).
propVerif_ReadDoors_inv6 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Door_closed_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime)  &
    propVerif_inv7(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv6(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Close_EV,
          Anomaly_,
          Door_closed_ind_
        )    
  ).

:- dec_p_type(propVerif_ReadDoors_inv7).
propVerif_ReadDoors_inv7 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv],int) &
  neg(
    propVerif_inv7(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      NextInputReadForDoorOpeningClosing
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv7(
          CurrentTime,
          TimeStimulationOpenCloseEv,
          Close_EV,
          NextInputReadForDoorOpeningClosing_
       )
  ).

:- dec_p_type(propVerif_ReadDoors_inv8).
propVerif_ReadDoors_inv8 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Door_closed_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime)  &
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv8(
          PositionsDG,
          NextInputReadForDoorOpeningClosing,
          Close_EV,
          Anomaly_,
          Door_closed_ind_
        )    
  ).

:- dec_p_type(propVerif_ReadDoors_inv9).
propVerif_ReadDoors_inv9 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_retracted_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Retract_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationExtendRetractEv],int) &
  neg(
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv9(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly_,
          Gear_retracted_ind
        )    
  ).

:- dec_p_type(propVerif_ReadDoors_inv11).
propVerif_ReadDoors_inv11 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_retracted_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Retract_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,
       NextInputReadForGearEndExtendingRetracting],int) &
  neg(
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv11(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting,
          Retract_EV,
          Anomaly_,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv13).
propVerif_ReadDoors_inv13 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_extended_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationExtendRetractEv],int) &
  neg(
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv13(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly_,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_ReadDoors_inv14).
propVerif_ReadDoors_inv14 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_extended_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,
       NextInputReadForGearEndExtendingRetracting],int) &
  neg(
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv14(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting,
          Extend_EV,
          Anomaly_,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_ReadDoors_inv16).
propVerif_ReadDoors_inv16 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_extended_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Retract_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationExtendRetractEv],int) &
  neg(
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv16(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly_,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv17).
propVerif_ReadDoors_inv17 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_extended_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Retract_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,
       NextInputReadForGearStartExtendingRetracting],int) &
  neg(
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv17(
          PositionsDG,
          NextInputReadForGearStartExtendingRetracting,
          Retract_EV,
          Anomaly_,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv19).
propVerif_ReadDoors_inv19 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_retracted_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,TimeStimulationExtendRetractEv],int) &
  neg(
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv19(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly_,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv20).
propVerif_ReadDoors_inv20 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_retracted_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_,
       NextInputReadForGearStartExtendingRetracting],int) &
  neg(
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv20(
          PositionsDG,
          CurrentTime,
          NextInputReadForGearStartExtendingRetracting,
          Extend_EV,
          Anomaly_,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv22).
propVerif_ReadDoors_inv22 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV,StayDown,
       End_cycle,Retract_EV],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_ReadDoors_inv25).
propVerif_ReadDoors_inv25 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Extend_EV,StayUp,
       End_cycle],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_ReadDoors_inv27).
propVerif_ReadDoors_inv27 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Door_open_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,Retract_EV,Extend_EV,
       End_cycle],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV,
          End_cycle_,
          Door_open_ind_,
          Anomaly_
        )
  ).

:- dec_p_type(propVerif_ReadDoors_inv28).
propVerif_ReadDoors_inv28 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_,
       Gear_retracted_ind,Gear_extended_ind],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_,End_cycle],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly_
        )
  ).

:- dec_p_type(propVerif_OutputGEV_inv22).
propVerif_OutputGEV_inv22 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_,
       NextInputReadForPressurizedcircuit,
       NextInputReadForPressurizedcircuit_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_,End_cycle,
       Retract_EV,StayDown,Extend_EV],bool) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_,
      NextInputReadForPressurizedcircuit_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_OutputGEV_inv25).
propVerif_OutputGEV_inv25 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_,
       NextInputReadForPressurizedcircuit,
       NextInputReadForPressurizedcircuit_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_,End_cycle,
       Extend_EV,StayUp,Retract_EV],bool) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_,
      NextInputReadForPressurizedcircuit_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_OutputGEV_inv27).
propVerif_OutputGEV_inv27 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind,Door_open_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_,
       NextInputReadForPressurizedcircuit,
       NextInputReadForPressurizedcircuit_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_,End_cycle,
       Retract_EV,Extend_EV,Anomaly],bool) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_,
      NextInputReadForPressurizedcircuit_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV,
          End_cycle_,
          Door_open_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputGEV_inv28).
propVerif_OutputGEV_inv28 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_,
       NextInputReadForPressurizedcircuit,
       NextInputReadForPressurizedcircuit_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_,End_cycle,
       Anomaly,Extend_EV,Retract_EV],bool) &
  neg(
    sensors_inv18(Open_EV,Close_EV,Extend_EV,Retract_EV,General_EV) &
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_,
      NextInputReadForPressurizedcircuit_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv1).
propVerif_OutputOpenEV_inv1 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv) &
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv1(
          TimeStimulationOpenCloseEv_,TimeStimulationExtendRetractEv
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv2).
propVerif_OutputOpenEV_inv2 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv2(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Open_EV_,
          Anomaly,
          Door_open_ind
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv3).
propVerif_OutputOpenEV_inv3 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    propVerif_inv3(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv3(
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Open_EV_,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv4).
propVerif_OutputOpenEV_inv4 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv4(
          TimeStimulationOpenCloseEv_,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv5).
propVerif_OutputOpenEV_inv5 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv5(
          PositionsDG,
          NextInputReadForDoorOpeningClosing_,
          Open_EV_,
          Anomaly,
          Door_open_ind
        )    
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv6).
propVerif_OutputOpenEV_inv6 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv6(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Close_EV,
          Anomaly,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv7).
propVerif_OutputOpenEV_inv7 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    propVerif_inv7(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      NextInputReadForDoorOpeningClosing
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv7(
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Close_EV,
          NextInputReadForDoorOpeningClosing_
       )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv8).
propVerif_OutputOpenEV_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv8(
          PositionsDG,
          NextInputReadForDoorOpeningClosing_,
          Close_EV,
          Anomaly,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv22).
propVerif_OutputOpenEV_inv22 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,End_cycle,StayDown],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv25).
propVerif_OutputOpenEV_inv25 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,End_cycle,StayUp],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv27).
propVerif_OutputOpenEV_inv27 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly,End_cycle],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV,
          End_cycle_,
          Door_open_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputOpenEV_inv28).
propVerif_OutputOpenEV_inv28 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_,Anomaly,End_cycle],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV)  &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv1).
propVerif_OutputCloseEv_inv1 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv) &
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv1(
          TimeStimulationOpenCloseEv_,TimeStimulationExtendRetractEv
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv2).
propVerif_OutputCloseEv_inv2 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv2(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Open_EV,
          Anomaly,
          Door_open_ind
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv3).
propVerif_OutputCloseEv_inv3 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    propVerif_inv3(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv3(
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Open_EV,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv4).
propVerif_OutputCloseEv_inv4 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv4(
          TimeStimulationOpenCloseEv_,
          NextInputReadForDoorOpeningClosing_
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv5).
propVerif_OutputCloseEv_inv5 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv5(
          PositionsDG,
          NextInputReadForDoorOpeningClosing_,
          Open_EV,
          Anomaly,
          Door_open_ind
        )    
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv6).
propVerif_OutputCloseEv_inv6 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv6(
          PositionsDG,
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Close_EV_,
          Anomaly,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv7).
propVerif_OutputCloseEv_inv7 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_,
      TimeStimulationOpenCloseEv],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    propVerif_inv7(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      NextInputReadForDoorOpeningClosing
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv7(
          CurrentTime,
          TimeStimulationOpenCloseEv_,
          Close_EV_,
          NextInputReadForDoorOpeningClosing_
       )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv8).
propVerif_OutputCloseEv_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv8(
          PositionsDG,
          NextInputReadForDoorOpeningClosing_,
          Close_EV_,
          Anomaly,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv22).
propVerif_OutputCloseEv_inv22 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,End_cycle,StayDown],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv25).
propVerif_OutputCloseEv_inv25 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,End_cycle,StayUp],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv27).
propVerif_OutputCloseEv_inv27 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,End_cycle,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV,
          End_cycle_,
          Door_open_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputCloseEv_inv28).
propVerif_OutputCloseEv_inv28 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,TimeStimulationOpenCloseEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_,End_cycle,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_,
      TimeStimulationOpenCloseEv_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV_,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv1).
propVerif_OutputExtendEV_inv1 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv) &
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv1(
          TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv_
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv9).
propVerif_OutputExtendEV_inv9 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_retracted_ind],rpb) &
  neg(
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv9(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV,
          Anomaly,
          Gear_retracted_ind
        )    
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv10).
propVerif_OutputExtendEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv10(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv10(
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv11).
propVerif_OutputExtendEV_inv11 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_retracted_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv11(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting_,
          Retract_EV,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv12).
propVerif_OutputExtendEV_inv12 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv12(
          TimeStimulationExtendRetractEv_,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv13).
propVerif_OutputExtendEV_inv13 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv13(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV_,
          Anomaly,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv14).
propVerif_OutputExtendEV_inv14 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv14(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting_,
          Extend_EV_,
          Anomaly,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv15).
propVerif_OutputExtendEV_inv15 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv15(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv15(
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV_,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv16).
propVerif_OutputExtendEV_inv16 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_exended_ind],rpb) &
  neg(
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv16(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV,
          Anomaly,
          Gear_exended_ind
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv17).
propVerif_OutputExtendEV_inv17 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_exended_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv17(
          PositionsDG,
          NextInputReadForGearStartExtendingRetracting_,
          Retract_EV,
          Anomaly,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv18).
propVerif_OutputExtendEV_inv18 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv18(
          TimeStimulationExtendRetractEv_,
          NextInputReadForGearStartExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv19).
propVerif_OutputExtendEV_inv19 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_retracted_ind],rpb) &
  neg(
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv19(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV_,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv20).
propVerif_OutputExtendEV_inv20 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_retracted_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv20(
          PositionsDG,
          CurrentTime,
          NextInputReadForGearStartExtendingRetracting_,
          Extend_EV_,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv22).
propVerif_OutputExtendEV_inv22 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,End_cycle,
       StayDown],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV)
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv25).
propVerif_OutputExtendEV_inv25 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,End_cycle,
       StayUp],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    propVerif_inv26(StayUp,Handle_ind) &
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV_)
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv27).
propVerif_OutputExtendEV_inv27 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,End_cycle,
       Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV,
          Extend_EV_,
          End_cycle_,
          Door_open_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputExtendEV_inv28).
propVerif_OutputExtendEV_inv28 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_,End_cycle,
       Anomaly,Close_EV],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind,Gear_retracted_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv1).
propVerif_OutputRetractEV_inv1 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv1(TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv) &
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv1(
          TimeStimulationOpenCloseEv,TimeStimulationExtendRetractEv_
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv9).
propVerif_OutputRetractEV_inv9 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv9(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV_,
          Anomaly,
          Gear_retracted_ind
        )    
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv10).
propVerif_OutputRetractEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv10(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv10(
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV_,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv11).
propVerif_OutputRetractEV_inv11 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv11(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting_,
          Retract_EV_,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv12).
propVerif_OutputRetractEV_inv12 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv12(
          TimeStimulationExtendRetractEv_,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv13).
propVerif_OutputRetractEV_inv13 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind,
       Gear_extended_ind],rpb) &
  neg(
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv13(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV,
          Anomaly,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv14).
propVerif_OutputRetractEV_inv14 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind,
       Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv14(
          PositionsDG,
          NextInputReadForGearEndExtendingRetracting_,
          Extend_EV,
          Anomaly,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv15).
propVerif_OutputRetractEV_inv15 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv,
       NextInputReadForGearEndExtendingRetracting],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv15(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv15(
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV,
          NextInputReadForGearEndExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv16).
propVerif_OutputRetractEV_inv16 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind,
       Gear_extended_ind],rpb) &
  neg(
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv16(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Retract_EV_,
          Anomaly,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv17).
propVerif_OutputRetractEV_inv17 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind,
       Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv14(AllowedStartRetEv) &
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv17(
          PositionsDG,
          NextInputReadForGearStartExtendingRetracting_,
          Retract_EV_,
          Anomaly,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv18).
propVerif_OutputRetractEV_inv18 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv18(
          TimeStimulationExtendRetractEv_,
          NextInputReadForGearStartExtendingRetracting_
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv19).
propVerif_OutputRetractEV_inv19 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv19(
          PositionsDG,
          CurrentTime,
          TimeStimulationExtendRetractEv_,
          Extend_EV,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv20).
propVerif_OutputRetractEV_inv20 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_,
       TimeStimulationExtendRetractEv],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv20(
          PositionsDG,
          CurrentTime,
          NextInputReadForGearStartExtendingRetracting_,
          Extend_EV,
          Anomaly,
          Gear_retracted_ind
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv22).
propVerif_OutputRetractEV_inv22 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,StayDown,
       End_cycle],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    propVerif_inv23(StayDown,Handle_ind) &
    propVerif_inv22(StayDown,End_cycle,Retract_EV) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv22(StayDown,End_cycle_,Retract_EV_)
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv25).
propVerif_OutputRetractEV_inv25 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,StayUp,
       End_cycle],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    propVerif_inv25(StayUp,End_cycle,Extend_EV) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv25(StayUp,End_cycle_,Extend_EV)
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv27).
propVerif_OutputRetractEV_inv27 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,End_cycle,
       Anomaly],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    sensors_inv22(Extend_EV,Retract_EV) &
    propVerif_inv27(
      PositionsDG,
      Retract_EV,
      Extend_EV,
      End_cycle,
      Door_open_ind,
      Anomaly
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv27(
          PositionsDG,
          Retract_EV_,
          Extend_EV,
          End_cycle_,
          Door_open_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_OutputRetractEV_inv28).
propVerif_OutputRetractEV_inv28 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,TimeStimulationExtendRetractEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_,End_cycle,
       Anomaly,Close_EV],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind,
       Gear_extended_ind],rpb) &
  neg(
    sensors_inv19(Open_EV,Close_EV) &
    sensors_inv20(Open_EV,Extend_EV,Retract_EV) &
    propVerif_inv28(
      PositionsDG,
      Close_EV,
      End_cycle,
      Gear_retracted_ind,
      Gear_extended_ind,
      Anomaly
    ) &    
    propVerif_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_,
      TimeStimulationExtendRetractEv_
    )
      implies
        propVerif_inv28(
          PositionsDG,
          Close_EV,
          End_cycle_,
          Gear_retracted_ind,
          Gear_extended_ind,
          Anomaly
        )
  ).

:- dec_p_type(propVerif_passingTime_inv2).
propVerif_passingTime_inv2 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationOpenCloseEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Open_EV,Anomaly],bool) &
  dec(Door_open_ind,rpb) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv5(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_inv2(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      Anomaly,
      Door_open_ind
    ) &
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv2(
          PositionsDG,
          CurrentTime_,
          TimeStimulationOpenCloseEv,
          Open_EV,
          Anomaly,
          Door_open_ind
        )
  ).

:- dec_p_type(propVerif_passingTime_inv3).
propVerif_passingTime_inv3 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationOpenCloseEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Open_EV],bool) &
  dec(Door_open_ind,rpb) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv3(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Open_EV,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv3(
          CurrentTime_,
          TimeStimulationOpenCloseEv,
          Open_EV,
          NextInputReadForDoorOpeningClosing
        )
  ).

:- dec_p_type(propVerif_passingTime_inv6).
propVerif_passingTime_inv6 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationOpenCloseEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Close_EV,Anomaly],bool) &
  dec(Door_closed_ind,rpb) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv8(
      PositionsDG,
      NextInputReadForDoorOpeningClosing,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &
    propVerif_inv6(
      PositionsDG,
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      Anomaly,
      Door_closed_ind
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv6(
          PositionsDG,
          CurrentTime_,
          TimeStimulationOpenCloseEv,
          Close_EV,
          Anomaly,
          Door_closed_ind
        )    
  ).

:- dec_p_type(propVerif_passingTime_inv7).
propVerif_passingTime_inv7 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationOpenCloseEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec(Close_EV,bool) &
  neg(
    propVerif_inv4(
      TimeStimulationOpenCloseEv,
      NextInputReadForDoorOpeningClosing
    ) &
    propVerif_inv7(
      CurrentTime,
      TimeStimulationOpenCloseEv,
      Close_EV,
      NextInputReadForDoorOpeningClosing
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv7(
          CurrentTime_,
          TimeStimulationOpenCloseEv,
          Close_EV,
          NextInputReadForDoorOpeningClosing
       )
  ).

:- dec_p_type(propVerif_passingTime_inv9).
propVerif_passingTime_inv9 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Retract_EV,Anomaly],bool) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv11(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv9(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv9(
          PositionsDG,
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly,
          Gear_retracted_ind
        )    
  ).

:- dec_p_type(propVerif_passingTime_inv10).
propVerif_passingTime_inv10 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec(Retract_EV,bool) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv10(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv10(
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          NextInputReadForGearEndExtendingRetracting
        )
  ).

:- dec_p_type(propVerif_passingTime_inv13).
propVerif_passingTime_inv13 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Extend_EV,Anomaly],bool) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv14(
      PositionsDG,
      NextInputReadForGearEndExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &
    propVerif_inv13(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv13(
          PositionsDG,
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly,
          Gear_extended_ind
      )
  ).

:- dec_p_type(propVerif_passingTime_inv15).
propVerif_passingTime_inv15 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(Extend_EV,bool) &
  neg(
    propVerif_inv12(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearEndExtendingRetracting
    ) &
    propVerif_inv15(
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      NextInputReadForGearEndExtendingRetracting
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv15(
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          NextInputReadForGearEndExtendingRetracting
        )
  ).

:- dec_p_type(propVerif_passingTime_inv16).
propVerif_passingTime_inv16 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Retract_EV,Anomaly],bool) &
  dec(Gear_extended_ind,rpb) &
  neg(
    propVerif_inv17(
      PositionsDG,
      NextInputReadForGearStartExtendingRetracting,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &
    propVerif_inv16(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Retract_EV,
      Anomaly,
      Gear_extended_ind
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv16(
          PositionsDG,
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Retract_EV,
          Anomaly,
          Gear_extended_ind
        )
  ).

:- dec_p_type(propVerif_passingTime_inv19).
propVerif_passingTime_inv19 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForPressurizedcircuit,NextInputReadForDoorOpeningClosing,
       NextInputReadForClosedSwitch,NextInputReadForOpenSwitch,
       TimeStimulationExtendRetractEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  dec(PositionsDG,sp) &
  dec([Extend_EV,Anomaly],bool) &
  dec(Gear_retracted_ind,rpb) &
  neg(
    propVerif_inv18(
      TimeStimulationExtendRetractEv,
      NextInputReadForGearStartExtendingRetracting
    ) &
    propVerif_inv20(
      PositionsDG,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &
    propVerif_inv19(
      PositionsDG,
      CurrentTime,
      TimeStimulationExtendRetractEv,
      Extend_EV,
      Anomaly,
      Gear_retracted_ind
    ) &    
    propVerif_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      NextInputReadForPressurizedcircuit,
      NextInputReadForDoorOpeningClosing,
      NextInputReadForClosedSwitch,
      NextInputReadForOpenSwitch,
      CurrentTime_    
    )
      implies
        propVerif_inv19(
          PositionsDG,
          CurrentTime_,
          TimeStimulationExtendRetractEv,
          Extend_EV,
          Anomaly,
          Gear_retracted_ind
        )
  ).



%%% consult('lgs.pl') & lPropertyVerificationPO.
:- dec_p_type(check_propVerif).
check_propVerif :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking propVerif_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv3 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv4 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv5 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv6 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv7 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv8 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv9 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv10 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv11 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv12 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv13 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv14 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv15...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv15 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv16 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv17 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv18 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv19 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv20 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv22 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv23...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv23 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv25 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv26...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv26 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv27 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv28 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_init_inv29...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     propVerif_init_inv29 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv17) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv23...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv23) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv26...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv26) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_inv29...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_inv29) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadHandleSwitchCircuit_act11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadHandleSwitchCircuit_act11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv15...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv15) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv17) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadGearsShock_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadGearsShock_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv17) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_ReadDoors_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_ReadDoors_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputGEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputGEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputGEV_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputGEV_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputGEV_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputGEV_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputGEV_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputGEV_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputOpenEV_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputOpenEV_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputCloseEv_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputCloseEv_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv15...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv15) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv17) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputExtendEV_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputExtendEV_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv15...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv15) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv17...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv17) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv18...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv18) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv20...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv20) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv22...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv22) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv25...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv25) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv27...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv27) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_OutputRetractEV_inv28...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_OutputRetractEV_inv28) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv15...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv15) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv16...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv16) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking propVerif_passingTime_inv19...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(propVerif_passingTime_inv19) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 158) discharged in ') &
     write(T) & write(' seconds') & nl
  ).







